﻿import QtQuick 2.0

Rectangle {
    id:mainPage
    width: isDetailsUI?450:406; height: isDetailsUI?290:211
    property bool isDetailsUI: true
    signal signalClickCurrentImg(string imgName,string strPath);
    color: "red"
    Component{
        id:imgc
        Rectangle {
            id:item
            width: grid.cellWidth ;
            height: grid.cellHeight
            border.width: 1
            border.color: "#FFFFFF"
            radius: 0
            smooth: true
            color: "#FFFFFF"

            AnimatedImage  {
                id: name
                width: grid.cellWidth - 4
                height: grid.cellHeight - 4
                anchors.centerIn: parent
                source: path
                playing: false

                MouseArea{
                    id:ma
                    anchors.fill: parent
                    hoverEnabled: true
                    onExited: {

                        item.border.color = "#FFFFFF"
                        mainHideCallBoard();
                        name.playing = false
                    }
                    onEntered: {
                        name.playing = true
                        item.border.color = "#cccccc"
                        var obj = mapToItem(null,x,y);
                        var posx = obj.x ;
                        var posy = obj.y ;
                        mainShowCallBoard(title,posx,posy);
                    }
                    onClicked: {
                        console.log(path+"\n"+title);
                        signalClickCurrentImg(title,path);
                    }
                }
            }
        }
    }
    GridView {
        id:grid
        width: 30*15; height: 30*9
        cellWidth:30; cellHeight:30
//        anchors.left: parent.left
//        anchors.leftMargin: isDetailsUI?5:20
//        anchors.right: parent.right
//        anchors.rightMargin: isDetailsUI?5:10
//        anchors.top: parent.top
//        anchors.topMargin: isDetailsUI?5:20
        model: chatFaceModel
        delegate: imgc
        focus: true
        boundsBehavior:Flickable.StopAtBounds
    }
    ChatITipsImg{
        id:imgBoard
        visible: false
        z:20
    }

    ChatImageGif {
        id: chatFaceModel
    }
    function mainShowCallBoard(number,posx,posy)
    {
        var objxy = mapFromItem(null,posx,posy);
        var nx = objxy.x;
        var ny = objxy.y;
        if(nx<0)
        {
            nx = 0;
        }
        if(nx + imgBoard.width> mainPage.width)
        {
            nx = mainPage.width - imgBoard.width;
        }
        imgBoard.x = nx+6;
        imgBoard.y = ny+30;
        imgBoard.setCurrentTxt(number);
        imgBoard.visible = true;
    }

    function mainHideCallBoard()
    {
        imgBoard.visible = false;
    }

    function replaceImgName(parm1, imgSource)
    {
        for(var i = 0; i < chatFaceModel.count; ++i)
        {
            if(chatFaceModel.get(i).path === imgSource)
            {
                console.log("头像控件图片地址:"+chatFaceModel.get(i).path);
                parm1.push(chatFaceModel.get(i).title)
            }
        }
    }

    Component.onCompleted: {

    }
}

