import QtQuick 2.0

Item {

    width: parent.width
    height: 40

    property int chatFlag: 0 //0:myself 1:other

    property string chatName: ""
    property string chatTime: ""
    property int chatType: 0
    property string chatContentText: ""

    Text {
        id: userName
        anchors.top: parent.top
        anchors.topMargin: 2
        anchors.left: parent.left
        anchors.leftMargin: 10

        font.pixelSize: 12
        font.family: "微软雅黑"
        color: if(chatFlag === 0)
               {
                   return "#69c9EE"
               }
               else
               {
                   return "#999A9A"
               }

        text: chatName
    }

    Text {
        id: userTime
        anchors.top: parent.top
        anchors.topMargin: 2
        anchors.left: userName.right
        anchors.leftMargin: 8
        font.pixelSize: 12
        font.family: "微软雅黑"
        color: if(chatFlag === 0)
               {
                   return "#69c9EE"
               }
               else
               {
                   return "#999A9A"
               }
        text: chatTime
    }

    Text {
        id: contentText
        anchors.top: userName.bottom
        anchors.topMargin: 5
        anchors.left: parent.left
        anchors.leftMargin: 10
        font.pixelSize: 12
        font.family: "微软雅黑"
        visible:
        {
            if(chatType == 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        color: "black"
        text: chatContentText
    }


}
