﻿import QtQuick 2.0
import QtQuick.Window 2.2
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4

Window {
    id: tooltip
    color: "#d1d1d1"
    flags: Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint
    property int currentIndex: 0
    signal itemClicked(string jid,string chatname)
    signal deleteAllItem()
    signal deleteOneItem(string jid)
    MouseArea{
        anchors.fill: parent
        hoverEnabled: true
/*
        onEntered: {
            tooltip.visible = true
        }

        onExited: {
            tooltip.visible = false
        }*/
    }

    ListModel{
        id:chatModel
    }
    Rectangle{
        id:_zdy
        width: parent.width
        anchors.top: parent.top
        anchors.topMargin: 1.4
        anchors.left: parent.left
        anchors.leftMargin: 1.4
        anchors.right: parent.right
        anchors.rightMargin: 1.4

    ScrollView
    {
        id: scrollview
        width: parent.width
        height: 1000

        //anchors.top: parent.top
        //anchors.bottom: bottomrect.top
        style: ScrollViewStyle {
            handle: Item{
                implicitWidth: 7
                Rectangle {
                    color: "#B0B0B0"
                    anchors.fill: parent
                    visible: true
                    radius: 5
                }
            }
            decrementControl:Image {
                width:7
                height: 7
                source: "qrc:/resource/images/im/uparrow.png"
            }
            incrementControl:Image {
                width: 7
                height: 7
                source: "qrc:/resource/images/im/downarrow.png"
            }
            scrollBarBackground: Rectangle {
                implicitWidth: 7
                color: "#d1d1d1"

            }
        }
        ListView{
            id:chatview
            width: 220
            height:parent.height
            anchors.fill: parent

            spacing:0
            orientation: ListView.Vertical
            //clip:true
            model:chatModel
            delegate: ChatToolTipItem {
                chatJid: chatJid1
                chatHead:chatHead1
                chatName: chatName1
                chatInfoNum: chatInfoNum1
                onItemClicked: {
                    currentIndex = index
                    tooltip.itemClicked(jid,chatName)
                    console.log("点击闪烁条目序号:", currentIndex)
                }

                onItemEnter: {

                    //console.log("进入闪烁条目序号:", currentIndex)
                    if(isShow)
                    {
                        //tooltip.itemClicked(jid)
                        tooltip.visible = true
                    }
                }
            }
        }
    }

}

    Rectangle {
        id: bottomrect
        width: 220
        height: 35
        anchors.bottom: parent.bottom
        color:"#FFFFFF"
            anchors.topMargin: 2
           border.color: "#d1d1d1"


        Text {
            id: cancletext
            width: 60
            height: 35
            anchors.top: parent.top
            anchors.topMargin: 0
            anchors.right: parent.right
            anchors.rightMargin: 5
            font.family: "微软雅黑"
            color: "#2c95fd"
            font.pixelSize: 12
            verticalAlignment: Qt.AlignVCenter
            text: qsTr("取消闪烁")
            MouseArea
            {
                anchors.fill: cancletext

                onClicked: {
                    //tooltip.visible = true
                    console.log("点击了取消闪烁")
                    deleteAllItem()

                }
            }
        }
    }
//检查jid是否在显示界面中
    function modifyData(jid, chatNum)
    {
        for(var i = 0; i < chatModel.count; ++i)
        {
            var obj = chatModel.get(i)
          //  console.log("查找闪烁条目中的chatid", obj.chatJid1, jid)

            if(obj.chatJid1 == jid)
            {
                console.log("查找到闪烁条目中的chatid", obj.chatJid1, jid)
               // console.log("modifyData", obj.chatJid1, chatNum)
                chatModel.setProperty(i, "chatInfoNum1", chatNum);
                return;
            }
        }
    }

    function appendData(jid,username, sex, chatNum)
    {
        var chatHeadIco;


        if(sex === 1)
        {
            chatHeadIco = "qrc:/resource/images/im/chatwoman (2).png"  //女
        }
        else if(sex === 3)
        {
             chatHeadIco = "qrc:/resource/images/im/45.png"   //群
        }
        else if(sex === 4)
        {
             chatHeadIco = "qrc:/resource/images/im/email.png" //邮件
        }
        else if(sex === 5)
        {
             chatHeadIco = "qrc:/resource/images/main/maintop/noticetray.png"   //事务提醒
        }
        else
        {
            chatHeadIco = "qrc:/resource/images/im/chatman (2).png"  //男
        }



        for(var i = 0; i < chatModel.count; ++i)
        {
            var obj = chatModel.get(i)

            if(obj.chatJid1 === jid)
            {
                console.log("设置闪烁条目上的数值", chatNum)
                chatModel.setProperty(i, "chatInfoNum1", chatNum);
                return;
            }
        }

        console.log("本次闪烁条目的总条数:",chatModel.count+1);

        chatModel.insert(0,{"chatJid1": jid, "chatName1": username,"chatHead1": chatHeadIco,  "chatInfoNum1": chatNum})//
        tooltip.height = 35 + tooltip.getModelCount()*50
        tooltip.y = screenheight - chattooltip.height

       // chatModel.insert(0,{"chatJid1": jid, "chatName1": username,"chatHead1": chatHeadIco,  "chatInfoNum1": chatNum+1})//

    }

    function getModelCount()
    {
        return chatModel.count;
    }

    function removeAtIndex()
    {
        console.log("删除对应闪烁条目:", currentIndex)
        //if(currentIndex!=0)
        chatModel.remove(currentIndex,1)
    }
    function removeAtIndexasname(name)
    {

       // chatModel.remove(currentIndex)
        for(var i = 0; i < chatModel.count; ++i)
        {
            var obj = chatModel.get(i)

            if(obj.chatJid1 === name)
            {
                console.log("删除对应闪烁条目，传递参数:", obj.chatJid1)
                //chatModel.setProperty(i, "chatInfoNum1", chatNum);
                chatModel.remove(i,1)
                hide()
                show()
                return;
            }
        }
    }

    function clearAllItem()
    {
        chatModel.clear();
    }
}
