﻿import QtQuick 2.0
import QtQuick.Window 2.2

Window {
    id: chatwindow

    property int viewwidth: 0
    property int viewheight: 0
    property alias listviewvisible: userlistrect.visible
    property alias listviewcurrentindex: contactlistview.currentIndex
    width: viewwidth
    height: viewheight
    flags: Qt.Window | Qt.FramelessWindowHint
    x: (Screen.desktopAvailableWidth - viewwidth)/2
    y: (Screen.desktopAvailableHeight - viewheight)/2
    signal deleteitem(string userjid)
    signal showitem(string userjid, int index)

    MouseArea { //为窗口添加鼠标事件
        id:mouse
        anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true
        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)

                //console.log("2221")
                //如果mainwindow继承自QWidget,用setPos
                chatwindow.setX(chatwindow.x+delta.x)
                chatwindow.setY(chatwindow.y+delta.y)
            }
        }
    }

    ListModel {
        id: contactModel
        //        ListElement {
        //            iconImage: "qrc:/resource/images/im/chatman.png"
        //            usernames: "Bill Smith"
        //            userjid: "1"
        //        }
    }

    Component {
        id: contactDelegate

        Rectangle{
            id: hoveredbkg
            width: 150
            height:40
            //anchors.fill: parent
            //color: "#D5D095"
            color: ListView.isCurrentItem ? "lightsteelblue" : "#D5D095"
            Image {
                id: icon
                width: 32
                height: 32
                anchors.top: parent.top
                anchors.topMargin: 4
                anchors.left: parent.left
                anchors.leftMargin: 6
                source: iconImage
            }
            Text {
                id: username
                anchors.top:parent.top
                anchors.topMargin: 4
                anchors.left:icon.right
                anchors.leftMargin: 6
                anchors.right: parent.right
                anchors.rightMargin: 6
                height: 32

                verticalAlignment: Qt.AlignVCenter
                horizontalAlignment: Qt.AlignLeft

                font.pixelSize: 10
                color: "black"

                text: usernames
            }

            MouseArea{
                anchors.fill: parent
                hoverEnabled: true

                onExited: {
                    //hoveredbkg.color = "#D5D095"
                    //deleteimage.visible = false
                }

                onEntered: {
                    //hoveredbkg.color = "lightsteelblue"
                    //deleteimage.visible = true
                }

                onClicked: {
                    console.log("index",index)
                    hoveredbkg.ListView.view.currentIndex = index
                    showitem(userjid,index)

                }
            }

            Image {
                id: deleteimage
                width: 20
                height: 20
                anchors.top: parent.top
                anchors.topMargin: 10
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 10
                anchors.right: parent.right
                anchors.rightMargin: 10
                visible: hoveredbkg.ListView.isCurrentItem ? true : false

                source: "qrc:/resource/images/im/delete.png"
                MouseArea {
                    anchors.fill: parent
                    onClicked: {

                        chatwindow.deleteitem(userjid)

                        contactModel.remove(index)
                    }
                }
            }
        }
    }

    Rectangle{
        id: userlistrect
        visible: false
        width: 150
        anchors.top: parent.top
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        color: "#D5D095"

        ListView {
            id: contactlistview
            anchors.fill: parent
            focus: true
            spacing:2
            //clip: true
            model: contactModel
            delegate: contactDelegate
            currentIndex: 0

        }
    }

    function addData(stricon, strnames, strjid)
    {
        console.log("addData__:",stricon,strnames,strjid)
        contactModel.append({"iconImage": stricon, "usernames": strnames, "userjid": strjid})
    }
}
