﻿import QtQuick 2.7
import QtQuick.Window 2.2
import QtQuick.Layouts 1.1
import QtQuick.XmlListModel 2.0
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import QtGraphicalEffects 1.0
import Qt.labs.platform 1.0
import QtWebEngine 1.5
import QtWebChannel 1.0
import FileIo 1.0
import WebRunPlatform 1.0
import QtQuick.Dialogs 1.2


import "../interface"
import "../common"
import "../js/query.js" as Query
import "../js/map.js" as MapJS

Window {
    id: groupchatwindow
    width: 888//740
    height: 522
    visible: false
    opacity: 1.0
    title:groupName
  //  flags: Qt.Window | Qt.FramelessWindowHint
     flags: Qt.Window | Qt.FramelessWindowHint|Qt.NoDropShadowWindowHint//|Qt.DragLinkCursor
    property int        count: 0

    x: ((Screen.desktopAvailableWidth - 598)/2) + (20*count)
    y: ((Screen.desktopAvailableHeight - 522)/2)+(60*count)

    property bool  isCtrlDown: false
    property string roomId: ""              //!房间id
    property string jid: roomId             //!房间id
    property string strUserJid: roomId      //!房间id
    property string groupId: ""
    property string oneselfJid:""           //!自己jid
    property string oneselfName:""          //!自己名称
    property string groupName: ""
    property string chatusername:groupName
    property string chatvoicetime:""
    property string chatuserprivname: ""
    property string sessionId: jessonid     //sessionID
    property bool  inputFocus: true
    property string strStaus: ""
    property string chattime1: ""
    property string openfolder: ""

    property string chatgifsource: ""
    property string gifname: ""

    property string avatar: ""
    property string selfvavtar: ""
    property string signatureIMG: ""
    property string strOid: ""
    property string createrID: ""
    property string groudmsglist:""
    property string jessonid: ""
    property bool akeyflag:false
    property bool ckeyflag:false
    property bool skeyflag:false
    property string _Command: ""
    property var userinfoObj: null
    property var userinfoMap: new MapJS.Map();

    property var    imagePreviewObj: null
    property string strMsg: ""
    property string p1: ""
    property string p2: ""
    property string p3: ""

    property double iReceived: 0.0 //文件大小,字节
    property int    itemCount: 0
    property int    iCurrentIndex: 0
    property bool   isReceivedAll: false  //下载完成
    property bool   isSendAll: false  //上传完成

    property string receiverFileName: "" //正在下载的文件名
    property int    receiverFile:0 //文件接收到字节
    property string fileUploadUuid: "" //上传文件生成的Uuid
    property int    voiceTimePast:0 //语音录制时间,每秒加1
    property bool   bflag: false
    property int    elapseTime: 0

    property bool   iamintheroom: true  //我在群里

    property string chatisopenfirereverfile1:"0"
    //2018-11-5修改图片格式只支持".jpg",".png" , ".gif", ".jpeg"四种
    property var imgformatLower: [".jpg",".png", ".gif", ".jpeg", ".bmp" ]
    //".psd",, ".pcx", ".tiff",  ".tga", ".exif", ".fpx", ".svg"
    //, ".cdr", ".pcd", ".dxf", ".ufo", ".eps"
    //, ".ai", ".hdri", ".raw", ".wmf", ".lic", ".fli", ".flc", ".emf"

    property var imgformaUpper: [".JPG",".PNG", ".GIF", ".JPEG",".BMP" ]
    //".PSD", ".PCX", ".TIFF", ".TGA", ".EXIF", ".FPX", ".SVG"
    //,  ".CDR", ".PCD", ".DXF", ".UFO", ".EPS"
    //, ".AI", ".HDRI", ".RAW", ".WMF", ".LIC", ".FLI", ".FLC", ".EMF"

    signal deleteitem(string _roomid)
    signal _room_changeGroupName(string roomid ,string name)
    signal appendConverList(string chatText, string chatTime, string chatuserjid, string chatType,string mystauts);

    Interface {
        id:inter

        onGetDataSignal:
        {
            console.log("_SEND_MSG_msg1: ",msg1)
            console.log("_SEND_MSG_msg2: ",msg2)
            console.log("_SEND_MSG_msg3: ",msg3)


            if(msg3 === "SEND_IMG_URL")
            {
                var obj = eval('(' + msg1 + ')');  //gaobo

                console.log("网页端传来图片地址参数SEND_IMG_URL", obj.file_url, obj.file_width,  obj.file_height)

                var imgWidth = 0;
                var imgHeight = 0;

                var temWidth = obj.file_width;
                var temHeight = obj.file_height;

                if( temWidth > 424)
                {
                    imgWidth = Number(obj.file_width) + 40;
                }
                else
                {
                    imgWidth = 424;
                }

                if((temHeight+100)  >= 372)
                {
                    imgHeight =  Number(temHeight)+100
                }
                else
                {
                    imgHeight = 372;
                }

                console.log("网页端传来图片地址后，打开地址SEND_IMG_URL参数:", strip+"/xs?"+obj.file_url, imgWidth,  imgHeight)
                creatImagePreviewObj(strip+"/xs?"+ obj.file_url,  Number(imgWidth), Number(imgHeight))


            }


            if(msg3 == "SHOW_USER_INFO")
            {
                var obj = eval('(' + msg1 + ')'); //gaobo

                //  console.log("SEND_IMG_URL",  obj.file_width,  obj.file_height);


                var vatar = "";
                var userName = obj.userName;
                var userId = obj.uid;
                var userIden = obj.userPrivName;
                var sexIco= obj.sex;
                //var phoneNum= obj.dep.telNo;
                var department = obj.deptName;

                //以前是显示用户信息
                /*
                if(obj.avatar !== null && obj.avatar !== "" && obj.avatar !=="0" && obj.avatar !=="1")
                {
                    if(obj.sex=== "0")//men
                    {
                        vatar ="qrc:/resource/images/im/headman.png"
                        sexIco="qrc:/resource/images/im/headman.png"
                    }
                    else
                    {
                        vatar ="qrc:/resource/images/im/headwoman.pn"
                        sexIco="qrc:/resource/images/im/headwoman.pn"
                    }
                }
                else
                {
                    vatar = strip+  "/img/user/"+obj.avatar
                }
                p1 = msg1;
                p2 = msg2;
                p3 = msg3;

                console.log("点击群里窗口右侧用户，打开用户信息");
                var urlDetail = strip + "/sys/userDetails?uid=" + obj.uid + "&lang=zh_CN"+ "&JSESSIONID1=" + jessonid
                webRun._vNewWindows(urlDetail,"用户详情",false,strip);

                */
                //  creatUserInfoObj(vatar,userName,userId,userIden,sexIco,phoneNum,department);

                if(username !== "")
                {
                    if(obj.avatar !== "0" && obj.avatar !== "1" && obj.avatar !== "" && obj.avatar !== null)
                        creatObj(obj.userName, obj.userPrivName, obj.sex, obj.uid, mobilNo,true, "",strip+obj.avatar)
                    else  if(sex === "1")
                        creatObj(obj.userName, obj.userPrivName, obj.sex, obj.uid, mobilNo,true, "","qrc:/resource/images/main/maincenter/woman.png")
                    else
                        creatObj(obj.userName, obj.userPrivName, obj.sex, obj.uid, mobilNo,true, "","qrc:/resource/images/main/maincenter/man.png")

                }
            }
            else if(msg3 == "SEND_MESSAGE_URL")
            {
                console.log("群聊消息记录中点击文件");

                var loginAddressFile = fileio.getLoginAddress();
                var obj = eval('(' + msg1 + ')'); //eval gaobo
                //downLoadManager.startExploreExe("explorer.exe", strFileName, obj.file_url);
                if(!fileio.findfilepathissame(obj.file_name,obj.time,obj.uuid))
                {
                    var sendtext = "文件："+obj.file_name +" 正在下载中，请下载完毕后再双击打开。";

                    //群聊消息记录里的文件下载
                    receiverFileName="消息记录下载文件";
                    downLoadManager.downloadFile(loginAddressFile+"/xs?"+obj.file_url, obj.file_name, "1",obj.time,jid,obj.uuid);
                    appendSendData(sendtext, 0, "0", "", "",jid,"0");
                }
                else
                {
                    //打开文件
                    downLoadManager.startExe("explorer.exe", downLoadManager.strGetFilePath("1")+obj.file_name,obj.time,false,obj.uuid) //打开文件
                }
            }
            else if(msg3 == "GET_USER_INFO")
            {
                p1 = msg1;
                p2 = msg2;
                p3 = msg3;

                console.log("收到消息 GET_USER_INFO");
                //contentMenu.open();
                var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                Query.querygetRoomPerson(room_url, getRoomPerson,3)
            }
        }
    }

    FileIo{
        id:fileio
    }


    WebRunPlatform{
        id:webrun
    }
    MouseArea { //为窗口添加鼠标事件
          id:mouse
         // anchors.fill: parent
          acceptedButtons: Qt.LeftButton //只处理鼠标左键
          property point clickPos: "0,0"

          cursorShape: Qt.SizeFDiagCursor;
          height: 8
          width: 8
          anchors.left:parent.left
          anchors.leftMargin: 0
          anchors.top:  parent.top
          anchors.topMargin: 0

          onPressed: { //接收鼠标按下事件
              clickPos  = Qt.point(mouse.x,mouse.y)
              bPressed = true

          }

          onReleased: {
              bPressed = false;
          }

          onPositionChanged: { //鼠标按下后改变位置
              //鼠标偏移量

              if(bPressed)
              {
                  var delta = Qt.point(mouse.x+clickPos.x, mouse.y+clickPos.y)
                  //如果mainwindow继承自QWidget,用setPos
                   groupchatwindow.setX( groupchatwindow.x+delta.x)
                   groupchatwindow.setY( groupchatwindow.y+delta.y)
                   groupchatwindow.setWidth( groupchatwindow.width-delta.x);
                   groupchatwindow.setHeight( groupchatwindow.height-delta.y);
              }

          }
   }
     MouseArea { //为窗口添加鼠标事件
          //id:mouse
         // anchors.fill: parent
          acceptedButtons: Qt.LeftButton //只处理鼠标左键
          property point clickPos: "0,0"

          cursorShape: Qt.SizeHorCursor;
          height: parent.height//8
          width: 8
          anchors.right:parent.right
          anchors.rightMargin: 0
         // anchors.bottom:  parent.bottom
        //  anchors.bottomMargin: 0
          onPressed: { //接收鼠标按下事件
              clickPos  = Qt.point(mouse.x,mouse.y)
              bPressed = true

          }

          onReleased: {
              bPressed = false;
          }

          onPositionChanged: { //鼠标按下后改变位置
              //鼠标偏移量
              if(bPressed)
              {
                  var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                  //如果mainwindow继承自QWidget,用setPos

                 //  groupchatwindow.setX( groupchatwindow.x+delta.x)
                 //  groupchatwindow.setY( groupchatwindow.y+delta.y)
                   groupchatwindow.setWidth( groupchatwindow.width+delta.x);
                 //  groupchatwindow.setHeight( groupchatwindow.height-delta.y);
              }
          }
   }
     MouseArea { //为窗口添加鼠标事件
          //id:mouse
         // anchors.fill: parent
          acceptedButtons: Qt.LeftButton //只处理鼠标左键
          property point clickPos: "0,0"

          cursorShape: Qt.SizeVerCursor;
          height: 8
          width: 8
          anchors.top:parent.top
          anchors.topMargin: 0
          anchors.right:  parent.right
          anchors.rightMargin: 4
          anchors.left: parent.left
          anchors.leftMargin: 4
          //anchors.bottom: parent.bottom
          //anchors.bottomMargin: 4
          onPressed: { //接收鼠标按下事件
              clickPos  = Qt.point(mouse.x,mouse.y)
              bPressed = true

          }

          onReleased: {
              bPressed = false;
          }

          onPositionChanged: { //鼠标按下后改变位置
              //鼠标偏移量
              if(bPressed)
              {
                  var delta = Qt.point(mouse.x-clickPos.x, mouse.y+clickPos.y)
                  //如果mainwindow继承自QWidget,用setPos

                 //  groupchatwindow.setX( groupchatwindow.x+delta.x)
                  groupchatwindow.setY( groupchatwindow.y+delta.y)
                  // groupchatwindow.setWidth( groupchatwindow.width+delta.x);
                   groupchatwindow.setHeight( groupchatwindow.height-delta.y);
              }
          }
   }
     MouseArea { //为窗口添加鼠标事件
          //id:mouse
         // anchors.fill: parent
          acceptedButtons: Qt.LeftButton //只处理鼠标左键
          property point clickPos: "0,0"

          cursorShape: Qt.SizeFDiagCursor;
          height: 8
          width: 8
          anchors.right:parent.right
          anchors.rightMargin: 0
        //  anchors.left: parent
        //  anchors.leftMargin: 8
          anchors.bottom: parent.bottom
          anchors.bottomMargin: 0
         // anchors.bottom:  parent.bottom
        //  anchors.bottomMargin: 0
          onPressed: { //接收鼠标按下事件
              clickPos  = Qt.point(mouse.x,mouse.y)
              bPressed = true

          }

          onReleased: {
              bPressed = false;
          }

          onPositionChanged: { //鼠标按下后改变位置
              //鼠标偏移量
              if(bPressed)
              {
                  var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                  //如果mainwindow继承自QWidget,用setPos

                 //  groupchatwindow.setX( groupchatwindow.x+delta.x)
                 //  groupchatwindow.setY( groupchatwindow.y+delta.y)
                   groupchatwindow.setWidth( groupchatwindow.width+delta.x);
                   groupchatwindow.setHeight( groupchatwindow.height+delta.y);
              }
          }
   }
     MouseArea { //为窗口添加鼠标事件
          //id:mouse
         // anchors.fill: parent
          acceptedButtons: Qt.LeftButton //只处理鼠标左键
          property point clickPos: "0,0"

          cursorShape: Qt.SizeVerCursor;
          height: 8
          width: 8
          anchors.bottom:parent.bottom
          anchors.bottomMargin: 0
        //  anchors.left: parent
        //  anchors.leftMargin: 8
          anchors.right: parent.right
          anchors.rightMargin: 8
          anchors.left: parent.left
          anchors.leftMargin: 8
         // anchors.bottom:  parent.bottom
        //  anchors.bottomMargin: 0
          onPressed: { //接收鼠标按下事件
              clickPos  = Qt.point(mouse.x,mouse.y)
              bPressed = true

          }

          onReleased: {
              bPressed = false;
          }

          onPositionChanged: { //鼠标按下后改变位置
              //鼠标偏移量
              if(bPressed)
              {
                  var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                  //如果mainwindow继承自QWidget,用setPos

                 //  groupchatwindow.setX( groupchatwindow.x+delta.x)
                 //  groupchatwindow.setY( groupchatwindow.y+delta.y)
                 //  groupchatwindow.setWidth( groupchatwindow.width+delta.x);
                   groupchatwindow.setHeight( groupchatwindow.height+delta.y);
              }
          }
   }
     MouseArea { //为窗口添加鼠标事件
          //id:mouse
         // anchors.fill: parent
          acceptedButtons: Qt.LeftButton //只处理鼠标左键
          property point clickPos: "0,0"

          cursorShape: Qt.SizeBDiagCursor;
          height: 8
          width: 8
          //anchors.right:parent.right
         // anchors.rightMargin: 0
          anchors.left: parent.left
          anchors.leftMargin: 0
          anchors.bottom: parent.bottom
          anchors.bottomMargin: 0
         // anchors.bottom:  parent.bottom
        //  anchors.bottomMargin: 0
          onPressed: { //接收鼠标按下事件
              clickPos  = Qt.point(mouse.x,mouse.y)
              bPressed = true

          }

          onReleased: {
              bPressed = false;
          }

          onPositionChanged: { //鼠标按下后改变位置
              //鼠标偏移量
              if(bPressed)
              {
                  var delta = Qt.point(mouse.x+clickPos.x, mouse.y-clickPos.y)
                  //如果mainwindow继承自QWidget,用setPos
                   groupchatwindow.setX( groupchatwindow.x+delta.x)
                 //  groupchatwindow.setY( groupchatwindow.y+delta.y)
                   groupchatwindow.setWidth( groupchatwindow.width-delta.x);
                   groupchatwindow.setHeight( groupchatwindow.height+delta.y);
              }
          }
   }
     MouseArea { //为窗口添加鼠标事件
          //id:mouse
         // anchors.fill: parent
          acceptedButtons: Qt.LeftButton //只处理鼠标左键
          property point clickPos: "0,0"

          cursorShape: Qt.SizeHorCursor;
          height: 8
          width: 8
          //anchors.right:parent.right
         // anchors.rightMargin: 0
          anchors.left: parent.left
          anchors.leftMargin: 0
          anchors.bottom: parent.bottom
          anchors.bottomMargin: 4
          anchors.top: parent.top
          anchors.topMargin: 4
         // anchors.bottom:  parent.bottom
        //  anchors.bottomMargin: 0
          onPressed: { //接收鼠标按下事件
              clickPos  = Qt.point(mouse.x,mouse.y)
              bPressed = true

          }

          onReleased: {
              bPressed = false;
          }

          onPositionChanged: { //鼠标按下后改变位置
              //鼠标偏移量
              if(bPressed)
              {
                  var delta = Qt.point(mouse.x+clickPos.x, mouse.y-clickPos.y)
                  //如果mainwindow继承自QWidget,用setPos

                   groupchatwindow.setX( groupchatwindow.x+mouse.x)
               //    groupchatwindow.setY( groupchatwindow.y)
                   groupchatwindow.setWidth( groupchatwindow.width-delta.x);
                  // groupchatwindow.setHeight( groupchatwindow.height-delta.y);
              }
          }
   }

   /* MouseArea { //为窗口添加鼠标事件
        id:mouse1
        anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true
        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)

                //如果mainwindow继承自QWidget,用setPos
                groupchatwindow.setX(groupchatwindow.x+delta.x)
                groupchatwindow.setY(groupchatwindow.y+delta.y)
            }
        }
    }*/

     FileDialog {

         id: fileDialog
         visible: false
         selectExisting: true
         selectFolder: false
         selectMultiple: true
         onAccepted:
         {


             // getuserinfos()
             // var strfile = fileDialog.currentFile.toString().split("///");
             //var strfile = fileDialog.currentFile.toString().replace(/^(file:\/{3})/,"");
             var str = fileio.findfilepathUseRegExp(fileDialog.fileUrls)
             console.log("str====",str)
             if(str!= "")
             {
                 var strfilepath;
                 var strlist = str.toString().split("---");
                 console.log("strlist====",strlist,strlist.length)
                 for(var i = 0;i<strlist.length-1;i++)
                 {
                     strfilepath= strlist[i]
                     console.log("strfile1111111111", strfilepath)
                     strfilepath = decodeURIComponent(strfilepath) //文件地址???
                     console.log("strfile22222222", strfilepath)
                     var tempFile = strfilepath.toString().split("/");
                     console.log("tempFile====",tempFile)
                     // console.log("strfile", tempFile,strfilepath.toString(),tempFile[tempFile.length - 1])
                     var MessageKey =strOid + "pq";
                     console.log("MessageKey======",MessageKey)
                     var strUrl;
                     var _sUuid =Query.uuid();
                     fileUploadUuid=_sUuid; //记录此次上传的uuid

                     //  if(strFileType == "1") file
                     //   if(strFileType == "2") img
                     //   if(strFileType == "3")voice

                     var  s1 =strfilepath;
                     var  s2 =downLoadManager.strGetFilePath("2");
                     var  s3 =s2+tempFile[tempFile.length - 1];

                     fileio.copyFile(s1,s3,s2)

                     if(findimg(strfilepath) == 1)
                     {
                         if(fileio.getfilesize(strfilepath)>1024*1024*2)
                         {
                             appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",groupName)
                             var strMessage1 = "{\"type\":\"file\",\"data\":";
                             strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                             strMessage1 += ",\"send_time\":\"";
                             strMessage1 += getTime() ;
                             strMessage1 += "\",\"uuid\":\"";
                             strMessage1 +=_sUuid;
                             strMessage1 += "\",\"callback\":\"";
                             strMessage1 +="1" ;
                             strMessage1 += "\"}";

                             strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                     + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                     + "&msg_type=1&charset=utf-8";//+MessageKey

                             if( chatTransferFile.start(strUrl,strfilepath,jessonid,roomId))
                             {
                                 //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                 var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请稍候。";
                                 appendSendData(sendtext, 0, "0", "", "",jid,"0");
                                 //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1",mainwindow.oneselfName)


                             }
                             console.log("fileDialog file___",strUrl)
                             edit.text = "";
                             return

                         }
                         appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",groupName)
                         var strMessage = "{\"type\":\"img\",\"data\":";
                         strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                         strMessage += ",\"send_time\":\"";
                         strMessage += getTime() ;
                         strMessage += "\",\"uuid\":\"";
                         strMessage +=_sUuid;
                         strMessage += "\",\"callback\":\"";
                         strMessage +="1" ;
                         strMessage += "\"}";

                         strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                 + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                 + "&msg_type=1&charset=utf-8"
                         console.log("上传图片地址",strUrl);//MessageKey+

                         //chatTransferFile.setStrJessionId(jessonid)
                         //chatTransferFile.setServerAddr(strUrl);
                         //chatTransferFile.setPostFilePath(strfile[1]);
                         if( chatTransferFile.start(strUrl,strfilepath,jessonid,roomId))
                         {
                             // appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")
                             // appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1",mainwindow.oneselfName)
                         }


                         console.log("fileDialog img___",  strUrl)

                     }
                     else
                     {
                         appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",groupName)
                         var strMessage1 = "{\"type\":\"file\",\"data\":";
                         strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                         strMessage1 += ",\"send_time\":\"";
                         strMessage1 += getTime() ;
                         strMessage1 += "\",\"uuid\":\"";
                         strMessage1 +=_sUuid;
                         strMessage1 += "\",\"callback\":\"";
                         strMessage1 +="1" ;
                         strMessage1 += "\"}";

                         strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                 + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                 + "&msg_type=1&charset=utf-8";//+MessageKey

                         if( chatTransferFile.start(strUrl,strfilepath,jessonid,roomId))
                         {
                             //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                             var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请稍候。";
                             appendSendData(sendtext, 0, "0", "", "",jid,"0");
                             //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1",mainwindow.oneselfName)


                         }
                         console.log("fileDialog file___",strUrl)  //http://192.168.0.18/im/putMessage?
                     }

                     filebtn.checked = 0
                 }

             }
         }
         /*{

            //  getuserinfos()
           // var strfile = fileDialog.currentFile.toString().split("///");
            var strfile = fileDialog.currentFile.toString().replace(/^(file:\/{3})/,"");
            strfile = decodeURIComponent(strfile)
            var tempFile = strfile.toString().split("/");
            console.log("strfile", strfile)
            var MessageKey =strOid + "pq";
            var strUrl;
            var _sUuid =Query.uuid();
            //  if(strFileType == "1") file
            //   if(strFileType == "2") img
            //   if(strFileType == "3")voice

            var  s1 =strfile;
            var  s2 =downLoadManager.strGetFilePath("2");
            var  s3 =s2+tempFile[tempFile.length - 1];

            fileio.copyFile(s1,s3,s2)

            if(findimg(strfile) == 1)
            {
                appendConverList("", getTime(), jid, "img",strStaus)
                var strMessage = "{\"type\":\"img\",\"data\":";
                strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                strMessage += ",\"send_time\":\"";
                strMessage += getTime() ;
                strMessage += "\",\"uuid\":\"";
                strMessage +=_sUuid;
                strMessage += "\",\"callback\":\"";
                strMessage +="1" ;
                strMessage += "\"}";

                appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1",mainwindow.oneselfName)
                strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                        + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                        + "&msg_type=1&charset=utf-8";

                console.log("fileDialog img___",  strUrl)

            }
            else
            {
                appendConverList("", getTime(), jid, "file",strStaus)
                var strMessage1 = "{\"type\":\"file\",\"data\":";
                strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                strMessage1 += ",\"send_time\":\"";
                strMessage1 += getTime() ;
                strMessage1 += "\",\"uuid\":\"";
                strMessage1 +=_sUuid;
                strMessage1 += "\",\"callback\":\"";
                strMessage1 +="1" ;
                strMessage1 += "\"}";


                strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                        + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                        + "&msg_type=1&charset=utf-8";

                console.log("fileDialog file___",strUrl)

            }

           /* chatTransferFile.setStrJessionId(jessonid)
            chatTransferFile.setServerAddr(strUrl);
            chatTransferFile.setPostFilePath(strfile[1]);*/
         /*  if( chatTransferFile.start(strUrl,strfile,jessonid,roomId))
            {
                 appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1",mainwindow.oneselfName)


            }

            filebtn.checked = 0
        }*/

         onRejected: {

             filebtn.checked = 0
         }

         Component.onCompleted: {
             visible = false
         }

     }

    FileDialog {

        id: pictureDialog

        visible: false
        selectExisting: true
        selectFolder: false
        selectMultiple: true
        nameFilters: [ "(*.jpg *.png *.bmp *.gif *.jpeg)" ]

        onAccepted:
        {


                            getuserinfos()
                         // var strfile = fileDialog.currentFile.toString().split("///");
                         //var strfile = fileDialog.currentFile.toString().replace(/^(file:\/{3})/,"");
                          var str = fileio.findfilepathUseRegExp(pictureDialog.fileUrls)
                              console.log("str====",str)
                          if(str!= "")
                          {
                              var strfilepath;
                              var strlist = str.toString().split("---");
                              console.log("strlist====",strlist,strlist.length)
                              for(var i = 0;i<strlist.length-1;i++)
                              {
                                   strfilepath= strlist[i]
                         // console.log("strfile1111111111", strfilepath)
                          strfilepath = decodeURIComponent(strfilepath) //文件地址???
                         // console.log("strfile22222222", strfilepath)
                          var tempFile = strfilepath.toString().split("/");
                                  console.log("tempFile====",tempFile)
                         // console.log("strfile", tempFile,strfilepath.toString(),tempFile[tempFile.length - 1])
                          var MessageKey =strOid + "pq";
                                  console.log("MessageKey======",MessageKey)
                          var strUrl;
                          var _sUuid =Query.uuid();
                          fileUploadUuid=_sUuid; //记录此次上传的uuid

                          //  if(strFileType == "1") file
                          //   if(strFileType == "2") img
                          //   if(strFileType == "3")voice

                          var  s1 =strfilepath;
                          var  s2 =downLoadManager.strGetFilePath("2");
                          var  s3 =s2+tempFile[tempFile.length - 1];

                          fileio.writeinifilepath(strfilepath)

                          fileio.copyFile(s1,s3,s2)

                          if(findimg(strfilepath) == 1)
                          {
                              if(fileio.getfilesize(strfilepath)>1024*1024*2)
                              {
                                  appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",groupName)
                                  var strMessage1 = "{\"type\":\"file\",\"data\":";
                                  strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                  strMessage1 += ",\"send_time\":\"";
                                  strMessage1 += getTime() ;
                                  strMessage1 += "\",\"uuid\":\"";
                                  strMessage1 +=_sUuid;
                                  strMessage1 += "\",\"callback\":\"";
                                  strMessage1 +="1" ;
                                  strMessage1 += "\"}";

                                  strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                          + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                          + "&msg_type=1&charset=utf-8";//+MessageKey

                                  if( chatTransferFile.start(strUrl,strfilepath,jessonid,roomId))
                                  {
                                      //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                      var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请稍候。";
                                      appendSendData(sendtext, 0, "0", "", "",jid,"0");
                                      //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1",mainwindow.oneselfName)


                                  }
                                  console.log("fileDialog file___",strUrl)
                                  edit.text = "";
                                  return
                              }

                              appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",groupName)
                              var strMessage = "{\"type\":\"img\",\"data\":";
                              strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                              strMessage += ",\"send_time\":\"";
                              strMessage += getTime() ;
                              strMessage += "\",\"uuid\":\"";
                              strMessage +=_sUuid;
                              strMessage += "\",\"callback\":\"";
                              strMessage +="1" ;
                              strMessage += "\"}";

                              strUrl =strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                      + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                      + "&msg_type=1&charset=utf-8"//MessageKey+

                              //chatTransferFile.setStrJessionId(jessonid)
                              //chatTransferFile.setServerAddr(strUrl);
                              //chatTransferFile.setPostFilePath(strfile[1]);
                              if( chatTransferFile.start(strUrl,strfilepath,jessonid,roomId))
                              {
                                  //appendSendData(strMessage, 0, "2", s2, "","1",mainwindow.oneselfName)
                              }
                              console.log("fileDialog img___",  strUrl)
                          }






                          picturebtn.checked = 0
                      }

                          }
                             }
            /* {

            //  getuserinfos()

           // var strfile = pictureDialog.currentFile.toString().split("///");
            var strfile = fileDialog.currentFile.toString().replace(/^(file:\/{3})/,"");
            strfile = decodeURIComponent(strfile)
            var tempFile = strfile.toString().split("/");
            //stroldPath = strfile[1].toString();
            console.log("*********1", strfile);
            var strUrl;
            var _sUuid =Query.uuid();

            if(findimg(strfile) == 1)
            {
                //  if(strFileType == "1") file
                //   if(strFileType == "2") img
                //   if(strFileType == "3")voice

                var  s1 =strfile[1];
                var  s2 =downLoadManager.strGetFilePath("2");
                var  s3 =s2+tempFile[tempFile.length - 1];

                fileio.copyFile(s1,s3,s2)

                var MessageKey =strOid + "pq";
                appendConverList("", getTime(), jid, "img",strStaus)
                var strMessage = "{\"type\":\"img\",\"data\":";
                strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                strMessage += ",\"send_time\":\"";
                strMessage += getTime();
                strMessage += "\",\"uuid\":\"";
                strMessage +=_sUuid;
                strMessage += "\",\"callback\":\"";
                strMessage +="1" ;
                strMessage += "\"}";



                strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                        + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to="+jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                        + "&msg_type=1&charset=utf-8";

                console.log("pictureDialog img___",  strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                            + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                            + "&msg_type=1&charset=utf-8")


            }

           /* chatTransferFile.setStrJessionId(jessonid)
            chatTransferFile.setServerAddr(strUrl);
            chatTransferFile.setPostFilePath(strfile[1]);*/
         /*   if( chatTransferFile.start(strUrl,strfile,jessonid,roomId))
            {
                appendSendData(strMessage, 0, "2", s2, "","1",mainwindow.oneselfName)
            }


            picturebtn.checked = 0
        }*/

        onRejected: {
            picturebtn.checked = 0
        }

        Component.onCompleted: {

        }

    }

    Rectangle{
        id: mainRect
        anchors.fill: parent
        //border.color: "#D8DCE0"
        border.color:"#278ADD"  //聊天窗口边框
        border.width: 1
        color: "#cccccc"
        clip:true
        focus: true
        // 群界面上部 标签
        Rectangle {
            id: title
            height: 74
            anchors.top: parent.top
            anchors.topMargin: 1

            anchors.left: parent.left
            anchors.leftMargin: 1

            anchors.right: parent.right
            anchors.rightMargin: 1

            border.width: 0
            border.color: "#D8DCE0"
            color: "#EBF3F8"
            MouseArea { //为窗口添加鼠标事件
                 id:mouse1
                 anchors.fill: parent
                 acceptedButtons: Qt.LeftButton //只处理鼠标左键
                 property point clickPos: "0,0"
                 onPressed: { //接收鼠标按下事件
                     clickPos  = Qt.point(mouse.x,mouse.y)
                     bPressed = true
                 }

                 onReleased: {
                     bPressed = false;
                 }

                 onPositionChanged: { //鼠标按下后改变位置
                     //鼠标偏移量
                     if(bPressed)
                     {
                         var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)

                         //如果mainwindow继承自QWidget,用setPos
                         groupchatwindow.setX(groupchatwindow.x+delta.x)
                         groupchatwindow.setY(groupchatwindow.y+delta.y)
                     }
                 }
             }
            //群头像
            Item{
                id: userimage
                width: 45
                height: 45
                anchors.left: parent.left
                anchors.leftMargin: 16
                anchors.top: parent.top
                anchors.topMargin: 15

                BorderImage {
                    id: userimage1
                    anchors.fill: parent
                    visible: true
                    source: {
                        if(avatar == "0")
                            return "qrc:/resource/images/im/chatman (2).png";
                        else
                            return avatar
                    }

                }/*
                Rectangle{
                    id:mask
                    anchors.fill: userimage1
                    radius: width/2.
                }

                OpacityMask {
                    anchors.fill: userimage1
                    source: userimage1
                    maskSource: mask
                }*/
            }

            //群名称
            TextField {
                id: username
                width:  440
                maximumLength: 20
                anchors.top: parent.top
                anchors.topMargin: 25
                anchors.left: userimage.right
                anchors.leftMargin: 10
                font.pixelSize: 17
                font.bold: true
                font.family: "微软雅黑"
                enabled : true
                text:
                {
                    if(groupName.indexOf("邀请")>-1 && groupName.indexOf("加入群聊")>-1 )
                    {
                        return groupName.substring(2,groupName.length-4)
                    }
                    else
                    {
                        return groupName;
                    }
                }

                focus:false

                style: TextFieldStyle {
                    textColor: "#666666"
                    background: Rectangle {
                        color: "#EBF3F8"
                        border.width: 0
                    }
                }

                onHoveredChanged:
                {
                    if(!hovered) {
                        username.focus = false;
                        username.textColor= "#666666"
                    }
                }

                onEditingFinished:
                {
                    //修改群名称
                    username.focus = false;
                    username.textColor= "#666666"
                    groupName = username.text;
                    var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                    Query.querygetRoomPerson(room_url, getRoomPerson,4)
                }

            }

            ControlButton {
                id: min
                anchors.top: parent.top
                anchors.right: max.left
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/im/chatMin.png"
                hoverImage: "qrc:/resource/images/im/chatMin_hovered.png"
                onClicked: {
                    groupchatwindow.visibility = Window.Minimized
                }
            }

            ControlButton {
                id: max
                anchors.top: parent.top
                anchors.right: close.left
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/im/chatMax.png"
                hoverImage: "qrc:/resource/images/im/chatMax_hovered.png"

                onClicked: {
                    if(groupchatwindow.visibility == Window.Maximized)
                    {
                        groupchatwindow.visibility = Window.Windowed
                    }
                    else
                    {
                        groupchatwindow.visibility = Window.Maximized
                    }
                }
            }

            ControlButton {
                id: close
                anchors.top: parent.top
                anchors.right: parent.right
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/im/chatClose.png"
                hoverImage: "qrc:/resource/images/im/chatClose_hovered.png"
                onClicked:{
                    groupchatwindow.deleteitem(jid);
                    // groupchatwindow.close()

                }
            }

            //添加群用户
            ControlButton {
                id: adduserid
                width: 32
                height: 32
                anchors.top: close.bottom
                anchors.topMargin: 10
                anchors.left: close.left
                normalImage: "qrc:/resource/images/im/adduser.png"
                MouseArea
                {
                    id:adduser_mouse
                    anchors.fill: parent
                    hoverEnabled: false
                    focus: false
                    acceptedButtons: Qt.LeftButton
                    cursorShape: Qt.ArrowCursor

                    onClicked:
                    {
                        //点击添加群用户按钮
                        var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                        Query.querygetRoomPerson(room_url, getRoomPerson,2)
                    }
                }
            }
        }

        //群成员列表
        Rectangle {
            id: roomMember
            width:280//(parent.width/4)
            height: parent.height
            anchors.top: title.bottom
            anchors.topMargin: 2
            anchors.right: parent.right
            anchors.rightMargin: 2
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 2
            border.width: 0
            border.color: "#D8DCE0"
            color: "#EBF3F8"
            WebChannel {
                id: room_webChannel
            }

            WebEngineView{
                id: room_Web
                anchors.top: parent.top//roomMember.top
                anchors.left: parent.left//roomMember.left
                anchors.leftMargin: 1
                anchors.right: parent.right//roomMember.right
                anchors.rightMargin: 1
                anchors.bottom: parent.bottom//roomMember.bottom
                anchors.bottomMargin: 1
                smooth: true
                webChannel: room_webChannel

            }
/*
            MouseArea {
                id: mouseRigButton
                anchors.fill: parent;
                acceptedButtons: Qt.RightButton

                onClicked: {
                    contentMenu.open();
                }
            }*/

            Menu {
                title: "Edit"
                id: contentMenu

                MenuItem {
                    text: "查看资料"
                    onTriggered: {
                        console.log("群成员里面查看个人消息")
                        //creatUserInfoObj(vatar,userName,userId,userIden,sexIco,phoneNum,department);
                        //   Menu.close();
                        if(p1.length>0)
                        {
                            var obj =eval('(' + p1 + ')');  // eval //gaobo
                            var userName = obj.userName;
                            var userId = obj.uid;
                            console.log(strip+ "/sys/userDetails?uid="+userId,jessonid)
                            //webRun._slot_request(strip+ "/sys/userDetails?uid="+userId,jessonid);
                            webRun._vNewWindows(strip + "/sys/userDetails?uid=" + userId + "&lang=zh_CN&JSESSIONID1=" + jessonid,"用户信息",false)
                            //room_Web.url = strip + "/spirit/groupChat?roomOf="+groupId;

                            p1="";
                        }
                    }
                }

                MenuItem {
                    text: "复制名称"
                    onTriggered: {

                        if(p1.length>0)
                        {
                           console.log("群成员里面复制名称")
                            var obj = eval('(' + p1 + ')');   // eval gaobo
                            var userName = obj.userName;
                            var userId = obj.uid;
                            fileio.setClipboard(userName);

                            p1="";
                        }
                    }
                }

                MenuItem {
                    text: "移出群聊"
                    visible: p2=="0"?true:false
                    onTriggered: {
                        if(p1.length>0)
                        {
                            console.log("移出群聊")
                            var obj = eval('(' + p1 + ')');  // eval gaobo
                            var userName = obj.userName;
                            var userId = obj.uid;
                            console.log(strip+ "/im/getOutPerson?&delete_uid="+userId+"&room_id="+jid + "&opt=1",jessonid)
                            webRun._slot_request(strip+ "/im/getOutPerson?&delete_uid="+userId+"&room_id="+jid + "&opt=1",jessonid);
                            room_Web.url = strip + "/spirit/groupChat?roomOf="+groupId;
                            p1="";

                            var _suuid = Query.uuid()
                            talkRoomIntface._vDelGroudUser(userId,userName,jid,groupName,mainwindow.oneselfName,_suuid);
                        }
                    }
                }
            }

            Component.onCompleted: {
                room_webChannel.registerObject("interface", inter);
                room_Web.url = strip + "/spirit/groupChat?roomOf="+groupId;
                console.log("群聊右侧人员列表界面:",strip + "/spirit/groupChat?roomOf="+groupId);
            }
        }

        //消息列表
        Rectangle {
            id: msglist
            width:280//(parent.width/4+30)
            height: parent.height
            anchors.top: title.bottom
            anchors.topMargin: 2
            anchors.leftMargin: 2
            anchors.right: parent.right
            anchors.rightMargin: 2
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 2
            border.width: 0
            border.color:"#D8DCE0"
            color: "#EBF3F8"
            visible:  true

            WebChannel {
                id: msglist_webChannel
            }

            WebEngineView{
                id: msglist_Web
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.leftMargin: 1
                anchors.right: parent.right
                anchors.rightMargin: 1
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 1
                smooth: true
                webChannel: room_webChannel

            }

            Component.onCompleted: {
                msglist_webChannel.registerObject("interface", inter);
                msglist_Web.url = strip + "/spirit/groupChatLog?of_to="+groupId+"&last_time="+fileio.getCurrTime()+"&msg_type=1";

            }
        }

        //输入框和显示框
        Rectangle {
            id: writeandshow
            // anchors.fill: parent
            height: parent.height
            anchors.top: title.bottom
            anchors.topMargin: 1
            anchors.right: roomMember.left
            anchors.rightMargin: 0
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 1
            anchors.left: parent.left
            anchors.leftMargin: 1
            border.width: 1
            border.color: "#D8DCE0"
            color: "#EBF3F8"
            focus: true
            //显示框
            Rectangle {
                id: showRect
                // anchors.fill: parent
                height: parent.height-140
                width: parent.width//598//parent.width
                border.color: "#D8DCE0"
                color:"#EBF3F8"
                //color: "#000000"

                ListModel{
                    id:groupChatModel
                }

                ScrollView
                {
                    width: parent.width
                    anchors.top: parent.top
                    height: parent.height//32 27   10

                    style: ScrollViewStyle {
                        handle: Item{
                            implicitWidth: 7
                            Rectangle {
                                //color: "#B0B0B0"
                                color: "#85C6F2" //滚动条颜色
                                anchors.fill: parent
                                visible: true
                                radius: 3
                            }
                        }
                        decrementControl:Image {
                            width:7
                            height: 7
                            source: "qrc:/resource/images/im/uparrow.png"
                        }
                        incrementControl:Image {
                            width: 7
                            height: 7
                            source: "qrc:/resource/images/im/downarrow.png"
                        }
                        scrollBarBackground: Rectangle {
                            implicitWidth: 7
                            color: "#EBF3F8"

                        }
                    }

                    ListView{
                        id:groupchatView
                        width: parent.width
                        height: parent.height-50
                        anchors.top: parent.top
                        anchors.bottom: parent.bottom
                        spacing:10
                        orientation:  ListView.Vertical
                        model:groupChatModel
                        delegate: ChatItem{
                            chatName: chatname1
                            chatContents: chatcontents1
                            chatFlag: chatflag1
                            chatHead: chathead
                            chatisopenfirereverfile:chatisopenfirereverfile1
                            chatTime: chattime1
                            chatIndex: index
                            chatGifSource: chatgifsource1
                            chatMsgType: chatmsgtype
                            chatFileData: chatfiledata
                            bIsReceived: bisreceived
                            chatFilePath: chatfilepath
                            chatVoiceTime: chatvoicetime
                            oneselfUid: oneselfJid //自己id
                            otherUid: jid       //别人id
                            //bIsMucRoomHandleMsg:false

                            isReceivedAll1:isReceivedAll
                            receiverFile1:receiverFile
                            receiverFileName1:receiverFileName

                            onDelChatitem:{

                                getuserinfos();
                                Query.deleteChatItem(strip,groupChatModel.get(index).uuid,jsessionid)
                                console.log("删除聊天index strip uuid:",index,strip,groupChatModel.get(index).uuid);
                                groupChatModel.remove(index,1);
                            }
                        }

                        clip:true

                        MouseArea{
                            id:mouseshow
                            anchors.fill: parent
                            propagateComposedEvents: true

                            onClicked:
                            {
                                //edit.focus = false
                                mouse.accepted = false
                            }

                            onEntered: {
                                //mouse.accepted = false
                            }

                            onExited: {
                                //.accepted = false
                            }
                        }
                    }
                }

           }


            //输入框
            Rectangle {
                id: writeRect
                height: parent.height-140
                width: parent.width
                //  anchors.fill: parent
                anchors.top: showRect.bottom
                border.width: 1
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 2
                border.color: "#D8DCE0"
                color: "#EBF3F8"
                anchors.topMargin: 0
                focus: true
                //color: "red"


                //表情区域
                Rectangle {
                    id: iconrect
                    z: 1
                    width: 470
                    height: 310
                    x: toolbar.x
                    y: toolbar.y - 310
                    color: "#FFFFFF"
                    visible: false

                    ChatFace {
                        id: faceitem
                        anchors.top: parent.top
                        anchors.topMargin: 5
                        anchors.left: parent.left
                        anchors.leftMargin: 10
                        onSignalClickCurrentImg: {

                            chatgifsource = strPath

                            gifname = imgName

                            edit.text += "["+gifname+"]";
                            edit.cursorPosition = edit.text.length

                            //edit.text += "<img src ="+chatgifsource+">"

                            iconrect.visible = false
                            facebtn.checked = false
                        }
                    }
                }

                //语音区域
                Rectangle{
                    id: voiceRect
                    height: 28
                    anchors.bottom: toolbar.top
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    anchors.right:
                    {
                        if(msglist.visible)
                        {
                            return msglist.left
                        }
                        else
                        {
                            return parent.right
                        }
                    }

                    anchors.rightMargin: 1
                    color: "#EBF3F8"

                    visible: false

                    ProgressBar{
                        id:voiceprogressbar
                        anchors.fill: parent
                        style: ProgressBarStyle {
                            background: Rectangle {
                                width: parent.width
                                height: parent.height
                                border.width: 1
                                border.color: "#CFD5DB"
                                color: "#EBF3F8"
                            }
                            progress: Rectangle {
                                radius: 4
                                color: "#BEE8FB"
                            }
                        }

                        Rectangle {
                            id: voiceicon

                            anchors.top: parent.top
                            anchors.topMargin: 10
                            anchors.left: parent.left
                            anchors.leftMargin: 10
                            width: 8; height: 8
                            radius: 4
                            color: "#79E09F"

                        }

                        Text {
                            id: voicetext
                            anchors.top: parent.top
                            anchors.bottom: parent.bottom
                            anchors.left: voiceicon.right
                            anchors.leftMargin: 10
                            font.family: "微软雅黑"
                            font.pixelSize: 12

                            verticalAlignment: Qt.AlignVCenter
                            text:qsTr("正在录音...");
                        }

                        Rectangle {
                            id: sendvoicebtn
                            width: 45
                            height: 22
                            radius: 3
                            anchors.top: parent.top
                            anchors.topMargin: 3
                            anchors.right: canclevoicebtn.left
                            anchors.rightMargin: 5
                            border.width: 1
                            border.color: "#069DD5"
                            color: "#069DD5"

                            Text {
                                anchors.fill: parent

                                font.family: "微软雅黑"
                                color: "#FFFFFF"
                                font.pixelSize: 12
                                horizontalAlignment: Qt.AlignHCenter
                                verticalAlignment: Qt.AlignVCenter
                                text: qsTr("发送")

                                MouseArea{
                                    anchors.fill: parent

                                    onClicked: {
                                        sendvoice()
                                    }
                                }
                            }
                        }

                        Rectangle {
                            id: canclevoicebtn
                            width: 45
                            height: 22
                            radius: 3
                            anchors.top: parent.top
                            anchors.topMargin: 3
                            anchors.right: parent.right
                            anchors.rightMargin: 5
                            border.width: 1
                            border.color: "#3290de"
                            color: "#069DD5"

                            Text {
                                anchors.fill: parent

                                font.family: "微软雅黑"
                                font.pixelSize: 12

                                horizontalAlignment: Qt.AlignHCenter
                                verticalAlignment: Qt.AlignVCenter
                                text: qsTr("取消")
                                color: "#FFFFFF"

                                MouseArea{
                                    anchors.fill: parent

                                    onClicked: {
                                        cancelvoice()
                                    }
                                }
                            }
                        }
                    }
                }

                //语音录制定时器
                Timer
                {
                    id: voicetimer
                    //interval: 1800;
                    interval: 600; //0.6秒*100表示进度条总长60秒
                    repeat: true
                    onTriggered: {
                        voiceprogressbar.value += 0.01

                        //console.log("音频录制进度:", voiceprogressbar.value)
                        if(voiceprogressbar.value == "1")
                        {
                            sendvoice()
                        }
                    }
                }

                //录音图标和倒计时定时器
                Timer {
                    id: voiceicon_timer
                    interval: 1000;
                    repeat: true
                    onTriggered: {

                        if(!bflag)
                        {
                            voiceicon.color = "#54B904"
                            bflag = !bflag
                        }
                        else
                        {
                            voiceicon.color = "#79E09F";
                            bflag = !bflag
                        }

                        voiceTimePast++
                        var timeleft=parseInt(60-voiceTimePast)
                        voicetext.text="正在录音,剩余"+timeleft+"秒"
                    }
                }

                Rectangle {
                    id:  toolbar
                    height: 30
                    anchors.top: parent.top
                    anchors.topMargin: 1
                    anchors.left: parent.left
                    anchors.leftMargin: 0
                    anchors.right: parent.right
                    anchors.rightMargin: 1
                    //border.width: 0
                    //border.color: "#D8DCE0"
                    color: "#EBF3F8"

                    //发表情
                    CheckedIconButton {
                        id: facebtn
                        width: 22
                        height: 22
                        anchors.left: parent.left
                        anchors.leftMargin: 8
                        anchors.top: parent.top
                        anchors.topMargin: 3
                        checkable: true
                        visible: true
                        tooltip: qsTr("表情")
                        normalIcon: "qrc:/resource/images/im/face.png"
                        hoveredIcon: "qrc:/resource/images/im/face_hovered.png"
                        checkedIcon: "qrc:/resource/images/im/face_hovered.png"

                        onClicked: {
                            if(iconrect.visible)
                            {
                                iconrect.visible = false
                            }
                            else
                            {
                                iconrect.visible = true
                            }
                        }
                    }

                    //发送图片按钮
                    CheckedIconButton {
                        id: picturebtn
                        width: 22
                        height: 22
                        anchors.left: facebtn.right
                        anchors.leftMargin: 10
                        anchors.top: parent.top
                        anchors.topMargin: 3
                        checkable: true
                        visible: true
                        tooltip: qsTr("发送图片")
                        normalIcon: "qrc:/resource/images/im/picture1.png"
                        hoveredIcon: "qrc:/resource/images/im/picture1_hovered.png"
                        checkedIcon: "qrc:/resource/images/im/picture1_hovered.png"
                        onClicked: {

                            var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                            Query.querygetRoomPerson(room_url, getRoomPerson,7)

                        }
                    }


                    //!文件对话
                    CheckedIconButton {
                        id: filebtn
                        width: 22
                        height: 22
                        anchors.left: picturebtn.right
                        anchors.leftMargin: 10
                        anchors.top: parent.top
                        anchors.topMargin: 3
                        checkable: true
                        visible: true
                        tooltip: qsTr("发送文件")
                        normalIcon: "qrc:/resource/images/im/file2.png"
                        hoveredIcon: "qrc:/resource/images/im/file2_hovered.png"
                        checkedIcon: "qrc:/resource/images/im/file2_hovered.png"
                        onClicked: {

                            var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                            Query.querygetRoomPerson(room_url, getRoomPerson,8)

                        }
                    }
                    CheckedIconButton {
                                    id: screenShotbtn
                                    width: 22
                                    height: 22
                                    anchors.left: filebtn.right
                                    anchors.leftMargin: 10
                                    anchors.top: parent.top
                                    anchors.topMargin: 3
                                    checkable: true
                                    visible: true
                                    tooltip: qsTr("截图发送")
                                    normalIcon: "qrc:/resource/images/im/shotsreen_hovered.png"
                                    hoveredIcon: "qrc:/resource/images/im/shotsreen.png"
                                    checkedIcon: "qrc:/resource/images/im/shotsreen_hovered.png"
                                    onClicked: {
                                        //var  paramurl = strip + "/email/index?lang=zh_CN";
                                        //Qt.openUrlExternally(strip + "/email/addbox?uid="+jid+"&uname="+chatusername+"&JSESSIONID1=" + jsessionid)
                                        //webRun._vNewWindows(strip + "/email/addbox?uid="+jid+"&uname="+chatusername,jsessionid)
                                        //console.log("(strip + "/email/addbox?uid="+jid+"&uname="+chatuserprivname,jsessionid)",id---------)

                                        var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                                        Query.querygetRoomPerson(room_url, getRoomPerson,9)

                                    }
                                }
                    //发送语音按钮
                    CheckedIconButton {
                        id: voice
                        width: 24
                        height: 22
                        anchors.top: parent.top
                        anchors.topMargin: 4
                        anchors.left: screenShotbtn.right
                        anchors.leftMargin: 10
                        checkable: true
                        visible: true
                        normalIcon: "qrc:/resource/images/im/voice.png"
                        hoveredIcon: "qrc:/resource/images/im/voice_hovered.png"
                        checkedIcon: "qrc:/resource/images/im/voice.png"
                        onClicked: {

                            var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                            Query.querygetRoomPerson(room_url, getRoomPerson,10)

                        }
                    }

                    //消息记录
                    Text {
                        id: messagelogingtext
                        height: 22
                        anchors.right: parent.right
                        anchors.rightMargin: 10
                        anchors.top: parent.top
                        anchors.topMargin: 3
                        font.pixelSize: 12
                        font.family: "微软雅黑"
                        visible: true
                        text: qsTr("消息记录")

                        MouseArea {
                            anchors.fill: parent
                            hoverEnabled: true
                            cursorShape: Qt.PointingHandCursor

                            onEntered: {
                                messagelogingtext.color = "#16b0e9"
                            }

                            onExited: {
                                messagelogingtext.color = "black"
                            }

                            onClicked: {
                                if(msglist.visible)
                                {
                                    //groupchatwindow.width = 740
                                    //roomMember.width = groupchatwindow.width/4;
                                    msglist.visible = false
                                    roomMember.visible= true
                                    //

                                    //!连接网页
                                    // getuserinfos() /spirit/groupChat?roomOf=1515375827724@gsrooms.
                                    console.log("聊天记录打开联系人",strip + "/spirit/groupChat?roomOf="+groupId);
                                    room_Web.url = strip + "/spirit/groupChat?roomOf="+groupId;

                                }
                                else
                                {
                                    //groupchatwindow = 898;
                                    // msglist.width = groupchatwindow.width/4+158;


                                    // msglist.left = parent.right-parent.width/4-30;
                                    //!连接网页
                                    //  getuserinfos()
                                    console.log("聊天记录:",strip + "/spirit/groupChatLog?of_to="+groupId+"&last_time="+fileio.getCurrTime()+"&msg_type=1");
                                    var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                                    Query.querygetRoomPerson(room_url, getRoomPerson,5) //查看消息记录
                                }

                            }
                        }
                    }

                }

                Rectangle{
                    id: inputRect
                    border.width: 0
                    border.color: "#D8DCE0"
                    color: "#EBF3F8"
                    anchors.topMargin: 30
                    anchors.fill: parent



                    MouseArea{
                        id:rightmouse;
                        anchors.fill: parent;
                        acceptedButtons: Qt.RightButton|Qt.LeftButton;

                        hoverEnabled: true;
                        onClicked: {
                            if (mouse.button == Qt.RightButton) {
                                //if(chatFilePath.length<=0)contents.selectAll();
                                editrightbuttonmenu.open();
                            }

                        }
                        Menu{
                            id:editrightbuttonmenu
                            MenuItem
                            {
                               // visible:(chatFilePath.length>0)
                                text: qsTr( "复制")
                                onTriggered:
                                {
                                   // edit.paste();
                                    edit.copy();
                                }
                            }
                            MenuItem
                            {
                               // visible:(chatFilePath.length>0)
                                text: qsTr( "粘贴")
                                onTriggered:
                                {
                                    edit.paste();
                                    var str = fileio.findfilepathUseRegExp(edit.text)

                                    if(str!= "")
                                    {
                                        console.log("粘贴文件",str);
                                        var strfilepath;
                                        var strlist = str.toString().split("---");
                                        for(var i = 0;i<strlist.length-1;i++)
                                        {
                                             strfilepath = strlist[i]
                                        var tempFile = strfilepath.toString().split("/");
                                        console.log("strfile", strfilepath)
                                        var MessageKey =strOid + "pq";
                                        var strUrl;
                                        var _sUuid =Query.uuid();
                                        fileUploadUuid=_sUuid; //记录此次上传的uuid

                                        var  s1 =strfilepath;
                                        var  s2 =downLoadManager.strGetFilePath("2");
                                        var  s3 =s2+tempFile[tempFile.length - 1];
                                        fileio.copyFile(s1,s3,s2)
                                        if(findimg(strfilepath) == 1)
                                        {
                                            if(fileio.getfilesize(strfilepath)>1024*1024*2)
                                            {
                                                appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",groupName)
                                                var strMessage1 = "{\"type\":\"file\",\"data\":";
                                                strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                                strMessage1 += ",\"send_time\":\"";
                                                strMessage1 += getTime() ;
                                                strMessage1 += "\",\"uuid\":\"";
                                                strMessage1 +=_sUuid;
                                                strMessage1 += "\",\"callback\":\"";
                                                strMessage1 +="1" ;
                                                strMessage1 += "\"}";

                                                strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                        + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                                        + "&msg_type=1&charset=utf-8";//+MessageKey

                                                if( chatTransferFile.start(strUrl,strfilepath,jessonid,roomId))
                                                {
                                                    //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                                    var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请稍候。";
                                                    appendSendData(sendtext, 0, "0", "", "",jid,"0");
                                                    //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1",mainwindow.oneselfName)


                                                }
                                                console.log("fileDialog file___",strUrl)
                                                edit.text = "";
                                                return

                                            }

                                            appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",groupName)
                                            var strMessage = "{\"type\":\"img\",\"data\":";
                                            strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                            strMessage += ",\"send_time\":\"";
                                            strMessage += getTime() ;
                                            strMessage += "\",\"uuid\":\"";
                                            strMessage +=_sUuid;
                                            strMessage += "\",\"callback\":\"";
                                            strMessage +="1" ;
                                            strMessage += "\"}";
                                            strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                    + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                                    + "&msg_type=1&charset=utf-8"//+MessageKey
                                            if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                            {

                                                appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")
                                            }
                                            console.log("fileDialog img___",  strUrl)
                                        }
                                        else
                                        {
                                            appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",groupName)
                                            var strMessage1 = "{\"type\":\"file\",\"data\":";
                                            strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                            strMessage1 += ",\"send_time\":\"";
                                            strMessage1 += getTime() ;
                                            strMessage1 += "\",\"uuid\":\"";
                                            strMessage1 +=_sUuid;
                                            strMessage1 += "\",\"callback\":\"";
                                            strMessage1 +="1" ;
                                            strMessage1 += "\"}";
                                            strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                    + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                                    + "&msg_type=1&charset=utf-8";//+MessageKey
                                            if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                            {
                                                var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请稍候。";
                                                appendSendData(sendtext, 0, "0", "", "",jid,"0");
                                               // appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")

                                            }
                                            console.log("fileDialog file___",strUrl)
                                        }
                                       }
                                        edit.text = "";
                                    }

                                }
                            }



                    }
                  }

                    Flickable {
                        id: flick
                        width: parent.width-20
                        height: parent.height-30
                        anchors.top: parent.top
                        anchors.left: parent.left
                        anchors.leftMargin: 10
                        contentWidth: edit.paintedWidth
                        contentHeight: edit.paintedHeight
                        clip: true

                        function ensureVisible(r)
                        {
                            if (contentX >= r.x)
                                contentX = r.x;
                            else if (contentX+width <= r.x+r.width)
                                contentX = r.x+r.width-width;
                            if (contentY >= r.y)
                                contentY = r.y;
                            else if (contentY+height <= r.y+r.height)
                                contentY = r.y+r.height-height;
                        }

                        TextEdit {
                            id: edit
                            width: flick.width
                            height: flick.height+font.pixelSize*edit.lineCount*2//flick.height -30
                            anchors.top: parent.top
                            anchors.left: parent.left
                            focus: true
                            wrapMode: TextEdit.Wrap
                            selectByMouse: true
                            onCursorRectangleChanged: flick.ensureVisible(cursorRectangle)
                            mouseSelectionMode: TextEdit.SelectCharacters
                            selectionColor: "#9BCAEF"
                            cursorVisible: true
                            Keys.enabled: true;
                            font.wordSpacing: 1.0
                            font.family: "微软雅黑"
                            font.pixelSize: 14
                            font.weight: Font.Normal
                            renderType: Text.NativeRendering
                            activeFocusOnPress:true
                            smooth: true
                            onFocusChanged: {
                                if(edit.focus)
                                {
                                    inputRect.color = "#f5faff"
                                    toolbar.color = "#f5faff"
                                }
                                else
                                {
                                    inputRect.color = "#EBF3F8"
                                    toolbar.color = "#EBF3F8"
                                }
                            }
                            Keys.onPressed:
                            {
                             //  var keyboard  = fileio.readIniFile("SendMsg","keyboard");
                              //  console.log("event.key----",event.key);
                                var keyboard  = fileio.readIniFile("SendMsg","keyboard");
                                                        if(keyboard === "Enter")
                                                        {
                                                            if (Qt.Key_Return===event.key )  //未找到ctrl控制键。先用事件ID代替
                                                            {
                                                                if(event.modifiers & Qt.ControlModifier)
                                                                {
                                                                     console.log("1111111111115");
                                                                   // edit.insert(edit.text.length,"\n");
                                                                   // edit.insert(edit.text.length,"\n");
                                                                }
                                                                else
                                                                {
                                                                    console.log("11111111114444");

                                                                   if(edit.text.length == 0)
                                                                    {
                                                                        return;
                                                                    }

                                                                    akeyflag = false;
                                                                    //_btnSendmsg();
                                                                   var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                                                                   Query.querygetRoomPerson(room_url, getRoomPerson,1)
                                                                  //released(Qt.Key_Return);
                                                                }
                                                            }

                                                        }
                                                        else
                                                        {
                                                            if (Qt.Key_Return===event.key )  //未找到ctrl控制键。先用事件ID代替
                                                            {
                                                                if(event.modifiers & Qt.ControlModifier)
                                                                {
                                                                    console.log("11111111114444");
                                                                   if(edit.text.length == 0)
                                                                    {
                                                                        return;
                                                                    }

                                                                   akeyflag = false;
                                                                   //_btnSendmsg();

                                                                   var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                                                                   Query.querygetRoomPerson(room_url, getRoomPerson,1)
                                                                }
                                                                else
                                                                {

                                                                }
                                                            }

                                                        }

       if(event.key === Qt.Key_V )
       {
           if(event.modifiers && Qt.ControlModifier)
           {
           edit.paste();
           //console.log("进入86")
           console.log(edit.text)
           var str = fileio.findfilepathUseRegExp(edit.text)
           edit.undo();
           //edit.text = "";
           console.log("粘贴文件",str);
           if(str!= "")
           {
               var strfilepath;
               var strlist = str.toString().split("---");
               for(var i = 0;i<strlist.length-1;i++)
               {
                    strfilepath = strlist[i]



               var tempFile = strfilepath.toString().split("/");
               console.log("strfile", strfilepath)
               var MessageKey =strOid + "pq";
               var strUrl;
               var _sUuid =Query.uuid();
               fileUploadUuid=_sUuid; //记录此次上传的uuid

               //  if(strFileType == "1") file
               //   if(strFileType == "2") img
               //   if(strFileType == "3")voice

               var  s1 =strfilepath;
               var  s2 =downLoadManager.strGetFilePath("2");
               var  s3 =s2+tempFile[tempFile.length - 1];

               fileio.copyFile(s1,s3,s2)

               if(findimg(strfilepath) == 1)
               {
                   if(fileio.getfilesize(strfilepath)>1024*1024*2)
                   {
                       appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",groupName)
                       var strMessage1 = "{\"type\":\"file\",\"data\":";
                       strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                       strMessage1 += ",\"send_time\":\"";
                       strMessage1 += getTime() ;
                       strMessage1 += "\",\"uuid\":\"";
                       strMessage1 +=_sUuid;
                       strMessage1 += "\",\"callback\":\"";
                       strMessage1 +="1" ;
                       strMessage1 += "\"}";

                       strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                               + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                               + "&msg_type=1&charset=utf-8";//+MessageKey

                       if( chatTransferFile.start(strUrl,strfilepath,jessonid,roomId))
                       {
                           //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                           var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请稍候。";
                           appendSendData(sendtext, 0, "0", "", "",jid,"0");
                           //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1",mainwindow.oneselfName)


                       }
                       console.log("fileDialog file___",strUrl)
                       edit.undo();
                       edit.text = "";
                       return;
                   }

                   appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",groupName)
                   var strMessage = "{\"type\":\"img\",\"data\":";
                   strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                   strMessage += ",\"send_time\":\"";
                   strMessage += getTime() ;
                   strMessage += "\",\"uuid\":\"";
                   strMessage +=_sUuid;
                   strMessage += "\",\"callback\":\"";
                   strMessage +="1" ;
                   strMessage += "\"}";

                   strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                           + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                           + "&msg_type=1&charset=utf-8"//+MessageKey

                   //chatTransferFile.setStrJessionId(jessonid)
                   //chatTransferFile.setServerAddr(strUrl);
                   //chatTransferFile.setPostFilePath(strfile[1]);
                   if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                   {
                      // appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")


                   }
                      edit.text = "";

                   console.log("fileDialog img___",  strUrl)

               }
               else
               {
                   appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",groupName)
                   var strMessage1 = "{\"type\":\"file\",\"data\":";
                   strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                   strMessage1 += ",\"send_time\":\"";
                   strMessage1 += getTime() ;
                   strMessage1 += "\",\"uuid\":\"";
                   strMessage1 +=_sUuid;
                   strMessage1 += "\",\"callback\":\"";
                   strMessage1 +="1" ;
                   strMessage1 += "\"}";


                   strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                           + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                           + "&msg_type=1&charset=utf-8";//+MessageKey

                  /* chatTransferFile.setStrJessionId(jessonid)
                   chatTransferFile.setServerAddr(strUrl);
                   chatTransferFile.setPostFilePath(strfile[1]);*/
                   if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                   {
                       var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请稍候。";
                       appendSendData(sendtext, 0, "0", "", "",jid,"0");
                      // appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")

                   }
                   console.log("fileDialog file___",strUrl)               }
              }
               edit.text = "";
           }
        ckeyflag=true
           }
       }


                               // if (event.key === Qt.Key_Enter)
                               if (event.key === Qt.Key_Alt) { //alt键
                                   akeyflag=true;
                                   //event.accepted = true;
                                   console.log("sendbtn 组合键 Key_Alt",akeyflag);
                                   console.log("sendbtn 组合键 Key_Alt11111",akeyflag);
                               }

                               if (event.key === Qt.Key_C && akeyflag)  //alt + c 键
                               {
                                   console.log("sendbtn 组合键 alt + c ",akeyflag);

                                  // groupchatwindow.close();
                               groupchatwindow.deleteitem(jid);
                                   //edit.text=""
                               }
                               if (event.key === Qt.Key_S && akeyflag)  //alt + S 键
                                               {
                                    ckeyflag = true;
                                                 //  console.log("sendbtn 组合键 alt + S ",akeyflag);
                                                 //  chatwindow.close();
                                                   if(edit.text.length == 0)
                                                   {
                                                       return;
                                                   }
                                                   //_btnSendmsg();
                                                   var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                                                   Query.querygetRoomPerson(room_url, getRoomPerson,1)
                                                   }

                               if(event.key === Qt.Key_Escape)//esc键
                               {
                                   console.log("sendbtn 组合键 esc键",akeyflag);
                                   chatwindow.close()
                               }
                            }



                        Keys.onReleased: {
                            if(ckeyflag==true){
                                if( fileio.findfilepathUseRegExp(edit.text)!=="")
                                {
                                   edit.clear()
                                }

                            }
                           akeyflag=false
                           ckeyflag=false
                           skeyflag=false
                            console.log("sendbtn 组合键 esc键 ***1**2**BS");
                        }

                        }
                    }

                    /*Rectangle {
                        id: closebtn
                        anchors.bottom: parent.bottom
                        anchors.bottomMargin: 5
                        anchors.right: sendbtn.left
                        anchors.rightMargin: 5
                        width: 80
                        height: 25
                        border.width: 1
                        border.color: "#069DD5"
                        radius: 5
                        color: "#069DD5"
                        Text{
                            id:closeText
                            text: qsTr("关闭(A)")
                            anchors.centerIn: parent
                            font.family: "微软雅黑"
                            color: "#FFFFFF"
                        }

                        MouseArea{
                            id: closeMouse
                            anchors.fill: parent
                            hoverEnabled: true

                            onEntered: {
                                closebtn.color = "#16b0e9"
                            }

                            onExited: {
                                closebtn.color = "#069DD5"
                            }

                            onClicked: {
                                // groupchatwindow.close()
                                groupchatwindow.deleteitem(jid)
                            }
                        }
                    }*/
                    Rectangle {
                        id: closebtn
                        anchors.bottom: parent.bottom
                        anchors.right: button_sendmsg.left
                        anchors.rightMargin: 10
                        anchors.bottomMargin: 5
                        width: 80
                        height: 25
                        border.width: 1
                        border.color: "#069DD5"
                        radius: 5
                        color: "#069DD5"
                        Text{
                            id:closeText
                            text: qsTr("关闭 (C)")
                            font.pixelSize: 15
                            anchors.centerIn: parent
                            font.family: "微软雅黑"
                            color: "#FFFFFF"
                        }

                        MouseArea{
                            id: closeMouse
                            anchors.fill: parent
                            hoverEnabled: true

                            onEntered: {
                                closebtn.color = "#16b0e9"
                            }

                            onExited: {
                                closebtn.color = "#069DD5"
                            }

                            onClicked: {
                                voiceRect.visible = false
                                voicetimer.stop();
                                voice.checked = 0
                                voiceicon_timer.stop();
                                voiceprogressbar.value = 0;
                                chatVoiceMessage.stopRecorder(false);
                                elapseTime = 0
                                deleteitem(jid)
                                groupchatwindow.deleteitem(jid)
                            }
                        }
                    }
                    CheckedIconButton {
                                   id: button_sendmsg
                                   anchors.bottom: parent.bottom
                                   anchors.right: button_sendmsgmodechang.left
                                   anchors.rightMargin: 0
                                   anchors.bottomMargin: 5
                                   width: 80
                                   height: 25

                                   Text{
                                       text: qsTr("发送(S)")
                                        font.pixelSize: 15
                                        font.family: "微软雅黑"
                                        color: "#FFFFFF"
                                        anchors.centerIn: parent
                                   }
                                   hoveredIcon :"qrc:/resource/images/im/send_hovered.png"
                                   normalIcon: "qrc:/resource/images/im/send_normal.png"
                                   checkedIcon:"qrc:/resource/images/im/send_checked.png"
                                   onClicked: {
                                      // groupUserwindow.deleteitem()
                                       var room_url=strip+"/im/getRoomPerson?roomOf="+jid
                                       Query.querygetRoomPerson(room_url, getRoomPerson,1)
                                   }
                               }
                    CheckedIconButton {
                        id: button_sendmsgmodechang
                        anchors.bottom: parent.bottom
                        anchors.right: parent.right
                        anchors.rightMargin: 10
                        anchors.bottomMargin: 5
                        width: 25
                        height: 25
                       // text: qsTr("")
                        hoveredIcon :"qrc:/resource/images/im/sendmsgmode_hovered.png"
                        normalIcon: "qrc:/resource/images/im/sendmsgmode_normal.png"
                        checkedIcon:"qrc:/resource/images/im/sendmsgmode_checked.png"
                        onClicked: {
                            sendmsgmodechangMenu.open();

                        }


                            Menu {
                                id: sendmsgmodechangMenu

                            MenuItem {
                                id:sendmsgmodechangMenu1
                                text:
                                    if(fileio.readIniFile("SendMsg", "keyboard")=="Ctrl+Enter")
                                       return "√按Ctrl+Enter键发送"
                                    else
                                       return "按Ctrl+Enter键发送"

                                onTriggered: {
                                    fileio.writeIniFile("SendMsg","keyboard","Ctrl+Enter");
                                    this.text= "√按Ctrl+Enter键发送"
                                    sendmsgmodechangMenu2.text="按Enter键发送"
                                }
                            }
                            MenuItem {
                                id:sendmsgmodechangMenu2
                                text:
                                if(fileio.readIniFile("SendMsg", "keyboard")=="Enter")
                                   return "√按Enter键发送"
                                else
                                   return "按Enter键发送"
                                onTriggered: {
                                    fileio.writeIniFile("SendMsg","keyboard","Enter");
                                    this.text= "√按Enter键发送"
                                    sendmsgmodechangMenu1.text="按Ctrl+Enter键发送"
                                }
                            }
                         }
                    }

                }
            }

        }
        DropArea{
               anchors.fill:  parent
             onDropped: {

                   console.log("拖放了文件: " + drop.urls.length);
                   if (drop.hasUrls){
                      console.log("拖放了文件: " + drop.urls.length);
                       for(var i = 0; i < drop.urls.length; i++){
                           //console.log("文件: " + drop.urls[i]);

                            edit.insert(edit.text.length,"文件: " + drop.urls[i])
                           //edit.paste();
                           var str1 = fileio.findfilepathUseRegExp(edit.text);
                           var str= fileio.percentEncoding2ByteArray(str1);

                           console.log("粘贴文件",str);
                           if(str!=="")
                           {
                               var strfilepath;
                               var strlist = str.toString().split("---");
                               for(var j = 0;j<strlist.length-1;j++)
                               {
                                    strfilepath = strlist[j]
                               var tempFile = strfilepath.toString().split("/");
                               console.log("strfile", strfilepath)
                               var MessageKey =strOid + "pq";
                               var strUrl;
                               var _sUuid =Query.uuid();
                               fileUploadUuid=_sUuid; //记录此次上传的uuid

                               var  s1 =strfilepath;
                               var  s2 =downLoadManager.strGetFilePath("2");
                               var  s3 =s2+tempFile[tempFile.length - 1];
                               fileio.copyFile(s1,s3,s2)
                               if(findimg(strfilepath) == 1)
                               {
                                   if(fileio.getfilesize(strfilepath)>1024*1024*2)
                                   {
                                       appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",groupName)
                                       var strMessage1 = "{\"type\":\"file\",\"data\":";
                                       strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                       strMessage1 += ",\"send_time\":\"";
                                       strMessage1 += getTime() ;
                                       strMessage1 += "\",\"uuid\":\"";
                                       strMessage1 +=_sUuid;
                                       strMessage1 += "\",\"callback\":\"";
                                       strMessage1 +="1" ;
                                       strMessage1 += "\"}";

                                       strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                               + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                               + "&msg_type=1&charset=utf-8";//+MessageKey

                                       if( chatTransferFile.start(strUrl,strfilepath,jessonid,roomId))
                                       {
                                           //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                           var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请稍候。";
                                           appendSendData(sendtext, 0, "0", "", "",jid,"0");
                                           //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1",mainwindow.oneselfName)

                                       }
                                       console.log("fileDialog file___",strUrl)
                                       edit.text = "";
                                       return;

                                   }

                                   appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",groupName)
                                   var strMessage = "{\"type\":\"img\",\"data\":";
                                   strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                   strMessage += ",\"send_time\":\"";
                                   strMessage += getTime() ;
                                   strMessage += "\",\"uuid\":\"";
                                   strMessage +=_sUuid;
                                   strMessage += "\",\"callback\":\"";
                                   strMessage +="1" ;
                                   strMessage += "\"}";
                                   strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                           + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                           + "&msg_type=1&charset=utf-8"//+MessageKey
                                   if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                   {

                                       //appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")
                                   }
                                   console.log("fileDialog img___",  strUrl)
                               }
                               else
                               {
                                   appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",groupName)
                                   var strMessage1 = "{\"type\":\"file\",\"data\":";
                                   strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                   strMessage1 += ",\"send_time\":\"";
                                   strMessage1 += getTime() ;
                                   strMessage1 += "\",\"uuid\":\"";
                                   strMessage1 +=_sUuid;
                                   strMessage1 += "\",\"callback\":\"";
                                   strMessage1 +="1" ;
                                   strMessage1 += "\"}";
                                   strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                           + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                                           + "&msg_type=1&charset=utf-8";//+MessageKey
                                   if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                   {
                                       var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请稍候。";
                                       appendSendData(sendtext, 0, "0", "", "",jid,"0");
                                      // appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")

                                   }
                                   console.log("fileDialog file___",strUrl)
                               }
                              }
                               edit.text = "";
                           }
                       }

                   }
                   else if (drop.hasText){
                      console.log("拖放了本文: " + drop.text.length);
                      // console.log("文本: " + drop.text);
                       edit.insert(edit.text.length,"文本: " + drop.text)


                   }





                      }
        }

    }


    //!p3 没有用
    function adduserList(p1,p2,p3) //群增加人员
    {
        console.log("adduserList 群增加人员");
        if(p3 !== "ADD_GROUPUSER_LIST")
            return;

        console.log("adduser:1",p1) // /im/getOutPerson
        console.log("adduser:2",p2) // /im/getOutPerson
        console.log("adduser:3",p3) // /im/getOutPerson

        var obj = eval('(' + p1 + ')');  //eval
        console.log("ADD_GROUPUSER_LIST",obj.quid,groupId,p1)

        if(obj.quid!=groupId)
            return;

        var strhttpip = fileio.readIniFile("login", "dnsip");
        if("newuid" in obj)
        {
            //room_Web.url = strhttpip + "/spirit/groupChat?roomOf="+groupId;
            //room_Web.update();

            //var userids = eval('(' + obj.allPersonnel + ')');  //liuyu
            /* var userlist = "";
            for(var len = 0 ; len < obj.newuid.length;len++)
            {

                if(len  ==  (obj.newuid.length -1))
                    userlist += obj.allPersonnel[len];
                else
                    userlist +=obj.allPersonnel[len]+",";

                var user =  jid+strOid +"pq"+obj.allPersonnel[len]+"@gsubo";
             }*/
            var _suuid = Query.uuid()
            talkRoomIntface._vAddGroudUser(obj.newuid,obj.newname,obj.quid,groupName,mainwindow.oneselfName,_suuid);
        }

        room_Web.url = strhttpip + "/spirit/groupChat?roomOf="+groupId;

    }

    function adduser(roomid,userid)
    {
        var strip = fileio.readIniFile("login", "dnsip")
        if(roomId=="1")
        {

        }

        var request = strip+ "/im/getPersonToRoom?&invite_uid=";


        // "{\"createUid\":\"109\",\"allPersonnel\":[\"251\",\"131\",\"108\"]}"  ""   "ADD_GROUPUSER_LIST"

    }

    function deluser(roomid,userid) //函数废弃
    {
        var strip = fileio.readIniFile("login", "dnsip")
        console.log("删除群用户deluser:",strip+ "/im/getPersonToRoom?&delete_uid=105,106,107&room_id="+ groupId+ "&opt=1",jessonid) // /im/getOutPerson   参数: room_id   delete_uid(要删除的人uid)    opt=1
        webrun._slot_request(strip+ "/im/getPersonToRoom?&delete_uid=105,106,107&room_id="+ groupId+ "&opt=1",jessonid);
    }

    function changeRoomName(roomid,name)
    {
        var strip = fileio.readIniFile("login", "dnsip")
        console.log("groudmsglist_",groudmsglist)
        console.log("修改群名称:",strip+ "/im/updateRoomName?&room_name="+name+"&room_id="+ roomid,jessonid)  ///im/updateRoomName  参数: room_name  room_id
        _room_changeGroupName(roomid,name)
        webrun._slot_request(strip+ "/im/updateRoomName?&room_name="+name+"&room_id="+ roomid,jessonid);
    }

    function  _getWebUserList(info,id,is)
    {
        console.log("_getWebUserList______________");
        console.log("_getWebUserList_",info);
        console.log("_getWebUserList_",id);
        console.log("_getWebUserList_",is);
    }

    function getMsg(strMsg, chatuserjid)
    {

        console.log("这是看是否接收到了消息",chatuserjid ,jid,strOid);
        if(chatuserjid == jid)
        {
            appendReceiveData(strMsg, 1, "");
        }

    }

    //接收openfire消息
    function appendReceiveData(str, iflag, chatfilepath)
    {
        var tmp  = "";
        var tmwp = str;
        var msgStat = "";
        var msgUuid = "";   //消息ID
        var Gjid = "";      //群ID
        var Ujid = "";      //用户ID
        var SUjid = "";     //发送用户ID
        chatisopenfirereverfile1="1"

        //console.log("appendReceiveData(str1, iflag, chatfilepath)")
        //console.log("appendReceiveData(",str, iflag, chatfilepath)

        //(  1520302505335@gsrooms.gsubo/150/1001pq107@gsubo/PC+2018-03-06 10:32:39/89180283-CF5C-4D87-9C5A-6C071F69F6FA
        //   @@!!@@**@@
        //   {"type":"text","data":"你们好","send_time":"1520303738.578770"}

        msgStat = tmwp.split("@@!!@@**@@")[0];
        str = tmwp.split("@@!!@@**@@")[1];

        Gjid =msgStat.split("/")[0];
        Ujid =msgStat.split("/")[1];
        SUjid =msgStat.split("/")[2];
        msgUuid =msgStat.split("/")[4];

        // console.log("appendReceiveData Gjid_",Gjid)
        //console.log("appendReceiveData Ujid_",Ujid)
        //console.log("appendReceiveData SUjid_",SUjid)
        // console.log("appendReceiveData msgUuid_",msgUuid)

        // if(!Ujid.indexOf("pq")<0 && Ujid.indexOf("@gsrooms")<0)
        // {
        //     Ujid = Ujid.split("pq")[0] +"pq"+Ujid;
        // }

        //   console.log("appendReceiveData(str, iflag, chatfilepath)")
        //   console.log("appendReceiveData(",str, iflag, chatfilepath,Gjid,Ujid,strOid,msgUuid,SUjid)


        for(var count = 0; count < groupChatModel.count;count++)
        {
            if(groupChatModel.get(count).uuid == msgUuid)
                return;
        }

        var obj = JSON.parse(str);

        var strMsgType;

        if(obj.type === "text")
        {
            tmp = obj.data.replace(/\\n/g,"\n");
            tmp = tmp.replace(/</g,"&lt;");
            strMsgType = "0";
        }
        else if(obj.type === "file")
        {
            tmp = str;
            strMsgType = "1";
        }
        else if(obj.type === "img")
        {
            tmp = str;
            strMsgType = "2";
        }
        else if(obj.type === "voice")
        {
            tmp = str;
            strMsgType = "3";
        }
        else if(obj.type === "shaking")
        {
            tmp = str;
            strMsgType = "4";
        }
        else if(obj.type === "groupgeneral")
        {
            //tmp = str;
            tmp = obj.data.replace(/\\n/g,"\n");
            strMsgType = "5";
        }

        if(Ujid == SUjid.split("@")[0] && strMsgType!=5) //群管理消息允许显示自己发的
            return;


        //var curTime=new Date().getTime();//结果：1280977330748
        var curTime=obj.send_time;//obj.send_time
        console.log("群聊窗口接收Openfie消息并获取时间--------",obj.send_time);
        var tmpTime  = curTime;//obj.send_time;
        var strsource = "";
        var strHeadIcoUrl;


        var listKey =userinfoMap.getkeys();

        console.log(listKey.length);
        console.log(userinfoMap.get( Ujid ),Ujid);

        /*if(userinfoMap.containsKey( Ujid ) )
        {
            strHeadIcoUrl=userinfoMap.get( Ujid );
            console.log(" appendReceiveData containsKey:"+ strHeadIcoUrl,Ujid)
        }
         else if(avatar !== "0" && avatar !== "1" && avatar !== "" && avatar !== null)
        {
            strHeadIcoUrl=avatar;
            console.log(" appendReceiveData:"+ strHeadIcoUrl)
        }
       else if(chatsex === "0")
        {
            console.log(" appendReceiveData0:")
            strHeadIcoUrl = "qrc:/resource/images/im/chatman (2).png"
        }
        else
        {
            console.log(" appendReceiveData1:")
            strHeadIcoUrl = "qrc:/resource/images/im/chatwoman (2).png"
        }*/

        String.prototype.endsWith=function(endStr){
            var d=this.length-endStr.length;
            return (d>=0&&this.lastIndexOf(endStr)==d)
        }

        if(iflag === 1)
        {
            if(obj.type === "file")
            {
                var strFileSize = obj.data.file_size;
                if(strFileSize.endsWith("MB"))
                {
                    console.log("append MB____",strFileSize.substr(0,strFileSize.length-2));
                    iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024 *1024;
                }
                else if(strFileSize.endsWith("KB"))
                {
                    console.log("append KB____",strFileSize.substr(0,strFileSize.length-2));
                    iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024;
                }
                else
                {
                    console.log("append null__",strFileSize);
                    iReceived = Number(strFileSize)* 1024;
                }

                //if(typeof tmpTime == "Number")
                tmpTime = tmpTime.toString();


                //console.log("append 222 ");
                //console.log("append1",tmpTime)
                groupChatModel.append({"chatname1": obj.name, "chathead":"", "chatcontents1":tmp, "chatflag1":1,"chattime1":obj.tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false , "chatfilepath": downLoadManager.strGetFilePath("1"), "chatvoicetime":"","uuid":msgUuid
                                          ,"downloadFile":true});


                //获取登录的地址
                var loginAddressFile = fileio.getLoginAddress();

                //openfire直接收到的文件,小于2M的文件自动下载
                if(iReceived<2*1024*1024)
                {
                    //var sendtext = "文件："+obj.data.file_name +" 正在下载中，请稍候。";
                    //appendSendData(sendtext, 0, "0", "", "",jid,"0");
                    receiverFileName=obj.data.file_name;
                    downLoadManager.downloadFile(loginAddressFile+"/xs?"+obj.data.file_url, obj.data.file_name, "1",tmpTime,jid,obj.uuid);
                    console.log("群聊,openfire直接收到的文件,小于2M的文件自动下载",tmpTime)
                }

            }
            else if(obj.type === "img")
            {
                var strFileSize1 = obj.data.file_size;
                if(strFileSize1.endsWith("MB"))
                {
                    iReceived = Number(strFileSize1.substr(0,strFileSize1.length-2)) * 1024 *1024;
                }
                else if(strFileSize1.endsWith("KB"))
                {
                    iReceived = Number(strFileSize1.substr(0,strFileSize1.length-2)) * 1024;
                }
                else
                {
                    iReceived = Number(strFileSize1)*1024;
                }

                //if(typeof tmpTime == "Number")
                tmpTime = tmpTime.toString();

                //console.log("append2",tmpTime)
                groupChatModel.append({"chatname1": obj.name, "chathead":"", "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false  , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":"","uuid":msgUuid});


                //openfire直接收到的图片,自动下载
                receiverFileName=obj.data.file_name;
                //获取登录的地址
                var loginAddressImg= fileio.getLoginAddress();
                downLoadManager.downloadFile(loginAddressImg+"/xs?"+obj.data.file_url, obj.data.file_name, "2",obj.send_time,jid,obj.uuid);

            }
            else if(obj.type === "voice")
            {
                //处理语音消息接受

                var strUrl = obj.data.file_url.split("=");
                //console.log("url",strUrl[strUrl.length - 1])

                var strVoiceTime = obj.data.voice_time
                //console.log(strVoiceTime)

                //if(typeof tmpTime == "Number")
                tmpTime = tmpTime.toString();

                //console.log("append3",tmpTime)

                groupChatModel.append({"chatname1": obj.name, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false  , "chatfilepath": (downLoadManager.strGetFilePath("3") + strUrl[strUrl.length - 1]),
                                          "chatvoicetime": strVoiceTime,"uuid":msgUuid});



            }
            else if(obj.type === "text")
            {

                //if(typeof tmpTime == "Number")
                tmpTime = tmpTime.toString();

                console.log("append4",tmpTime)
                groupChatModel.append({"chatname1": obj.name, "chathead":"", "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false  , "chatfilepath": "", "chatvoicetime":"","uuid":msgUuid});
            }
            else if(obj.type === "shaking") //解析抖屏数据
            {
                console.log("抖屏",tmp)
                shake_window.start()
            }
            else if(obj.type === "groupgeneral") //群管理消息
            {
                console.log("群管理消息")
                tmpTime = tmpTime.toString();
                groupChatModel.append({"chatname1": obj.name, "chathead":"", "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": "0", "chatfiledata": "0.0", "bisreceived": false  , "chatfilepath": "", "chatvoicetime":"","uuid":msgUuid}); //,"bIsMucRoomHandleMsg":true})
            }


            //    for(var i=0;i<groupChatModel.count;i++)
            //    {
            //        console.log(groupChatModel.get(i).uuid ,msgUuid);
            //
            //        if(groupChatModel.get(i).uuid ==msgUuid)
            //        {
            //            console.log("groupChatModel.get(i).callback:",tmpTime);
            //            console.log("groupChatModel.get(i).callback:", groupChatModel.get(i).callback);
            //            groupChatModel.setProperty(i, "callback", "1");
            //            groupChatModel.setProperty(i-1, "callback", "1");
            //            console.log("groupChatModel.get(i).callback:", groupChatModel.get(i).callback);
            //            console.log("groupChatModel.get(i).callback:", groupChatModel.get(i-1).callback);
            //        }
            //    }

            groupchatwindow.isReceivedAll = false;
        }
        else
        {
            console.log(" ERROR_appendReceiveData_ 这是接收数据"+ str ,typeof str )
            console.log(" ERROR_appendReceiveData_这是接收数据"+ iflag ,typeof iflag )
        }

        groupchatView.positionViewAtEnd();
    }



    function creatUserInfoObj(vatar1,userName1,userId1,userIden1,sexIco1,phoneNum1,department1)
    {
        var component = Qt.createComponent("userinfo.qml");

        //    console.log("vatar1);         ",vatar1);
        //    console.log("userName1);      ",userName1);
        //    console.log("userId1);        ",userId1);
        //    console.log("userIden1);      ",userIden1);
        //    console.log("sexIco1);        ",sexIco1);
        //    console.log("phoneNum1);      ",phoneNum1);f
        //    console.log("department1);    ",department1);

        //  console.log("__@_2")
        if (component.status === Component.Ready)
        {
            //console.log("__@322")
            if(userinfoObj === null)
            {
                userinfoObj = component.createObject(window.parent, {"vatar": vatar1
                                                         , "userName": userName1
                                                         , "userId": userId1
                                                         , "userIden": userIden1
                                                         , "sexIco":sexIco1
                                                         ,"phoneNum":phoneNum1
                                                         ,"department":department1
                                                         , "visible": true});
            }

            //  obj = component.createObject(window.parent, {"vatar": vatar1
            //                                   , "userName": userName1
            //                                   , "userId": userId1
            //                                   , "userIden": userIden1
            //                                   , "sexIco":sexIco1
            //                                   ,"phoneNum":phoneNum1
            //                                   ,"department":department1});
        }

        if(userinfoObj === null)
        {
            console.log("__@111")
        }
        else
        {
            userinfoObj.deleteitem.connect(groupchatwindow.deleteuserinfoObj)
        }
    }

    function deleteuserinfoObj()
    {
        if(userinfoObj == null)
        {
            return;
        }

        userinfoObj.deleteitem.disconnect(groupchatwindow.deleteuserinfoObj)

        userinfoObj.destroy()
        userinfoObj = null
        console.log("删除deleteuserinfoObj")
    }

    function findSameTime(str)
    {
        for(var i=0;i<groupChatModel.count;i++)
        {
            if(groupChatModel.count == 0)
            {
                return false;
            }

            if(isSameTime(groupChatModel.get(i).chattime1,str))
            {
                return true;
            }
            else
            {
                continue;
            }
        }
        return false;
    }

    function getFormatData(msecond,iType)
    {
        var dates = new Date((msecond - 0)+ 8*3600);
        if(iType == 0)
        {
            return dates.getUTCFullYear().toString();
        }
        else if(iType == 1)
        {
            return dates.getMonth().toString();
        }
        else if(iType == 2)
        {
            return dates.getDate().toString();
        }
        else if(iType == 3)
        {
            return dates.getHours().toString();
        }
        else if(iType == 4)
        {
            return dates.getMinutes().toString();
        }
    }

    function isSameTime(strModel,str)
    {
        var tmpTime = strModel;

        if(getFormatData(tmpTime,0) === getFormatData(str,0))
        {
            if(getFormatData(tmpTime,1) === getFormatData(str,1))
            {
                if(getFormatData(tmpTime,2) === getFormatData(str,2))
                {
                    if(getFormatData(tmpTime,3) === getFormatData(str,3))
                    {
                        if(getFormatData(tmpTime,4) === getFormatData(str,4))
                        {
                            return true;
                        }
                        else
                        {
                            return false;
                        }
                    }
                }
            }
            return false;
        }
        else
        {
            return false;
        }
    }

    function filterImg(str){
        for(var i=0;i<tmpModel.count;i++)
        {
            var curTitle=tmpModel.get(i).title2;
            var curPath = "<img src="+tmpModel.get(i).path+"/>";
            var reg = new RegExp(curTitle, "ig");
            str = str.replace(reg, curPath);
        }
        var orgStr =str.replace(/<<(.+?)>>/gi,"&lt;&lt;$1&gt;&gt;");
        orgStr.replace(/'/gi,"&#39;")
        return orgStr;
    }

    function getTime()
    {
        var timestamp = Date.parse(new Date());
        timestamp = timestamp/1000.0
        timestamp = timestamp.toString()

        console.log("timestamp:____"+timestamp);
        return timestamp + "";
    }

    function sendMsgResult(userJSON,sendtext,uuid)
    {
        console.log("发送消息到OA服务器接口返回数据:",userJSON, sendtext)
        if(userJSON.indexOf("IMok")>-1||userJSON.indexOf("ok")>-1)
        {
            //appendSendData(sendtext, 0, "0", "", "",uuid,"0");
            //singleChat.sendMsg(0, sendtext,  strOid + "pq"+jid + "@gsubo",uuid,false,mainwindow.oneselfName);
            talkRoomIntface.sendGroudRoomMsg(0,sendtext,groupId,mainwindow.oneselfName,groupName,uuid);
            appendSendData(sendtext, 0, "0", "", "",uuid,"0",mainwindow.oneselfName);
            console.log("发送消息到OA服务器接口返回数据:有ok或IMok，发送open fire参数为:",0, sendtext, groupId,uuid,false,mainwindow.oneselfName)


        }
        else
        {
            appendSendData(sendtext+"----"+"发送失败", 0, "0", "", "",uuid,"0");
            console.log("发送消息到OA服务器接口返回数据:没有ok或IMok,不发送openfire消息")
        }
    }

    function sendMsgerror(sendtext,uuid)
    {
       // appendSendData(sendtext+"----"+"发送失败", 0, "0", "", "",uuid,"0");
         appendSendData(sendtext+"----"+"发送失败", 0, "0", "", "",uuid,"0",mainwindow.oneselfName);
        console.log("发送消息到OA服务器接口返回数据:没有ok或IMok,不发送openfire消息")
    }

    function sendMsgResult2(userJSON,sendtext,uuid) //回执消息
    {
        console.log("发送回执消息到OA服务器接口返回数据:",userJSON, sendtext)
        if(userJSON.indexOf("IMok")>-1||userJSON.indexOf("ok")>-1)
        {
            //appendSendData(sendtext, 0, "0", "", "",uuid,"0");
            console.log("发送回执消息到OA服务器接口返回数据:有ok或IMok，发送open fire参数为:",0, sendtext,  strOid + "pq"+jid + "@gsubo",uuid,false,mainwindow.oneselfName)
            singleChat.sendMsg(0, sendtext,  strOid + "pq"+jid + "@gsubo",uuid,false,mainwindow.oneselfName);
        }
        else
        {
            //appendSendData(sendtext+"----"+"发送失败", 0, "0", "", "",uuid,"0");
            console.log("发送回执消息到OA服务器接口返回数据:没有ok或IMok,不发送openfire消息")
        }

    }

    function sendMsgerror2(sendtext,uuid)
    {
        //appendSendData(sendtext+"----回执发送失败", 0, "0", "", "",uuid,"0");
        console.log("发送回执消息到OA服务器接口返回数据:网络原因,不发送openfire消息")
    }

    function  _btnSendmsg()
    {

        // console.log("_____btnSendmsg_______1______");
        //akeyflag = false;

        if(edit.text.length<=0)
        {
            //     console.log("_____btnSendmsg_______2______");
            return;
        }
       // getuserinfos()
        // console.log("_____btnSendmsg_______3______");
        var _sUuid =  Query.uuid();
        //2018-11-26
        //appendConverList(edit.text, getTime(), jid, "text",strStaus)//源代码strStaus字段错误，没测出原因。收到群聊消息补充了此处错误
        appendConverList(edit.text.replace(/</g,"&lt;"), getTime(), jid, "text",groupName)  //2018-11-26修改   增加到会话列表

        //  console.log("_____btnSendmsg_______4_____");
        // if(callbackmsg)
        // {
        //     singleChat.sendMsg(0, edit.text,  strOid + "pq"+jid + "@gsubo",_sUuid,true);
        //     msgcallback.checked = false;
        //     callbackmsg = false;
        // }
        // else
        // {
        //     singleChat.sendMsg(0, edit.text,  strOid + "pq"+jid + "@gsubo",_sUuid,false);
        // }

        var MessageKey =strOid + "pq";
        console.log("_____btnSendmsg_______5_____",edit.text, 0, "0", "", "",_sUuid,"0");
       // appendSendData(edit.text, 0, "0", "", "",_sUuid,"0",mainwindow.oneselfName);      //增加到界面显示

        // console.log("_____btnSendmsg_______5_____");
        groupchatView.positionViewAtEnd();

        var parm = [];
        parm[0] = 1;
        parm[1] = userjid;
        parm[2] = jid;
        parm[3] = edit.text;
        parm[3]=parm[3].replace(/#/g,"%23");
        parm[3]=parm[3].replace(/\[/g,"%5B");
        parm[3]=parm[3].replace(/\]/g,"%5D");

        parm[4] = "text";       
        parm[5] = userjid + "@gsubo"
        parm[6] = jid
        parm[7] = getTime();
        parm[8] = _sUuid;
        parm[9] = 1;

        var parm1 = [];
        parm1[0] = 5;
        parm1[1] = userjid + "@gsubo"
        parm1[2] = jid
        parm1[3] = getTime();
        parm1[4] = 1;
           var strip = fileio.readIniFile("login", "dnsip")
        var strServer = strip + "/im/putMessage?flag=" + parm[0] +"&from_uid=" +
                parm[1] +"&to_uid=" + parm[2] + "&content=" + parm[3] + "&type=" + parm[4] +
                "&of_from=" +MessageKey+ parm[5] + "&of_to=" + parm[6] + "&stime=" + parm[7]  + "&atime=" + parm[7]*1000+ "&uuid=" +
                parm[8] + "&msg_type=" + parm[9] + "&charset=utf-8"

         console.log("_____group btnSendmsg_____________"+strServer,"555555------"+jessonid);
         Query.sendMessage(strServer,parm,edit.text,strOid + "pq",sendMsgResult,sendMsgerror);
       // talkRoomIntface.sendGroudRoomMsg(0,edit.text,groupId,mainwindow.oneselfName,groupName,_sUuid);
       // chatMessageToServer.sendMsgServer(jessonid, strServer.toString())
        edit.text = "";
         alert(5000);

        // console.log("onCompleted:",strStaus)
        // console.log("onCompleted:",avatar  )
        // console.log("onCompleted:",signature )
        // console.log("onCompleted:",signatureIMG)

    }

    function appendSendData(str, iflag, strmsgtype, chatfilepath, voicetime,uuid,callback,sendername)
    {

        console.log(" function appendSendData(str, iflag, strmsgtype, chatfilepath, voicetime,uuid,callback)")
        console.log(" function appendSendData(",str, iflag, strmsgtype, chatfilepath, voicetime,uuid,callback)

        chatisopenfirereverfile1 = "0"
        var tmp = str;
        tmp = tmp.replace(/</g,"&lt;");
        var curTime=new Date().getTime();//结果：1280977330748

        var tmpTime = Number(curTime);
        var strsource = chatgifsource;
        var strHeadIcoUrl;

        if(iflag === 0)
        {
            strHeadIcoUrl = selfvavtar;
            console.log(" appendSendData发送消息_自己头像:"+ strHeadIcoUrl)
        }

        else  if(userinfoMap.containsKey( obj.from_uid , ""))
        {
            strHeadIcoUrl =userinfoMap.get( obj.from_uid , "")
            console.log(" appendSendData发送消息_别人头像:"+ strHeadIcoUrl)
        }
        else if(chatsex === "0")
        {
            strHeadIcoUrl = "qrc:/resource/images/im/chatman (2).png"
        }
        else
        {
            strHeadIcoUrl = "qrc:/resource/images/im/chatwoman (2).png"
        }



        if(iflag === 0)
        {
            //if(typeof tmpTime == "Number")
                tmpTime = tmpTime.toString();

            console.log("append 1111 ",tmpTime);
            groupChatModel.append({"chatname1": sendername, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime , "chatgifsource1": strsource
                                      , "chatmsgtype": strmsgtype, "chatfiledata":"0.0", "bisreceived": false, "chatfilepath": chatfilepath
                                      ,"chatvoicetime":voicetime,"uuid":uuid,"callback":callback});

        }
        else
        {
            console.log(" ERROR_appendSendData_这不是发送数据"+ str ,typeof str )
            console.log(" ERROR_appendSendData_这不是发送数据"+ iflag ,typeof iflag )
        }

        groupchatView.positionViewAtEnd();
    }

    function appendSendFile(iSend, strMsg)
    {
        if(!isSendAll)
        {
            console.log("appendSendFile1",iSend)
            groupChatModel.setProperty(groupChatModel.count - 1,"chatfiledata",iSend)
            groupChatModel.setProperty(groupChatModel.count - 1,"bisreceived",true)
        }
        else
        {
            console.log("appendSendFile2",iSend)
            groupChatModel.setProperty(groupChatModel.count - 1,"chatfiledata",iSend)
            groupChatModel.setProperty(groupChatModel.count - 1,"bisreceived",true)
        }
    }

    function findimg(strfile)
    {
        var ret = -1;

        for(var i = 0; i < imgformatLower.length; ++i )
        {
            ret = strfile.indexOf(imgformatLower[i])
            if(ret != -1)
            {
                return 1;
            }
        }

        for(var j = 0; j < imgformaUpper.length; ++j)
        {
            ret = strfile.indexOf(imgformaUpper[j])
            if(ret != -1)
            {
                return 1;
            }
        }

        return ret;
    }

    function appendReceivedFile(isReceivedAll)
    {
        console.log("iReceived", iReceived)

        if(!isReceivedAll)
        {
            groupChatModel.setProperty(groupChatModel.count - 1,"chatfiledata",iReceived.toString())
        }
        else
        {
            groupChatModel.setProperty(groupChatModel.count - 1,"chatfiledata",iReceived.toString())
            // groupChatModel.setProperty(groupChatModel.count - 1,"bisreceived",true)

            for(var len = 0; len < groupChatModel.count;len++)
            {
                groupChatModel.setProperty(len,"bisreceived",true)
            }
        }
    }

    //文件发送
    function g_sender(parm1, parm2,struid,strfilepath)
    {
        if(struid!=roomId)return;
        console.log("群发送文件进度", parm1, parm2,struid,strfilepath)
        if(parm1==0||parm2==0)return;
        if(parm1 != parm2)
        {
            var senderFile = parm1 / parm2 + "";
            var senderCount = Number(senderFile.substr(0,5));

            appendSendFile(senderCount.toString(), strMsg);
        }
        else
        {
            console.log("群发送文件:已完成")
            groupchatwindow.isSendAll = true;
            appendSendFile("1.0", strMsg)
        }
    }


    //文件下载
    function g_receiver(parm1, parm2)
    {
        //console.log("下载文件 receiver,parm1:",parm1, parm2)

        groupchatwindow.receiverFile = Number(parm1);  //收到的字节数
        if(parm1 != parm2)
        {
            isReceivedAll = false;
            //chatView.ChatItem.receiverFile1=receiverFile;
            //chatView.ChatItem.isReceivedAll1=isReceivedAll;

            console.log("群收到的字节数 receiverFile:",receiverFile)

            //appendReceivedFile(receiverFile.toString().substring(0,3));
        }
        else
        {
            isReceivedAll = true;
            console.log("群接收文件:已完成,receiverFile:",receiverFile," isReceivedAll:",isReceivedAll);

            // appendReceivedFile("1.0")
        }

    }

    //文件下载完毕
    function g_receivefileFinished( code,filename,struid)
    {
        if(struid!=roomId)return

        console.log("群聊文件下载完毕:",code,filename,struid)

        if(groupchatwindow.receiverFileName=="消息记录下载文件")
        {
          var sendtext = "文件："+filename +"已下载完毕，再次双击文件或图片可以打开";
          appendSendData(sendtext, 0, "0", "", "",roomId,"0");
        }

        if(code == "666")
        {
            fileio.playmusic(downLoadManager.strGetFilePath("3")+filename);
            console.log("播放音乐",downLoadManager.strGetFilePath("3")+filename)
        }
    }


    //显示历史消息
    function appendMsgData(str, iflag, chatfilepath)
    {
        var address = fileio.getLoginAddress()
        chatisopenfirereverfile1 = "0"

        var tmp;
        //console.log("增加到群聊窗口的内容:",str)  //gaobo wait
        var obj = eval('(' + str + ')');  //eval

        var strMsgType;

        if(obj.type === "text")
        {
            tmp = obj.content.replace(/\\n/g,"\n");
            tmp = tmp.replace(/</g,"&lt;");

            strMsgType = "0";
        }
        else if(obj.type === "file")
        {
            tmp = str;
            strMsgType = "1";
        }
        else if(obj.type === "img")
        {
            tmp = str;
            strMsgType = "2";
        }
        else if(obj.type === "voice")
        {
            tmp = str;
            strMsgType = "3";
        }
        else if(obj.type === "local")
        {
            console.log("nukonw type local")
        }

        var tmpTime = obj.time;
        var uuidStr = obj.uuid;
        var strsource = chatgifsource
        var strHeadIcoUrl

        if(userinfoMap.containsKey( obj.from_uid , ""))
        {
            strHeadIcoUrl =userinfoMap.get( obj.from_uid , "")
        }
        else if(iflag === 1 )
            strHeadIcoUrl = ""// avatar ;
        else
            strHeadIcoUrl = selfvavtar;

        String.prototype.endsWith=function(endStr){
            var d = this.length-endStr.length;
            return (d >= 0 && this.lastIndexOf(endStr) == d)
        }

        //if(typeof tmpTime == "Number")
        tmpTime = tmpTime.toString();
        var strFileSize;
        if("file" in obj)
        {
            strFileSize = obj.file.file_size;
        }
        else
        {
            strFileSize = obj.data.file_size;
        }

        if(iflag === 1) //别人
        {
            if(obj.type === "file")
            {
                if(strFileSize.endsWith("MB"))
                {
                    iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024 *1024;
                }
                else if(strFileSize.endsWith("KB"))
                {
                    iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024;
                }
                else
                {
                    iReceived = Number(strFileSize)* 1024;
                }

                //console.log("路径1")
                //if(typeof tmpTime == "Number")
                    tmpTime = tmpTime.toString();
                groupChatModel.insert(0,{"chatname1": obj.formUserName, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": downLoadManager.strGetFilePath("1"), "chatvoicetime":"","userjid":obj.from_uid,"uuid":uuidStr});

                //群聊历史消息文件,都暂不下载
            }
            else if(obj.type === "text")
            {
                //console.log("路径3" )
                //if(typeof tmpTime == "Number")
                    tmpTime = tmpTime.toString();

                groupChatModel.insert(0,{"chatname1": obj.formUserName, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": "", "chatvoicetime":"","userjid":obj.from_uid,"uuid":uuidStr});
            }
            else if(obj.type === "img")
            {
                var strImgSize1 = obj.file.file_size;
                if(strImgSize1.endsWith("M"))
                {
                    iReceived = Number(strImgSize1.substr(0,strImgSize1.length-1)) * 1024 *1024;
                }
                else if(strImgSize1.endsWith("KB"))
                {
                    iReceived = Number(strImgSize1.substr(0,strImgSize1.length-1)) * 1024;
                }
                else
                {
                    iReceived = Number(strImgSize1.substr(0,strImgSize1.length-1));
                }

                //if(typeof tmpTime == "Number")
                    tmpTime = tmpTime.toString();

                //console.log("路径2")
                groupChatModel.insert(0,{"chatname1": obj.formUserName, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":"","userjid":obj.from_uid,"uuid":uuidStr});

                //群聊历史消息图片,都暂不下载
            }
            else
            {
                console.log("群聊历史消息：语音:",obj.type,tmp);
                chatvoicetime=obj.file.voice_time
                groupChatModel.insert(0,{"chatname1": obj.formUserName, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": downLoadManager.strGetFilePath("3"), "chatvoicetime":chatvoicetime,"userjid":obj.from_uid,"uuid":uuidStr});

            }

            //  isReceivedAll = false;
            groupchatView.positionViewAtEnd();
        }
        else //自己
        {
            if(obj.type === "file")
            {
                console.log("content", tmp)
                console.log("strFileSize___", strFileSize)


                if(strFileSize.endsWith("MB"))
                {
                    iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024 *1024;
                }
                else if(strFileSize.endsWith("KB"))
                {
                    iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024;
                }
                else
                {
                    iReceived = Number(strFileSize)*1024;
                }

                console.log("路径6" )

                //if(typeof tmpTime == "Number")
                    tmpTime = tmpTime.toString();

                groupChatModel.insert(0,{"chatname1": oneselfName, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": downLoadManager.strGetFilePath("1"), "chatvoicetime":"","userjid":obj.from_uid,"uuid":uuidStr});

            }
            else  if(obj.type === "text")
            {
                //console.log("路径4" )

                //if(typeof tmpTime == "Number" || typeof tmpTime == "number")
                    tmpTime = tmpTime.toString();

                groupChatModel.insert(0,{"chatname1": oneselfName, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": "", "chatvoicetime":"","userjid":obj.from_uid,"uuid":uuidStr});
            }
            else if(obj.type === "img")
            {
                var strImgSize;
                if("file" in obj)
                {
                strImgSize = obj.file.file_size;
                }
                else
                {
                    strImgSize = obj.data.file_size;
                }

                if(strImgSize.endsWith("M"))
                {
                    iReceived = Number(strImgSize.substr(0,strImgSize.length-1)) * 1024 *1024;
                }
                else if(strImgSize.endsWith("KB"))
                {
                    iReceived = Number(strImgSize.substr(0,strImgSize.length-1)) * 1024;
                }
                else
                {
                    iReceived = Number(strImgSize.substr(0,strImgSize.length-1));
                }


                //if(typeof tmpTime == "Number")
                    tmpTime = tmpTime.toString();


                console.log("路径5" )
                if("file" in obj)
                {
                  groupChatModel.insert(0,{"chatname1": oneselfName, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":"","userjid":obj.from_uid,"uuid":uuidStr});
                 }
                else
                {
                    groupChatModel.append({"chatname1": oneselfName, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                              , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                              , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":"","userjid":obj.from_uid,"uuid":uuidStr});
                }
            }
            else
            {
                console.log("自己发的语音:",obj.type,tmp);
                chatvoicetime=obj.file.voice_time
                groupChatModel.insert(0,{"chatname1": oneselfName, "chathead":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": downLoadManager.strGetFilePath("3"), "chatvoicetime":chatvoicetime,"userjid":obj.from_uid,"uuid":uuidStr});
            }

            groupchatView.positionViewAtEnd();
        }
    }

    function appendMessageLoginingData(str)
    {
        //  console.log("strxxxxxx :",str)
        if(str === "")
        {
            console.log("获取用户聊天记录为空  :return")
            return;
        }

        console.log("聊天记录为:",str);

        var strMsg = eval('(' + str + ')');  //eval

         console.log("strMsg 长度:",strMsg.length)

        for(var i =  0; i < strMsg.length; ++i)
        {
            var obj = strMsg[i];

            //console.log("obj :",obj)
            //console.log("userjid :",userjid)

            var _sstr = JSON.stringify(obj)

            //!请求头像
            var strip=fileio.readIniFile("login", "dnsip")
            var requestuserinfo = strip+"/user/findUserByuid?uid="+ obj.from_uid+"&msg_type=1"

            if(!userinfoMap.containsKey( obj.from_uid , ""))
            {
                chatGetUserInfo.getUserInfo(jessonid, requestuserinfo, 3);
                console.log("用户信息:",requestuserinfo);
                userinfoMap.put( obj.from_uid , "")
            }
            //console.log("userjid :",_sstr)
            if(obj.from_uid === oneselfJid)//自己
            {
                console.log("appendMsgData自己发给群:",i,obj.from_uid,oneselfJid, jid, obj.formUserName +" -> "+ obj.toUserName,"   ID:",obj.from_uid+":"+obj.to_uid,_sstr)
                groupchatwindow.appendMsgData(_sstr, 0, "");
            }
            else if(obj.to_uid === jid)//别人
            {
                console.log("appendMsgData别人发本群:",i,obj.from_uid,oneselfJid, jid, obj.formUserName +" -> "+ obj.toUserName,"   ID:",obj.from_uid+":"+obj.to_uid,_sstr)
                groupchatwindow.appendMsgData(_sstr, 1, "");
            }

            else//其他聊天框的信息
            {
                console.log("appendMsgData别人发给别人（gaobo wait）:",i,obj.from_uid,oneselfJid, jid, obj.formUserName +" -> "+ obj.toUserName,"   ID:",obj.from_uid+":"+obj.to_uid,_sstr)
            }

        }
        edit.focus = true
        edit.forceActiveFocus()
    }

    function isUserInGroup(pramajid)
    {
        if(userinfoMap.containsKey( pramajid ) )
            return true;
        else
            return false;
    }

    function isHaveUserInfo(imagePath,pramajid)
    {
        // console.log("isHaveUserInfo___:",imagePath)
        // console.log("isHaveUserInfo___:",userinfoMap.get( pramajid ))

        if(userinfoMap.get( pramajid ) == imagePath)
            return true;
        else
            return false;
    }
    //打开图片窗口
    function creatImagePreviewObj(imageSource, iWidth, iHeight) {


       // console.log("desktopAvailableWidth_s"+Screen.desktopAvailableWidth);
       // console.log("desktopAvailableHeigth_"+Screen.desktopAvailableHeight);

        if( iWidth >Screen.desktopAvailableWidth)
        {
            iWidth = Screen.desktopAvailableWidth-100;
        }

        if( iWidth >Screen.desktopAvailableHeight)
        {
            iHeight = Screen.desktopAvailableHeight-100;
        }

        //console.log("imageSource:" + imageSource);
        var component = Qt.createComponent("ImagePreview.qml");

        if (component.status === Component.Ready)
        {
            if(imagePreviewObj === null)
            {
               // console.log("imagesadd:"+imageSource)
                imagePreviewObj = component.createObject(window.parent, {"imgSource": imageSource
                                                             , "windowWidth": iWidth
                                                             , "windowHeight": iHeight})
            }
        }
        if(imagePreviewObj === null)
        {

        }
        else
        {
            imagePreviewObj.deleteitem.connect(deleteImagePreObj)
        }
    }
    function deleteImagePreObj()
    {


        if(imagePreviewObj == null)
        {
            return;
        }

        imagePreviewObj.deleteitem.disconnect(deleteImagePreObj)

        imagePreviewObj.destroy()
        imagePreviewObj = null
        //console.log("关闭图像", "imview")
    }

    //上传文件成功后发送给对方消息
    function g_getfileurl(msgType, iRet, strReceivedMsg,struid,strfilepath)
    {

        if(struid!=jid)return;
        console.log("g_getfileurl 文件",msgType,iRet,strReceivedMsg,strfilepath);
        var _sUuid =  fileUploadUuid; //获取此次上传的uuid;

      /*  var obj = eval('(' + strReceivedMsg + ')');
        if(strReceivedMsg.indexOf("roomId")<=0)return;
        console.log("getfileurl——————obj.roomId",obj.roomId,"getfileurl——————jid",roomId)
        if(obj.roomId != roomId)return;*/


        if(msgType === 1)      //文件
        {

            //暂时注释群聊发送文件的消息回执
            var obj = eval('(' + strReceivedMsg + ')'); //eval
            fileio.writeiniSendfilenotes(strfilepath,obj.file_name,obj.sendTime)
            var strMessage1 = "{\"type\":\"file\",\"data\":";
            strMessage1 += strReceivedMsg;
            strMessage1 += ",\"send_time\":\"";
            strMessage1 += getTime() ;
            strMessage1 += "\",\"uuid\":\"";
            strMessage1 +=_sUuid;
            strMessage1 += "\",\"callback\":\"";
            strMessage1 +="1" ;
            strMessage1 += "\"}";
            var  s2 =downLoadManager.strGetFilePath("1");
            console.log("上传文件成功后发送给对方消息，openfire参数:",1, strMessage1, strOid + "pq"+jid + "@gsubo",_sUuid,false,mainwindow.oneselfName);
            //appendSendData(strMessage1, 0, "2", s2, "",_sUuid,"1")
            appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1",mainwindow.oneselfName)
            console.log("上传文件成功后发送给对方消息，openfire参数","1",strMessage1,roomId,mainwindow.oneselfName,groupName,_sUuid);
            talkRoomIntface.sendGroudRoomMsg(1,strReceivedMsg,roomId,mainwindow.oneselfName,groupName,_sUuid);
            // singleChat.sendMsg(1, strReceivedMsg, strOid ,_sUuid,false)
            // if(callbackmsg)
            // {
            //     singleChat.sendMsg(1, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,true)
            //     msgcallback.checked = false;
            //     callbackmsg = false;
            // }
            // else
            // {
            // }

            strMsg = strReceivedMsg;

          /*  if(isSendAll)
            {
                groupChatModel.setProperty(groupChatModel.count - 1,"bisreceived",true)
                groupChatModel.setProperty(groupChatModel.count - 1, "chatcontents1", strMsg)
            }*/
        }
        else if(msgType === 2) //图片
        {
            console.log("g_getfileurl———图片———",strReceivedMsg);
            //暂时注释群聊发送文件的消息回执

           // appendSendData(strReceivedMsg, 0, "2", s2, "",_sUuid,"1")
            var strMessage1 = "{\"type\":\"img\",\"data\":";
            strMessage1 += strReceivedMsg;
            strMessage1 += ",\"send_time\":\"";
            strMessage1 += getTime() ;
            strMessage1 += "\",\"uuid\":\"";
            strMessage1 +=_sUuid;
            strMessage1 += "\",\"callback\":\"";
            strMessage1 +="1" ;
            strMessage1 += "\"}";
            var  s2 =downLoadManager.strGetFilePath("2");
            console.log("上传文件成功后发送给对方消息，openfire参数:",2, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,false,mainwindow.oneselfName);
            // appendSendData(strMessage1, 0, "2", s2, "",_sUuid,"1")

            appendSendData(strMessage1, 0, "2", s2, "",_sUuid,"2",mainwindow.oneselfName)

            // groupchatwindow.appendMsgData(strMessage1, 0, "");
            talkRoomIntface.sendGroudRoomMsg(2,strReceivedMsg,roomId,mainwindow.oneselfName,groupName,_sUuid);
            // singleChat.sendMsg(2, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,false)
            // if(callbackmsg)
            // {
            //     singleChat.sendMsg(2, strReceivedMsg, strOid + "pq"+jid + "@gsubo",uuid,true)
            //     msgcallback.checked = false;
            //     callbackmsg = false;
            // }
            // else
            // {
            // }

            strMsg = strReceivedMsg ;

            if(isSendAll)
            {
                groupChatModel.setProperty(groupChatModel.count - 1,"bisreceived",true)
                groupChatModel.setProperty(groupChatModel.count - 1, "chatcontents1", strMsg)
            }
        }
        else if(msgType === 3) //声音
        {
            /*
            strMsg = strReceivedMsg;
            if(isSendAll)
            {
                groupChatModel.setProperty(groupChatModel.count - 1,"bisreceived",true)
                groupChatModel.setProperty(groupChatModel.count - 1, "chatcontents1", strMsg)
            }*/


            console.log("上传语音文件成功后发送给对方消息，openfire参数:",3, strReceivedMsg, roomId,_sUuid,mainwindow.oneselfName,groupName);
            //singleChat.sendMsg(3, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,false,mainwindow.oneselfName)
            talkRoomIntface.sendGroudRoomMsg(3,strReceivedMsg,roomId,mainwindow.oneselfName,groupName,_sUuid);

            console.log("上传文件成功后发送给对方消息，openfire参数","1",strMessage1,roomId,mainwindow.oneselfName,groupName,_sUuid);


            var elapseTime1 = getTime() - elapseTime;
            if(elapseTime1>60)
               elapseTime1=60

            var strMessage = "{\"type\":\"voice\",\"data\":";
            strMessage += strReceivedMsg;
            strMessage += ",\"send_time\":\"";
            strMessage += getTime() ;
            strMessage += "\",\"uuid\":\"";
            strMessage +=_sUuid;
            strMessage += "\",\"callback\":\"";
            strMessage +="1" ;
            strMessage += "\"}";

            appendSendData(strMessage, 0, "3", "", elapseTime1.toString(),_sUuid,"3",mainwindow.oneselfName)

            //appendConverList("", getTime(), jid, "voice",groupName)
            //appendSendData(str, iflag, strmsgtype, chatfilepath, voicetime,uuid,callback,sendername)
        }
    }

    //收到查询的用户信息
    function __callback(userjson, flags) {

        if(flags === 1 || flags === 2) return; //单聊

        // console.log("__callback：：：",userjson,flags);
        if(flags === 3)
        {
            var  obj = eval('(' + userjson + ')');  //eval
            var  img = obj.object.avatar;
            var  sex = obj.object.sex;

            if(!isUserInGroup( obj.object.uid))return;//不属于本群

            var himg ="";

            if(img !== "0" && img !== "1" && img !== "" && img !== null)
            {
                himg =   strip +  "/img/user/"+img;
                console.log("himg----------------",himg);
            }
            else  if(sex === "0") //boy.png'
            {
                himg =  "qrc:/resource/images/main/maincenter/man.png";
            }
            else if(sex === "1")//girl.png'
            {
                himg =   "qrc:/resource/images/main/maincenter/woman.png";
            }
            else
            {
                console.log("无法识别的头像：",img);
            }

            if(!isHaveUserInfo(himg,obj.object.uid))
            {
                for(var len = 0 ; len< groupChatModel.count;len++)
                {
                    //console.log("userinfoMap.setvalue:_",len,obj.object.uid,obj.jid ,himg);

                    if(groupChatModel.get(len).userjid == obj.object.uid)
                    {
                        groupChatModel.setProperty(len, "chatname1", obj.object.userName)
                        groupChatModel.setProperty(len, "chathead", himg) 
                        //userinfoMap.setvalue;
                        groupchatView.update();
                        userinfoMap.remove(obj.object.uid);
                        userinfoMap.put(obj.object.uid,himg)
                        //  console.log("userinfoMap.setvalue:2_",userinfoMap.get(obj.object.uid));
                        //console.log("userinfoMap.setvalue:_",len,himg,groupChatModel.get(len).chatname1,groupChatModel.get(len).userjid , obj.object.uid);
                        //console.log("userinfoMap.setvalue:_",len,groupChatModel.get(len).chathead, userinfoMap.get( groupChatModel.get(len).userjid ));
                        //console.log("userinfoMap.setvalue:_",len,obj.object.uid,obj.jid ,himg);
                    }
                    else
                    {
                        console.log("!isHaveUserInfo(himg,obj.object.uid)",groupChatModel.get(len).userjid , obj.object.uid);
                    }
                }
            }
            else
            {
                console.log("!isHaveUserInfo(himg,obj.object.uid)",himg,obj.object.uid);
            }

        }
        else
        {
            console.log("__callback flags error", flags)
        }
    }

    function endshotsreen(shotfilepath,uSerjidshot)
    {

        show();
        if(shotfilepath=="")return; //截图未保存就退出

        if(roomId!=uSerjidshot)return;
        getuserinfos()
        var strfile = shotfilepath;
        var tempFile = shotfilepath.toString().split("/");
        console.log("strfile", shotfilepath)
        var MessageKey =strOid + "pq";
        var strUrl;
        var _sUuid =Query.uuid();
        //  if(strFileType == "1") file
        //   if(strFileType == "2") img
        //   if(strFileType == "3")voice

        var  s1 =shotfilepath;
        var  s2 =downLoadManager.strGetFilePath("2");
        var  s3 =s2+tempFile[tempFile.length - 1];

        fileio.copyFile(s1,s3,s2)


            appendConverList("", getTime(), jid, "img",groupName)
            var strMessage = "{\"type\":\"img\",\"data\":";
            strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
            strMessage += ",\"send_time\":\"";
            strMessage += getTime() ;
            strMessage += "\",\"uuid\":\"";
            strMessage +=_sUuid;
            strMessage += "\",\"callback\":\"";
            strMessage +="1" ;
            strMessage += "\"}";
            var strip =fileio.readIniFile("login", "dnsip")
            strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                    + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                    + "&msg_type=1&charset=utf-8"//+MessageKey

            //chatTransferFile.setStrJessionId(jessonid)
            //chatTransferFile.setServerAddr(strUrl);
            //chatTransferFile.setPostFilePath(strfile[1]);
            if( chatTransferFile.start(strUrl,shotfilepath,jessonid,jid))
            {
               // appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")
            }


            console.log("fileDialog img___",  strUrl)


    }


    //检查自己是否还在群里,如已被移出,禁止各类操作
    function getRoomPerson(RoomPerson,opflag)
    {
        //console.log("RoomPerson",RoomPerson)

        var obj = eval('(' + RoomPerson + ')');
        iamintheroom=false;

        for(var i =0; i < obj.obj.length; ++i)
        {
            //console.log(obj.obj[i].uid,oneselfJid)
            if(obj.obj[i].uid==oneselfJid)
            {
                console.log("我在群里")
                iamintheroom=true;
            }
        }

        if(!iamintheroom)
        {
            mainbottomoperating.creatMessageObj("抱歉，您已经被移出本群", "msg")
            groupchatView.visible=false;
            msglist.visible = false
            room_Web.reload()
            return;
        }


        if(opflag=="1") //发送消息
        {
            if(edit.text.length == 0)
            {
                return;
            }

            akeyflag = false;
            _btnSendmsg();
            room_Web.reload()
        }
        else if(opflag=="2") //点击添加群用户按钮
        {
            webRun._vNewWindows(strip + "/spirit/newGroupChat?uid="+chatuserprivname+"&quid="+jid+"&JSESSIONID1=" + jessonid ,"添加群用户",false)
            console.log("添加群用户",strip + "/spirit/newGroupChat?uid="+chatuserprivname+"&quid="+jid);
        }
        else if(opflag=="3") //人员列表右键菜单
        {
            contentMenu.open()
        }
        else if(opflag=="4") //修改群名
        {
            changeRoomName(jid,username.text);
        }

        else if(opflag=="5") //查看消息记录
        {
            msglist.visible = true
            roomMember.visible= false
            msglist_Web.url = strip + "/spirit/groupChatLog?of_to="+groupId+"&last_time="+fileio.getCurrTime()+"&msg_type=1";
        }
        else if(opflag=="6") //初始化群聊窗口
        {
            console.log("群初始化")
            webrun._sig_webgetDatal.connect(_getWebUserList);

            msglist.visible = false
            roomMember.visible= true
            room_Web.url = strip + "/spirit/groupChat?roomOf="+groupId;
        }
        else if(opflag=="7") //发送图片
        {


            if(picturebtn.checked)
            {
                openfolder=fileio.readinifilepath();
                openfolder=openfolder.substring(0,openfolder.lastIndexOf("/"))

                pictureDialog.setFolder(openfolder)
                pictureDialog.open()
            }
            else
            {
                pictureDialog.close()
            }

        }
        else if(opflag=="8") //发送文件
        {

            if(filebtn.checked)
            {
                fileDialog.setFolder(fileio.readinifilepath())
                fileDialog.open()
            }
            else
            {
                fileDialog.close()
            }

        }
        else if(opflag=="9") //截图发送
        {
            hide();
            screenshot.startShot(roomId);
        }
        else if(opflag=="10") //发送语音
        {
            if(!voiceRect.visible)
            {
                voicetext.text="正在录音..."
                voiceRect.visible = true

                console.log("开始录制声音");
                chatVoiceMessage.startRecorder(getTime())
                voiceprogressbar.value=0
                voiceTimePast=0
                voicetimer.start();
                voiceicon_timer.start();
                elapseTime = getTime();
            }
            else
            {
                cancelvoice()
            }

        }

    }

    Component.onCompleted: {
        //! 绑定web回调
        //! 添加群成员web接口

        var room_url=strip+"/im/getRoomPerson?roomOf="+jid
        Query.querygetRoomPerson(room_url, getRoomPerson,6) //初始化群聊窗口


        webrun._sig_webgetDatal.connect(_getWebUserList);
        chatTransferFile.sigReplyMessage.connect(g_getfileurl)
        chatTransferFile.sigSendFileData.connect(g_sender)
        downLoadManager.signalDownloadProcess.connect(g_receiver)
        downLoadManager.signalReplyFinished.connect(g_receivefileFinished);

        //chatMessageFromServer.getMsgServer(jessonid, strip + "/im/showMessageList?of_to="+ jid +"&pagenum=1"+"&msg_type=1");//"&last_time="+getTime()+
        Query.requestgroupmessage(strip,oneselfJid,jid,appendMessageLoginingData)
        console.log("获取消息历史记录接口：",strip + "/im/showMessageList?of_to="+ jid +"&pagenum=1"+"&msg_type=1");//&last_time= getTime() +

        chatMessageFromServer.sigReplyMessage.connect(appendMessageLoginingData)
        //注释掉群聊里的查看个人消息
        //chatGetUserInfo.sigReplyMessage.connect(__callback)
        screenshot.finishPixmap.connect(endshotsreen)
        transData._sig_trigger.connect(adduserList);
        edit.focus = true
        edit.forceActiveFocus()
    }


    //发送语音
    function sendvoice()
    {
        voiceRect.visible = false
        voicetimer.stop()
        voice.checked = 0
        voiceprogressbar.value = 0;
        voiceTimePast=0
        voiceicon_timer.stop();

        var elapseTime1 = getTime() - elapseTime;
        var strFile = chatVoiceMessage.stopRecorder(true);
        var _sUuid=   Query.uuid();
        fileUploadUuid=_sUuid; //记录此次上传的uuid

        //界面追加语音消息
        var MessageKey =strOid + "pq";
        getuserinfos();

        var tempFile = strFile.toString().split("/");
        console.log("发送音频文件",tempFile[tempFile.length-1])

        var strUrl;
        strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                + "&type=voice" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" + jid + "&stime=" + getTime() + "&uuid=" + _sUuid
                + "&msg_type=1&voice_time="+ elapseTime1 +"&charset=utf-8";

        console.log("音频接口地址", strUrl)

        chatTransferFile.start(strUrl,strFile,jessonid,roomId)
    }

    //停止语音录制
    function cancelvoice()
    {
        voiceRect.visible = false
        voicetimer.stop();
        voice.checked = 0
        voiceicon_timer.stop();
        voiceprogressbar.value = 0;
        voiceTimePast=0
        elapseTime = 0;
        chatVoiceMessage.stopRecorder(false);
    }

}
