﻿import QtQuick 2.0
import QtQuick.Window 2.2
import QtQuick.Controls 1.4
import Qt.labs.platform 1.0
import "../common"
import FileIo 1.0

Window {
    id: imagePreview

    flags: Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint
    x: (Screen.desktopAvailableWidth - windowWidth)/2
    y:{
        /*if(windowHeight>(Screen.desktopAvailableHeight-200))
        {
            return (Screen.desktopAvailableHeight - windowHeight)/2+270
        }*/
        return (Screen.desktopAvailableHeight - windowHeight)/2//+10
        }
        //(Screen.desktopAvailableHeight - windowHeight)/2

    visible: true

    property bool bPressed: true
    property string imgSource: ""
    property alias windowWidth: imagePreview.width
    property alias windowHeight: imagePreview.height
    signal deleteitem();


    MouseArea { //为窗口添加鼠标事件
        id:mouse
        anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"
        
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true
            console.log("images :"+imgSource);
        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)

                //如果mainwindow继承自QWidget,用setPos
                imagePreview.setX(imagePreview.x+delta.x)
                imagePreview.setY(imagePreview.y+delta.y)
            }
        }
    }

    FileIo{
        id: fileio
    }

    Rectangle{
        anchors.fill: parent
        visible: true
        color: "#F3F3F3"
        border.color: "#ccc"
        border.width: 1
       Rectangle{
            id: titleBkg
            anchors.top: parent.top
            anchors.topMargin: 10
            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10
            height: 30
            color: "#F3F3F3"

            Text{
                id: titleTxex
                width: 80
                height: 28
                anchors.centerIn: parent
                font.pixelSize: 14
                font.family: "微软雅黑"
                text: qsTr("图片预览")
                verticalAlignment: Qt.AlignVCenter
                horizontalAlignment: Qt.AlignHCenter
                color: "#333333"
            }

            ControlButton {
                id:min
                anchors.top: parent.top
                anchors.right: max.left
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/im/chatMin.png"
                hoverImage: "qrc:/resource/images/im/chatMin_hovered.png"
                onClicked: {
                    imagePreview.showMinimized()
                }
            }

            ControlButton {
                id:max
                anchors.top: parent.top
                anchors.right: close.left
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/im/chatMax.png"
                hoverImage: "qrc:/resource/images/im/chatMax_hovered.png"

                onClicked: {
                    if(imagePreview.visibility == Window.Windowed)
                    {
                        imagePreview.showMaximized()
                    }
                    else
                    {
                        imagePreview.showNormal()
                    }
                }
            }

            ControlButton {
                id:close
                anchors.top: parent.top
                anchors.right: parent.right
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/im/chatClose.png"
                hoverImage: "qrc:/resource/images/im/chatClose_hovered.png"
                onClicked: {
                    imagePreview.deleteitem()
                }
            }
        }

       Rectangle{
            id: imagbkg
            //color: "red"
            anchors.top:titleBkg.bottom
            anchors.topMargin: 30
            anchors.left: parent.left
            anchors.leftMargin:20
            anchors.right: parent.right
            anchors.rightMargin: 20
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 50

           color:"#F3F3F3"
            Image {
                id: img
                anchors.centerIn: parent
                //fillMode:Image.PreserveAspectFit
                cache : true
                sourceSize.width: windowWidth -270
                sourceSize.height:windowHeight - 270
                source:imgSource//"qrc:/resource/images/im/chatpicture.png";//"file:///D:/weincunchu/WXWork Files/Image/2018-09/企业微信截图_88e8864f-cde3-4e77-b56f-eba1766f786d(1).png" //imgSource                
            }
            /*TextEdit{
                id: img
                anchors.centerIn: parent
              //  fillMode:Image.PreserveAspectFit
               // cache : true
           //   editset.StyleSheet("background-image:url(./pic/new_images/start_jiankong.png)");
              TextEdit.setStyleSheet:"background-image:url(imgSource)"
            }*/
        }

        Rectangle{
            id:download
            anchors.top:imagbkg.bottom

            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right: parent.right
            anchors.rightMargin: 1

            color: "#F3F3F3"

            Image {
                id: downloadImage
                source: "qrc:/resource/images/im/download.png"
                width: 22
                height: 22
                anchors.top: parent.top
                anchors.topMargin: 14
                x:windowWidth/2 - 40

                MouseArea {
                    anchors.fill: parent
                    hoverEnabled: true
                    cursorShape: Qt.PointingHandCursor

                    onExited: {
                        downloadImage.source =  "qrc:/resource/images/im/download.png"
                    }

                    onEntered: {
                        downloadImage.source =  "qrc:/resource/images/im/download_hovered.png"
                    }

                    onClicked: {
                        console.log("进入图片下载界面")
                        var strPath = imgSource.split("&");
                        var filename = fileio.savePicture(strPath[strPath.length -2 ].toString().substring(16,strPath[strPath.length -2 ].length))

                        console.log("输出图片名字",filename)
                        if(filename !== "")
                        {
                            downLoadManager.downloadPicture(imgSource, filename);
                        }

                        console.log("下载后filename", filename)
                    }
                }
            }

            Image {
                id: rotateImage
                source: "qrc:/resource/images/im/rotate.png"
                width: 22
                height: 22
                anchors.top: parent.top
                anchors.topMargin: 14
                x:windowWidth/2 + 18

                MouseArea {
                    anchors.fill: parent
                    hoverEnabled: true
                    cursorShape: Qt.PointingHandCursor

                    onExited: {
                        rotateImage.source = "qrc:/resource/images/im/rotate.png"
                    }

                    onEntered: {
                        rotateImage.source = "qrc:/resource/images/im/rotate_hovered.png"
                    }

                    onClicked: {
                        img.rotation += 90
                    }
                }
            }
        }
    }

}
