import QtQuick 2.0
import QtQuick.Controls 1.3
import QtQuick.Controls.Styles 1.4

Button{
    id:root
    property string normalcolor: ""
    property string checkedcolor: ""
    property string textContent: ""
    property string iconSources: ""
    style:ButtonStyle{
        background:  Rectangle {
            id:background
            states:[
                State{
                    name:"checked"
                    when:root.checked
                    PropertyChanges {
                        target: background
                        color: checkedcolor
                    }
                },

                State{
                    name:"!checked"
                    when:!root.checked
                    PropertyChanges {
                        target: background
                        color: normalcolor

                    }
                }
            ]

            Image {
                id: name
                anchors.top: parent.top
                anchors.topMargin: 10
                anchors.left: parent.left
                anchors.leftMargin: 19
                source: iconSources
            }
        }

        label: Text{
            id: text_label
            text: textContent
            font.pixelSize: 14
            font.family: "微软雅黑"
            font.bold: false
            color: "#1d6ea5"

            horizontalAlignment: Qt.AlignHCenter
            verticalAlignment: Qt.AlignVCenter
            states:[
                State{
                    name:"checked"
                    when:root.checked

                    PropertyChanges {
                        target: text_label
                        color: "#016EB0"
                    }
                },

                State{
                    name:"!checked"
                    when:!root.checked
                    PropertyChanges {
                        target: text_label
                        color: "#010101"
                    }
                }
            ]
        }
    }
}
