import QtQuick 2.0
import QtQuick.Controls 1.3
import QtQuick.Controls.Styles 1.4

Button{
    id:root
    property string normalIcon: ""
    property string checkedIcon: ""
    property string hoveredIcon: ""
    property bool isclicked: false

    style:ButtonStyle{
        background:  Image {
            id:background
            states:[
                State {
                    name: "hovered"
                    when: root.hovered && !root.checked
                    PropertyChanges {
                        target: background
                        source: hoveredIcon
                    }
                },

                State{
                    name:"checked"
                    when:root.checked
                    PropertyChanges {
                        target: background
                        source: checkedIcon
                    }
                },

                State{
                    name:"!checked"
                    when:!root.checked
                    PropertyChanges {
                        target: background
                        source: normalIcon
                    }
                }
            ]
        }
    }
}
