﻿import QtQuick 2.0
import QtQuick.Controls 2.0

Image {
    id:bkg
    property string normalImage: ""
    property string hoverImage: ""
    property string textContent: ""
    property int iconWidth: 0
    property int iconHeight: 0
    property int leftMargin: 0
    property int topMargin: 0

    signal clicked()

    source : ""

    Image {
        id: icon
        anchors.top:parent.top
        anchors.topMargin:topMargin
        anchors.left: parent.left
        anchors.leftMargin: leftMargin
        source: normalImage
    }

    MouseArea{
        anchors.fill: parent
        hoverEnabled: true
        cursorShape: Qt.PointingHandCursor
        onPositionChanged: {
        }

        onEntered: {
            bkg.source = hoverImage
            if(textContent != "")
            {
                tooltip.visible = true
                tooltip.text = textContent
            }
        }

        onExited: {
            bkg.source = ""
            tooltip.visible = false
            tooltip.text = ""
        }

        onPressed: {
            bkg.clicked()
        }
    }

   ToolTip{
       id: tooltip
   }
}



//import QtQuick 2.0
//import QtQuick.Controls 1.3
//import QtQuick.Controls.Styles 1.4

//Button{
//    id:root
//    property string normalImage: ""
//    property string hoverImage: ""
//    property string textContent: ""
//    style:ButtonStyle{
//        background:  Image{
//            id:background
//            states:[
//                State{
//                    name:"hovered"
//                    when:root.hovered
//                    PropertyChanges {
//                        target: background; source:hoverImage
//                    }
//                },

//                State{
//                    name:"!hovered"
//                    when:!root.hovered
//                    PropertyChanges {
//                        target: background; source:normalImage
//                    }
//                }
//            ]
//        }

//        label: Text{
//            id:text_label
//            text:textContent
//            font.pixelSize: 12
//            font.family: "微软雅黑"
//            color:  "#ffffff"
//            font.bold: false
//            horizontalAlignment: Qt.AlignHCenter
//            verticalAlignment: Qt.AlignVCenter
//        }
//    }
//}






