import QtQuick 2.0
import QtQuick.Controls 1.3
import QtQuick.Controls.Styles 1.4

Button{
    id:root
    property string normalImage: ""
    property string hoverImage: ""
    property string textContent: ""
    style:ButtonStyle{
        background:  Image{
            id:background
            states:[
                State{
                    name:"hovered"
                    when:root.hovered
                    PropertyChanges {
                        target: background; source:hoverImage
                    }
                },

                State{
                    name:"!hovered"
                    when:!root.hovered
                    PropertyChanges {
                        target: background; source:normalImage
                    }
                }
            ]
        }

        label: Text{
            id:text_label
            text:textContent
            height: root.height
            font.pixelSize: 11
            font.family: "微软雅黑"
            color:  "#ffffff"
            font.bold: false
            horizontalAlignment: Qt.AlignLeft
            verticalAlignment: Qt.AlignVCenter
        }
    }
}
