﻿import QtQuick 2.0
import QtQuick.Layouts 1.1
import QtQuick.Controls 2.1
import QtQuick.Window 2.0
import QtWebEngine 1.5
import QtWebChannel 1.0

import "../common"
import "../interface"

Window {
    id: webWindow
    property string nabkgImageme: ""
    property string weburl: ""
    property bool bPressed: true
    property int viewwidth: (Screen.desktopAvailableWidth)*0.8
    property int viewheight: (Screen.desktopAvailableHeight)*0.8
    property string titletext: ""
    property string pageid: ""
    width: viewwidth
    height: viewheight
    x: (Screen.desktopAvailableWidth - viewwidth)/2
    y: (Screen.desktopAvailableHeight - viewheight)/2

    flags:Qt.Window|Qt.FramelessWindowHint

    signal deleteitem(string pageid)

    signal sendWebUrl(string msg1, string msg2, string msg3)


    MouseArea { //为窗口添加鼠标事件
        id:mouse
        anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true
        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)

                //console.log("2221")
                //如果mainwindow继承自QWidget,用setPos
                webWindow.setX(webWindow.x+delta.x)
                webWindow.setY(webWindow.y+delta.y)
            }
        }
    }

    Image {
        id: titlebkg
        height: 45
        anchors.top:parent.top
        anchors.left:parent.left
        anchors.right: parent.right
        anchors.bottom: webshow.top
        source: nabkgImageme

        Text {
            id: name
            width: 100
            height: 25
            anchors.top: parent.top
            anchors.topMargin: 10
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.leftMargin: 10
            text: webWindow.titletext


            font.pixelSize: 16
            font.family: "微软雅黑"
            color:  "#ffffff"
            font.bold: false

            MouseArea
            {
                anchors.fill: parent

                onPressed: {

                }
            }
        }

        ControlButton {
            id:min
            anchors.top: parent.top
            anchors.right: max.left
            width: 25
            height: 19
            normalImage: "qrc:/resource/images/main/maintop/min.png"
            hoverImage: "qrc:/resource/images/main/maintop/minHover.png"
            onClicked: {
                webWindow.visibility = Window.Minimized
            }
        }

        ControlButton {
            id:max
            anchors.top: parent.top
            anchors.right: close.left
            width: 25
            height: 19
            normalImage: "qrc:/resource/images/main/maintop/max.png"
            hoverImage: "qrc:/resource/images/main/maintop/maxHover.png"

            onClicked: {
                if(webWindow.visibility == Window.Maximized)
                {
                    webWindow.visibility = Window.Windowed
                }
                else
                {
                    webWindow.visibility = Window.Maximized
                }
            }
        }

        ControlButton{
            id:close
            anchors.top: parent.top
            anchors.right: parent.right
            width: 25
            height: 20
            normalImage: "qrc:/resource/images/main/maintop/close.png"
            hoverImage: "qrc:/resource/images/main/maintop/closeHover.png"
            onClicked:{
                webWindow.deleteitem(pageid)
                //webWindow.close()
            }
        }
    }

    Interface {
        id:inter
        onGetDataSignal: {
            if(msg3 === "web_child_url")
            {
                sendWebUrl(msg1, msg2, msg3);
            }
        }
    }

    WebChannel {
        id: webChannel
    }

    WebEngineView {
        id:webshow

        anchors.top: titlebkg.bottom
        anchors.bottom: parent.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.fill: parent

        url:weburl

        webChannel: webChannel

        smooth: true

        onNewViewRequested:  function(request) {
            var newWindow = windowComponent.createObject(window.parent
                                                         , {"webWidth":(Screen.desktopAvailableWidth)*0.8
                                                             , "webHeight": (Screen.desktopAvailableHeight)*0.8});
            request.openIn(newWindow.webView);
        }
    }

   Component.onCompleted: {
    webChannel.registerObject("interface", inter);
 
   }

}

