import QtQuick 2.0
import QtQuick.Controls 2.2
Image {
    id:bkg
    property string iconImage: ""
    property string hoverImage: ""
    property string textcontent: ""
    property string toolTipText: ""
    property int iconWidth: 0
    property int iconHeight: 0
    property int leftMargin: 0
    signal clicked()
    Image {
        id: icon
        width: iconWidth
        height: iconHeight
        anchors.top: parent.top
        anchors.topMargin: 1
        anchors.left: parent.left
        anchors.leftMargin: leftMargin
        source: iconImage
    }

    Text {
        id: text
        anchors.top: parent.top
        anchors.bottom: parent.bottom
        anchors.right: parent.right
        anchors.left: icon.right
        anchors.leftMargin: 2
        horizontalAlignment: Qt.AlignHCenter
        verticalAlignment: Qt.AlignVCenter
        font.pixelSize: 12
        font.family: "微软雅黑"
        color:  "#ffffff"
        font.bold: false

        text: textcontent

    }

    MouseArea{
        anchors.fill: parent

        hoverEnabled: true
        cursorShape: Qt.PointingHandCursor

        onEntered: {
            bkg.source = hoverImage
            tooltip.text = toolTipText
            tooltip.visible = true
        }

        onExited: {
            bkg.source = ""
            tooltip.visible = false
        }

        onPressed: {
            bkg.clicked()
        }
    }

    ToolTip{
        id: tooltip
        x: 0
        y: iconHeight
    }

}
