import QtQuick 2.0
import QtQuick.Controls 2.2
Image {
    id:bkg
    property string normalImage: ""
    property string hoverImage: ""
    property string textContent: ""
    property int iconWidth: 0
    property int iconHeight: 0
    signal clicked()

    source : normalImage

    MouseArea{
        anchors.fill: parent

        hoverEnabled: true
        cursorShape: Qt.PointingHandCursor

        onPositionChanged: {

        }

        onEntered: {
            bkg.source = hoverImage
            if(textContent != "")
            {
                tooltip.visible = true
                tooltip.text = textContent
            }
        }

        onExited: {
            bkg.source = normalImage
            tooltip.visible = false
            tooltip.text = ""
        }

        onPressed: {
            bkg.clicked()
        }
    }

   ToolTip{
       id: tooltip
   }
}
