import QtQuick 2.0
import QtQuick.Controls 1.3
import QtQuick.Controls.Styles 1.4

Button{
    id:root
    property string normalSource: ""
    property string checkeSource: ""
    property string textContent: ""
    property int iconWidth: 0
    property int iconHeight: 0

    style:ButtonStyle{
        background:  Rectangle {
            id:background
            Image {
                id: icon
                anchors.left: parent.left
                anchors.leftMargin: parent.width/2 - (iconWidth + 4)
                anchors.top: parent.top
                anchors.topMargin: (40 - iconHeight)/2
                width: iconWidth
                height: iconHeight

                states:[
                    State{
                        name:"hovered"
                        when:root.hovered | root.checked
                        PropertyChanges {
                            target: icon
                            source: checkeSource
                        }
                    },

                    State{
                        name:"!hovered"
                        when:!root.hovered | !root.checked
                        PropertyChanges {
                            target: icon
                            source: normalSource

                        }
                    }
                ]
            }
            color: "#ffffff"

            Text{
               id: text_label
               text: textContent
               font.pixelSize: 14
               font.family: "微软雅黑"
               font.bold: false
               anchors.right: parent.right
               anchors.top: parent.top
               anchors.topMargin: (parent.height - text_label.contentHeight) /2
               anchors.rightMargin: parent.width/2 - text_label.contentWidth

               verticalAlignment: Qt.AlignVCenter
               states:[
                   State{
                       name:"hovered"
                       when:root.hovered || root.checked

                       PropertyChanges {
                           target: text_label
                           color: "#368feb"
                       }
                   },

                   State{
                       name:"!hovered"
                       when:!root.hovered || !root.checked
                       PropertyChanges {
                           target: text_label
                           color: "#b0b8bd"
                       }
                   }
               ]
           }


            Rectangle {
                id: bottomLine
                anchors.bottom: background.bottom
                width:root.width
                height: 3

                states:[
                    State{
                        name:"checked"
                        when:root.checked

                        PropertyChanges {
                            target: bottomLine
                            color: "#368feb"
                        }
                    },

                    State{
                        name:"!checked"
                        when:!root.checked
                        PropertyChanges {
                            target: bottomLine
                            color: "#e6e6e6"
                        }
                    }
                ]
            }
        }
    }
}
