﻿import QtQuick 2.0
import QtQuick.Window 2.2
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import "../common"

Window {
    id: versionmessagewindow
    width: 380
    height: 300
    flags: Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint
    modality: Qt.ApplicationModal
    x: (Screen.desktopAvailableWidth - 380)/2
    y: (Screen.desktopAvailableHeight - 300)/2
    opacity: 1.0
    visible: true
    title: "发现新版本"
    property alias messageText: context.text
    property string version: "";
    property bool bPressed: true;
    property bool isSure : false;
    property string versionDownurl: "";
    signal deleteitem();
    signal sigSure(string version,string versiondownurl);
    signal sigCancel();


    MouseArea { //为窗口添加鼠标事件
        id:mouse
        anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true
        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                //如果mainwindow继承自QWidget,用setPos
                versionmessagewindow.setX(versionmessagewindow.x+delta.x)
                versionmessagewindow.setY(versionmessagewindow.y+delta.y)
            }
        }
    }

    Rectangle{
        id: bkg
        anchors.fill: parent
        border.color: "#ffffff"
        border.width: 1
        //  border.source: "qrc:/resource/images/login/versionDialog.png"
        Image {
            id: rocket
            fillMode: Image.TileHorizontally
            smooth: true
            source: 'qrc:/resource/images/login/versionDialog.png'
        }
        Rectangle {
            id: bkgimg
            anchors.top: parent.top
            anchors.left: parent.left
            width: parent.width
            height: 30
            color: "#e8ecf0"

            Image {
                id: titleicon
                anchors.top: parent.top
                anchors.topMargin: 7
                anchors.left:parent.left
                anchors.leftMargin: 6
                source: "qrc:/resource/logo.ico"
                width:16
                height:16
            }

            Text {
                id: titletext
                anchors.top: parent.top
                anchors.topMargin: 4
                anchors.left:titleicon.right
                anchors.leftMargin: 5
                font.pixelSize: 14
                font.bold: false
                font.family: "微软雅黑"
                color: "#1a67c2"
                text: qsTr("发现新版本")
            }

            ControlButton {
                id: close
                anchors.top: parent.top
                anchors.topMargin: 8
                anchors.right: parent.right
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/login/versionDialogclose.png"
                //hoverImage: "qrc:/resource/images/login/versionDialogclose.png"
                onClicked:{
                    sigCancel();
                    versionmessagewindow.deleteitem();
                    versionmessagewindow.close();
                }
            }
        }


        /*  Image {
            id: icon
            anchors.left: parent.left
            anchors.leftMargin: 40
            anchors.top: bkgimg.bottom
            anchors.topMargin: 40
            width: 34
            height: 30
            source: "qrc:/resource/images/main/common/hint.png"

        }*/

        Text {
            id: context
            height: 45
            width: 255
            anchors.left: parent.left
            anchors.leftMargin: 65
            anchors.top: parent.top
            anchors.topMargin: 180
            horizontalAlignment: Text.AlignHCenter
            font.pixelSize: 16
            font.family: "微软雅黑"
            color: "#666666"
        }

        /*Rectangle{
            id: line
            anchors.bottom: surebtn.top
            anchors.bottomMargin: 15
            anchors.left: parent.left
            anchors.right: parent.right
            color: "#eeeeee"
            height: 1
            visible: false
        }*/

        ControlButton {
            id: surebtn
            width: 90
            height: 36
            anchors.right: cancelbtn.left
            anchors.rightMargin: 16
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 15
            normalImage: "qrc:/resource/images/立即点击.png"
            hoverImage: "qrc:/resource/images/立即.png"
            MouseArea{
                id:surebtnmouse
                anchors.fill: parent
                //enabled: edit.text.length?true:false
                hoverEnabled: true
                cursorShape: Qt.PointingHandCursor
                onEntered: {//鼠标离开信号
                    console.log("Entered")
                }

                onExited: {//鼠标进入信号
                    console.log("Exited")
                }

                onClicked: {
                    versionmessagewindow.close();
                    sigSure( version,versionDownurl);



                }
            }
        }


        ControlButton {
            id: cancelbtn
            width: 90
            height: 36
            anchors.right: parent.right
            anchors.rightMargin: 95
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 15
            normalImage: "qrc:/resource/images/暂不.png"
            hoverImage: "qrc:/resource/images/暂不点击.png"
            MouseArea{
                id:cancelbtnmouse
                anchors.fill: parent
                //enabled: edit.text.length?true:false
                hoverEnabled: true
                cursorShape: Qt.PointingHandCursor
                onEntered: {//鼠标离开信号
                    console.log("Entered")

                }

                onExited: {//鼠标进入信号
                    console.log("Exited")

                }
                onClicked: {
                    sigCancel();
                    versionmessagewindow.deleteitem();
                    versionmessagewindow.close();
                }
            }
        }
    }
}

