﻿import QtQuick 2.0
import QtQuick.Window 2.0
import Qt.labs.platform 1.0
import FileIo 1.0
import TrayIconUpdate 1.0
import LoginWebServer 1.0
//import getClientversion 1.0
import GetClientversion 1.0
import WebRunPlatform 1.0
import WebIEPlatform 1.0
import "./js/query.js" as Query
import "./js/map.js" as MapJS
import "main"
import "login"
import "common"
import "chat"
import "signalWeb"

Window {
    id:window
    objectName: "mainwindow"
    
    visible: true
    minimumWidth: 300
    minimumHeight: 650

    title:"OA办公精灵"
    color:"#CCCCCC"
    
    x: 500
    y: 50
    property string windowtitle: ""
    property string companyoid: ""
    property string oaoutnet: ""
    property string strip: ""
    property string strusername: ""
    property string strusername2;  //姓名
    property string strpasswd: ""
    property var taryMsgdataMap: new MapJS.Map();//图标闪烁用来未读消息记录界面有多少用户及用户名
    property bool bPressed: false
    property string userJid: ""
    property string strChatMsg: ""
    property int screenwidth: Screen.desktopAvailableWidth
    property int screenheight: Screen.desktopAvailableHeight
    property string userautologin : ""
    property bool isLoginSuccessful: false
    property bool isWindowsHide: false
    property var versionmesageObj: null

    property int _mainwindowX: mainwindow.x
    property int _mainwindowY: mainwindow.y
    property int _mainwindowW: mainwindow.width
    property int _mainwindowh:0// 680
    // Behavior on x {PropertyAnimation {duration: 500} }
    // Behavior on y {PropertyAnimation {duration: 500} }
    // Behavior on width{PropertyAnimation {duration: 500}}
    //Behavior on height{PropertyAnimation {duration: 20}}


    property string _gu1 : ""
    property string _gu2 : ""
    
    
    property int  webWidth: Screen.desktopAvailableWidth*0.8
    property int  webHeight: Screen.desktopAvailableHeight*0.8
    
    //flags: Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.WindowSystemMenuHint |Qt.Tool   | Qt.WindowStaysOnTopHint | Qt.X11BypassWindowManagerHint
    flags: Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.WindowSystemMenuHint |Qt.Tool


    WebRunPlatform{
        id:webrun_logout
    }
    Messagecs{

        id:messagecs
        visible: false


    }
    FileIo {
        id: fileio
    }
    WebIEPlatform
    {
        id:iewebrun
    }
    GetClientversion
    {
        id:getclientversion
    }

    Rectangle{
        id: titlebkg
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.right: parent.right
        height: 28
        color: "#169ADA"

    Text {
        id: title
        anchors.top: parent.top
        anchors.topMargin: 0
        anchors.leftMargin: 3
        font.family: "微软雅黑"
        font.pixelSize: 12
        height: 28
        color: "#FFFFFF"
        verticalAlignment: Qt.AlignVCenter
        text: qsTr("关于OA办公精灵"+window.x)
    }

    }
   /*
    MouseArea {
        acceptedButtons: Qt.LeftButton
        hoverEnabled: true

        property var window: parent

        property int borderWidth: 8
        property int minimumWidth: 48
        property int minimumHeight: 48
        property int maximumWidth: 0
        property int maximumHeight: 0

        // Program runtime dynamic data
        property int resizing: 0
        property real firstWidth: 0
        property real firstHeight: 0
        property real firstMouseX: 0
        property real firstMouseY: 0

        function getValidWidth(width) {
            if (minimumWidth > 0 && width < minimumWidth)
                return minimumWidth;

            if (maximumWidth > minimumWidth && width > maximumWidth)
                return maximumWidth;

            return width;
        }

        function getValidHeight(height) {
            if (minimumHeight > 0 && height < minimumHeight)
                return minimumHeight;

            if (maximumHeight > minimumHeight && height > maximumHeight)
                return maximumHeight;

            return height;
        }

        function getMousePosition(window, mouseX, mouseY) {
            if (mouseX < borderWidth) {
                if (mouseY < borderWidth) {
                    return 1; // left top
                } else if (mouseY < window.height - borderWidth) {
                    return 2; // left
                } else {
                    return 3; // left bottom
                }
            } else if (mouseX < window.width - borderWidth) {
                if (mouseY < borderWidth) {
                    return 4; // top
                } else if (mouseY < window.height - borderWidth) {
                    return 5; // center
                } else {
                    return 6; // bottom
                }
            } else {
                if (mouseY < borderWidth) {
                    return 7; // right top
                } else if (mouseY < window.height - borderWidth) {
                    return 8; // right
                } else {
                    return 9; // right bottom
                }
            }
        }

        function getCursorShape(window, mouseX, mouseY) {
            switch (getMousePosition(window, mouseX, mouseY)) {
            case 1: return Qt.SizeFDiagCursor;
            case 2: return Qt.SizeHorCursor;
            case 3: return Qt.SizeBDiagCursor;
            case 4: return Qt.SizeVerCursor;
            case 5: return Qt.ArrowCursor;
            case 6: return Qt.SizeVerCursor;
            case 7: return Qt.SizeBDiagCursor;
            case 8: return Qt.SizeHorCursor;
            case 9: return Qt.SizeFDiagCursor;
            default: break;
            }

            return Qt.ArrowCursor;
        }

        function resizeLeftTop(window, mouseX, mouseY) {
            var offsetX = mouseX - firstMouseX;
            var offsetY = mouseY - firstMouseY;

            var x = window.x + offsetX;
            var y = window.y + offsetY;
            var width = window.width - offsetX;
            var height = window.height - offsetY;

            // Lock-in maximum and minimum
            offsetX = width - getValidWidth(width);
            offsetY = height - getValidHeight(height);
            x = x + offsetX;
            width = width - offsetX;
            y = y + offsetY;
            height = height - offsetY;

            window.x = x;
            window.y = y;
            window.width = width;
            window.height = height;
        }

        function resizeLeft(window, mouseX, mouseY) {
            var offsetX = mouseX - firstMouseX;

            var x = window.x + offsetX;
            var width = window.width - offsetX;

            // Lock-in maximum and minimum
            offsetX = width - getValidWidth(width);
            x = x + offsetX;
            width = width - offsetX;

            window.x = x;
            window.width = width;
        }

        function resizeLeftBottom(window, mouseX, mouseY) {
            var offsetX = mouseX - firstMouseX;
            var offsetY = mouseY - firstMouseY;

            var x = window.x + offsetX;
            var width = window.width - offsetX;
            var height = firstHeight + offsetY;

            // Lock-in maximum and minimum
            offsetX = width - getValidWidth(width);
            x = x + offsetX;
            width = width - offsetX;
            height = getValidHeight(height);

            window.x = x;
            window.width = width;
            window.height = height;
        }

        function resizeTop(window, mouseX, mouseY) {
            var offsetY = mouseY - firstMouseY;

            var y = window.y + offsetY;
            var height = window.height - offsetY;

            // Lock-in maximum and minimum
            offsetY = height - getValidHeight(height);
            y = y + offsetY;
            height = height - offsetY;

            window.y = y;
            window.height = height;
        }

        function resizeBottom(window, mouseX, mouseY) {
            var offsetY = mouseY - firstMouseY;

            var height = firstHeight + offsetY;

            // Lock-in maximum and minimum
            height = getValidHeight(height);

            window.height = height;
        }

        function resizeRightTop(window, mouseX, mouseY) {
            var offsetX = mouseX - firstMouseX;
            var offsetY = mouseY - firstMouseY;

            var y = window.y + offsetY;
            var width = firstWidth + offsetX;
            var height = window.height - offsetY;

            // Lock-in maximum and minimum
            offsetY = height - getValidHeight(height);
            y = y + offsetY;
            width = getValidWidth(width);
            height = height - offsetY;

            window.y = y;
            window.width = width;
            window.height = height;
        }

        function resizeRight(window, mouseX, mouseY) {
            var offsetX = mouseX - firstMouseX;

            var width = firstWidth + offsetX;

            // Lock-in maximum and minimum
            width = getValidWidth(width);

            window.width = width;
        }

        function resizeRightBottom(window, mouseX, mouseY) {
            var offsetX = mouseX - firstMouseX;
            var offsetY = mouseY - firstMouseY;

            var width = firstWidth + offsetX;
            var height = firstHeight + offsetY;

            // Lock-in maximum and minimum
            width = getValidWidth(width);
            height = getValidHeight(height);

            window.width = width;
            window.height = height;
        }

        function move(window, mouseX, mouseY) {
            window.x = window.x + (mouseX - firstMouseX);
            window.y = window.y + (mouseY - firstMouseY);
        }

        function resize(window, mouseX, mouseY) {
            switch (resizing) {
            case 1:
                resizeLeftTop(window, mouseX, mouseY);
                break;
            case 2:
                resizeLeft(window, mouseX, mouseY);
                break;
            case 3:
                resizeLeftBottom(window, mouseX, mouseY);
                break;
            case 4:
                resizeTop(window, mouseX, mouseY);
                break;
            case 5:
                move(window, mouseX, mouseY);
                break;
            case 6:
                resizeBottom(window, mouseX, mouseY);
                break;
            case 7:
                resizeRightTop(window, mouseX, mouseY);
                break;
            case 8:
                resizeRight(window, mouseX, mouseY);
                break;
            case 9:
                resizeRightBottom(window, mouseX, mouseY);
                break;
            default:
                break;
            }
        }

        onPositionChanged: {
            if (resizing == 0) {
                cursorShape = getCursorShape(window, mouse.x, mouse.y);
            } else {
                resize(window, mouse.x, mouse.y);
            }
        }

        onPressed: {
            resizing = getMousePosition(window, mouseX, mouseY);
            firstWidth = window.width;
            firstHeight = window.height;
            firstMouseX = mouseX;
            firstMouseY = mouseY;
        }

        onReleased: {
            resizing = 0;
        }
    }
*/

    function getClientversion(str)
    {
        //  getClientversion.getClientversionfromSever(str)
    }
    function getuserinfos()
    {
        oaoutnet = fileio.readIniFile("login", "useroutnetlogin")
        if(oaoutnet === "0") //内网登录
        {
            strip = fileio.readIniFile("login", "oainnet")

        }
        else if(oaoutnet === "1")//外网登录
        {
            strip = fileio.readIniFile("login", "oaoutnet")

        }
        else if(oaoutnet === "2")//测试地址
        {
            strip = fileio.readIniFile("login", "oatestnet")

        }
        else
        {
            console.log(" 配置文件内没有保存对应网址");
        }



        //对旧密码进行加密处理
        strpasswd = fileio.readIniFile("login", "passwd1");

        if(strpasswd!="")
        {
            fileio.writeIniFile("login", "xoabang1", fileio.textEncode(strpasswd,"X"));
            fileio.writeIniFile("login", "passwd1","");
        }

        strpasswd = fileio.readIniFile("login", "passwd")

        if(strpasswd!="")
        {
            fileio.writeIniFile("login", "xoabang", fileio.textEncode(strpasswd,"X"));
            fileio.writeIniFile("login", "passwd","");
        }


        //获取保存的用户名密码
        if(fileio.readIniFile("login", "reboot")=="1" && fileio.readIniFile("login", "username1")!="")
        {
            strusername = fileio.readIniFile("login", "username1");
            var xoabang1= fileio.readIniFile("login", "xoabang1");
            strpasswd=fileio.textDecode(xoabang1,"X");

            companyoid = fileio.readIniFile("login", "companyoid1")
        }
        else
        {
            strusername = fileio.readIniFile("login", "username");
            var xoabang= fileio.readIniFile("login", "xoabang")
            strpasswd=fileio.textDecode(xoabang,"X");

            companyoid = fileio.readIniFile("login", "companyoid")


            //var xoabang=fileio.textEncode(strpasswd,"X");
            //console.log("加密后的密码",xoabang);
            //var password=fileio.textDecode(xoabang,"X");
            //console.log("解密后的密码",password);

        }
        
    }

    TrayIconUpdate {
        id: trayIconUpdate
    }
    
    LoginWebServer {
        id: loginWebServer
    }

    ChatToolTipView{
        id: chattooltip
        width: 220
        visible: false
        
        onItemClicked: {
            console.log("点击了闪烁提醒消息中的一条，总数为:",chattooltip.getModelCount(),"jid为:",jid);
            if(chattooltip.getModelCount() == 1)
            {
                if(jid === "/email/index?")
                {
                    //console.log("点击了闪烁提醒消息中的/email/index?");
                    taryMsgdataMap.remove("'" + jid + "'")
                    chattooltip.removeAtIndex();
                    _msgtimer.running = false;
                    trayIconUpdate.updateTrayIcon(":/resource/logo.ico")
                    chattooltip.visible = false;
                    chattooltip.hide();
                    var  paramurl = strip + "/email/index?lang=zh_CN";
                    //Qt.openUrlExternally(paramurl+"&JSESSIONID1=" + mainwindow.jsessionid)
                    //iewebrun._vNewWindows((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"电子邮件",true,"");

                    //iewebrun._vNewWindows_IE((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"电子邮件");
                    iewebrun._vNewWindows_XOAbrowser((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"电子邮件",true);


                }
                else if(jid === "/sms/index?")
                {
                    //console.log("点击了闪烁提醒消息中的/sms/index?");
                    taryMsgdataMap.remove("'" + jid + "'")
                    chattooltip.removeAtIndex();
                    _msgtimer.running = false;
                    trayIconUpdate.updateTrayIcon(":/resource/logo.ico")
                    mainwindow.cleartopseralarms()
                    chattooltip.visible = false;
                    chattooltip.hide();
                    var  paramurl = strip + "/sms/index?lang=zh_CN";
                    // Qt.openUrlExternally(paramurl+"&JSESSIONID1=" + mainwindow.jsessionid)


                    //iewebrun._vNewWindows_IE((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"事务提醒");
                    iewebrun._vNewWindows_XOAbrowser((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"事务提醒",true);
                    //iewebrun._vNewWindows((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"事务提醒",true,"");

                }
                else
                {
                    //console.log("点击了普通消息,chatname:",chatname);
                    mainwindow.showObj(jid,chatname);
                    taryMsgdataMap.remove("'" + jid + "'")
                    chattooltip.removeAtIndex();
                    _msgtimer.running = false;
                    trayIconUpdate.updateTrayIcon(":/resource/logo.ico")
                    chattooltip.visible = false;
                    chattooltip.hide();
                }

            }
            else
            {
                if(jid === "/email/index?")
                {
                    taryMsgdataMap.remove("'" + jid + "'")
                    chattooltip.removeAtIndex();
                    _msgtimer.running = true;
                    trayIconUpdate.updateTrayIcon(":/resource/logo.ico")
                    chattooltip.visible = false;
                    chattooltip.hide();
                    var  paramurl = strip + "/email/index?lang=zh_CN";
                    // Qt.openUrlExternally(paramurl+"&JSESSIONID1=" + mainwindow.jsessionid)
                    //iewebrun._vNewWindows_IE((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"电子邮件");
                    iewebrun._vNewWindows_XOAbrowser((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"电子邮件",true);

                    //iewebrun._vNewWindows((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"电子邮件",true,"");

                }
                else if(jid === "/sms/index?")
                {
                    taryMsgdataMap.remove("'" + jid + "'")
                    chattooltip.removeAtIndex();
                    _msgtimer.running = true;
                    trayIconUpdate.updateTrayIcon(":/resource/logo.ico")
                    chattooltip.visible = false;
                    chattooltip.hide();

                    var  paramurl = strip + "/sms/index?lang=zh_CN";
                    //iewebrun._vNewWindows((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"事务提醒",true,"");
                    mainwindow.cleartopseralarms()
                    //iewebrun._vNewWindows_IE((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"事务提醒");
                    iewebrun._vNewWindows_XOAbrowser((paramurl+"&JSESSIONID1=" + mainwindow.jsessionid).toString(),"事务提醒",true);
                    // Qt.openUrlExternally(paramurl+"&JSESSIONID1=" + mainwindow.jsessionid)
                }
                else
                {
                    mainwindow.showObj(jid,chatname);
                    taryMsgdataMap.remove("'" + jid + "'")
                    chattooltip.removeAtIndex();
                    _msgtimer.running = true;
                    chattooltip.hide();
                }
            }

            // chattooltip.deleteAllItem();

        }
        
        onDeleteAllItem: {
            chattooltip.clearAllItem();
            taryMsgdataMap.clear();
            chattooltip.visible = false
            chattooltip.hide();
            _msgtimer.running = false;
            trayIconUpdate.updateTrayIcon(":/resource/logo.ico")
            //  mainwindow.destroyallobject();
        }
        onDeleteOneItem: {
            console.log("")
            mainwindow.showObj(jid,chatname);
            taryMsgdataMap.remove("'" + jid + "'")
            removeAtIndex();
            _msgtimer.running = false;
            trayIconUpdate.updateTrayIcon(":/resource/logo.ico")
        }
        
    }
    
    function setWindowTitle(Title)
    {
        window.title = Title;
    }
    
    function loginCallback(userjson)
    {
        console.log("登录成功后检查共享内存中账号",strusername)
        console.log("登录接口接口返回数据:",userjson) //gaobo wait

        if(userjson=="" ||userjson.indexOf("404")!=-1)
        {
            console.log("登录失败，网址无法访问！")
            messagecs.messageText = "登录失败，网址无法访问！"
            messagecs.visible=true
            return
        }
        else if(userjson.indexOf("301 Moved Permanently")!=-1 && strip.indexOf("http://")!=-1)
        {

            strip=strip.replace("http://","https://")

            //将https地址写入配置文件
            fileio.writeIniFile("login", "dnsip", strip)

            oaoutnet = fileio.readIniFile("login", "useroutnetlogin")
            if(oaoutnet === "0") //内网登录
            {
                fileio.writeIniFile("login", "oainnet", strip)
            }
            else if(oaoutnet === "1")//外网登录
            {
                fileio.writeIniFile("login", "oaoutnet", strip)
            }
            else if(oaoutnet === "2")//测试地址
            {
                fileio.writeIniFile("login", "oatestnet", strip)
            }

            //开始登录

            var url = strip + "/login?loginId=" + companyoid +"&userAgent=pc" + "&username=" + strusername + "&password=" + strpasswd
                    +"&clientVersion=" + fileio.readIniFile("def", "autologinMode")+"&clientType=pc"
            var url_urlcode = encodeURIComponent(url);
            loginWebServer.loginWebServer(strip + "/login?loginId=" + companyoid +"&userAgent=pc" + "&username=" + strusername + "&password=" + encodeURIComponent(strpasswd)
                                          +"&clientVersion=" + fileio.readIniFile("def", "autologinMode")+"&clientType=pc")
            return
        }

        var strGaobo = fileio.readIniFile("login", "gaobo")

        if(fileio.findstrusersharememory(strusername) && strGaobo!=1)
        {
            console.log("查找到共享内存已有账号:",strusername)
            messagecs.messageText = "你已登录"+strusername+"账号"
            messagecs.visible = true;
            login.logininfoid = true
            login.loginbtnid = true
            login.cancelbtnid = false
            login.loginingid = false
            login.loginingiconid = false
            login.rememberpasswdid = true
            login.autologinid = true
            return
        }

        console.log("开始保存到共享内存账号:",strusername)  //这几个汉字不能修改，会根据这个判断是否含有用户ID

        var obj = eval('(' + userjson + ')');
        if("flag" in obj )
        {
            if(obj.flag)
            {
                fileio.exesavesharememory(strusername);
                console.log("成功保存到共享内存账号:",strusername)
                mainwindow.jsessionid = obj.msg
                var struncode = encodeURIComponent(strusername);

                //now
                mainwindow.weburl =  strip +"/spirit/main?company="+window.companyoid+"&USERNAME=" + struncode + "&PASSWORD=" + encodeURIComponent(strpasswd) + "&JSESSIONID1=" +obj.msg

                //mainwindow.weburl =strip + "/spirit/zz?"+"JSESSIONID1=" +obj.msg
                //webeng1.url = strip + "/spirit/zz?JSESSIONID1="+jsessionid

                console.log("应用界面地址:",strip +"/spirit/main?company="+companyoid+"&USERNAME=" + strusername + "&PASSWORD=xxxx" + "" + "&JSESSIONID1=" +obj.msg)

                // console.log("getUserParm____",userjson)
                //            login.visible = false
                //            mainwindow.visible = true
                //            window.isLoginSuccessful = true

                mainwindow.userOnlineStatus(true)
                mainwindow.getUserInfo(userjson)

            }
            else
            {
                mainwindow.getError(obj.code,obj.msg)
                login.visible = true
                mainwindow.visible = false
                window.isLoginSuccessful = false
            }
        }
        else
        {//console.log("obj.flag",obj.flag,obj.code)
            mainwindow.getError(obj.code,"未知错误")
            login.visible = true
            mainwindow.visible = false
            window.isLoginSuccessful = false

        }

        //记录窗口位置
        fileio.writeIniFile("login", "windowX", window.x)
        fileio.writeIniFile("login", "windowY", window.y)

    }
    
    ResizeItem {
        z: 1
        enableSize: 8
        anchors.fill: parent
        
        Login {
            id:login
            width: window.width
            height: window.height
            visible: true
            
            onLoginSuccess: {
                console.log("点击了登录按钮，查找共享内存中账号","目标账号:",strusername,"共享内存中账号:",fileio.exereadsharememory())//,fileio.exereadsharememory()
                getuserinfos()
                var strGaobo = fileio.readIniFile("login", "gaobo")
                if(fileio.findstrusersharememory(strusername) && strGaobo!=1)
                {
                    console.log("查找到共享内存已有账号:",strusername,"弹窗提示已登录账号")
                    messagecs.messageText = "您已经登录"+strusername+"账号"
                    messagecs.visible = true;
                    login.logininfoid = true
                    login.loginbtnid = true
                    login.cancelbtnid = false
                    login.loginingid = false
                    login.loginingiconid = false
                    login.rememberpasswdid = true
                    login.autologinid = true
                    return
                }

                // console.log(" f 12  ")
                logininfoid = false
                loginbtnid = false
                cancelbtnid = true  //取消按钮
                loginingid = true   //登陆中image
                login.visible = true  //登陆界面
                mainwindow.visible = false  //主界面
                strpasswd = userjson
                //console.log("strpasswd=",userjson)
                console.log("成功登陆，用户名：",strusername)


                var strutf8username= fileio.utf8fu(strusername)
                //strusername.
                //console.log("utf8fu用户名：",strutf8username)

                var url = strip + "/login?loginId=" + companyoid +"&userAgent=pc" + "&username=" + strusername + "&password=" + strpasswd
                        +"&clientVersion=" + fileio.readIniFile("def", "autologinMode")+"&clientType=pc"
                var url_urlcode = encodeURIComponent(url);
                loginWebServer.loginWebServer(strip + "/login?loginId=" + companyoid +"&userAgent=pc" + "&username=" + strusername + "&password=" + encodeURIComponent(strpasswd)
                                              +"&clientVersion=" + fileio.readIniFile("def", "autologinMode")+"&clientType=pc")
                console.log("登录接口地址:",strip + "/login?loginId=" + companyoid +"&userAgent=pc" + "&username=" + strutf8username + "&password=xxx"//+strpasswd
                            +"&clientVersion=" + fileio.readIniFile("def", "autologinMode")+"&clientType=pc");

                //    //  fileio.makepersonal(strusername)
                //Query.loginWebServer(strip,strusername,strpasswd, companyoid, loginCallback)

                //gaobo 注释掉下面这句
                //mainwindow.weburl =  strip +"/spirit/login?company="+companyoid+"&USERNAME=" + strusername + "&PASSWORD=" + strpasswd
                
                //   console.log("loginCallback_",url )
                //   console.log("loginCallback_userjson_",userjson )1

            }
        }
        
        MainWindow {
            id: mainwindow
            width: window.width
            height: window.height
            visible: false
            _Maincompanyoid:companyoid
            
            onMinClicked: {
                window.flags = Qt.Window | Qt.FramelessWindowHint //| Qt.WindowStaysOnTopHint
                window.visible=false
                // window.visibility = Window.Minimized
                //  console.log(" f 12  ")
            }
            
            onMaxClicked: {
                // console.log(" f 8  ")
                if(window.visibility == Window.Windowed)
                {
                    //    console.log(" f 9  ")
                    window.visibility = Window.Maximized
                }
                else
                {
                    //    console.log(" f 10  ")
                    window.visibility = Window.Windowed
                }
                // console.log(" f 11  ")
            }
            
            onCloseClicked: {
                window.flags = Qt.FramelessWindowHint | Qt.Window
                window.visible=false//window.hide()
            }
            
            /*function getUserParm(userjson)
            {
                console.log(" e 3  ")
                getUserInfo(userjson);
                console.log(" e 4  ")
            }*/
            
            
            function getError(errorcode,errmsg){
                loginWebServerErr(errorcode,errmsg);
            }
            
            onUserOnlineStatus: {
                if(flags)
                {
                    // console.log(" f 4  ")
                    login.visible = false
                    mainwindow.visible = true
                    window.isLoginSuccessful = true
                    //  console.log(" f 5  ")
                }
                else
                {
                    // console.log(" f 6  ")
                    login.visible = true
                    mainwindow.visible = false
                    window.isLoginSuccessful = false
                    // console.log(" f 7  ")
                }
            }
            
            Component.onCompleted: {
                _mainwindowh = window.height
                //console.log("_mainwindowh_______",_mainwindowh)
                //console.log("主窗口检测到桌面宽度：",Screen.desktopAvailableWidth)
                userautologin = fileio.readIniFile("login", "autologin")
                var strReboot = fileio.readIniFile("login", "reboot")
                var strGaobo = fileio.readIniFile("login", "gaobo")
                getuserinfos()
                if(userautologin == "2" || strReboot=="1") //自动登录，或者 掉线重登
                {

                    if(strReboot=="1")
                    {
                        console.log("开始掉线重登 reboot")
                        fileio.writeIniFile("login", "reboot", "0");
                    }
                    else
                        console.log("开始自动登录 autologin")

                    if(fileio.readIniFile("login", "switchUser")=="1")  //切换用户操作，自动登录不生效
                    {
                        fileio.writeIniFile("login", "switchUser", "0");
                        login.logininfoid = true
                        login.loginbtnid = true
                        login.cancelbtnid = false
                        login.loginingid = false
                        login.loginingiconid = false
                        login.rememberpasswdid = true
                        login.autologinid = true
                        return
                    }

                    if(fileio.findstrusersharememory(strusername) && strReboot!="1" && strGaobo!=1)
                    {
                        messagecs.messageText = "你已登录"+strusername+"账号"
                        messagecs.visible = true;
                        login.logininfoid = true
                        login.loginbtnid = true
                        login.cancelbtnid = false
                        login.loginingid = false
                        login.loginingiconid = false
                        login.rememberpasswdid = true
                        login.autologinid = true
                        return
                    }


                    fileio.exesavesharememory(strusername);
                    console.log("自动登录进入，成功保存到共享内存账号:",strusername)


                    /*    logininfoid = false
                    loginbtnid = false
                    cancelbtnid = true  //取消按钮
                    loginingid = true   //登陆中image
                    login.visible = true  //登陆界面
                    mainwindow.visible = false  //主界面
                    strpasswd = userjson
                    //console.log("strpasswd=",userjson)

                    var url = strip + "/login?loginId=" + companyoid +"&userAgent=pc" + "&username=" + strusername + "&password=" + strpasswd
                            +"&clientVersion=" + fileio.readIniFile("def", "autologinMode")+"&clientType=pc"
                    loginWebServer.loginWebServer(url)
                    console.log("登录接口地址:",url);*/
                    login.logininfoid = false
                    login.loginbtnid = false
                    login.rememberpasswdid = false
                    login.autologinid = false
                    login.loginingiconid = true
                    login.cancelbtnid = true
                    login.loginingid = true
                    //fileio.writeIniFile()
                    /*  if(rememberpasswd.checkedState)
                     {
                         fileio.writeIniFile("login", "passwd", userpasswd.text)
                     }*/


                    login.visible = true
                    mainwindow.visible = false
                    // mainwindow.weburl =  strip +"/spirit/login?company="+window.companyoid+"&USERNAME=" + strusername + "&PASSWORD=" + strpasswd

                    console.log("主窗口应用页面地址:",strip  +"/spirit/login?company="+window.companyoid+"&USERNAME=" + strusername + "&PASSWORD=xxxx" )//+strpasswd

                    getclientversion.getClientversionfromSever(strip+"/sys/getAPPMessage")

                    if(strReboot!="1")
                    {
                       //login.loginSuccess(fileio.readIniFile("login", "passwd"))
                        var xoabang= fileio.readIniFile("login", "xoabang")
                        login.loginSuccess(fileio.textDecode(xoabang,"X"));

                    }
                    else
                    {
                       //login.loginSuccess(fileio.readIniFile("login", "passwd1"))
                        var xoabang1= fileio.readIniFile("login", "xoabang1")
                        login.loginSuccess(fileio.textDecode(xoabang1,"X"));


                       fileio.writeIniFile("login", "username1", "");
                       //fileio.writeIniFile("login", "passwd1", "");
                       fileio.writeIniFile("login", "xoabang1", "");

                       fileio.writeIniFile("login", "companyoid1", "");
                    }

                    console.log("strip===",strip)
                    // getclientversion.getClientversionfromSever(strip+"/sys/getAPPMessage")
                }

                //fileio.writeIniFile("login", "switchlogin", "1")
                //getclientversion.sigGetVersionSuccess.connect(getClientversionsuessed)

            }
        }


        Timer {
            id: _msgtimer
            property bool bflag: false
            interval: 400;
            repeat: true
            onTriggered:
            {
                if(!bflag)
                {
                    trayIconUpdate.updateTrayIcon(":/resource/images/main/common/chat.png")
                    bflag = !bflag
                }
                else
                {
                    trayIconUpdate.updateTrayIcon(":/resource/images/main/common/chat2.png");
                    bflag = !bflag
                }
            }
            
        }
        
        function setWindowSize()
        {
            window.maximumWidth = Screen.desktopAvailableWidth
            window.maximumHeight = Screen.desktopAvailableHeight
        }
        
        //收到群聊消息
        function getgroupMsg(strMsg,chatuserjid)
        {
            //!底层数据不一致，需要交换数据
            console.log("收到群组的新消息:",strMsg,"收到群组的新消息openfire用户参数:",chatuserjid)
            var _temstrMsg = chatuserjid;
            //strMsg = chatuserjid;
            chatuserjid = _temstrMsg.split("/")[0]+"/"+_temstrMsg.split("/")[1];

            var _sGuid = _temstrMsg.split("/")[0];
            var _sUid  = _temstrMsg.split("/")[1];
            var _sUuid = _temstrMsg.split("/")[2];
            //console.log("new groub msg _sGuid",_sGuid)
            //console.log("new groub msg _sGuid",_sUid)
            //console.log("new groub msg _sGuid",_sUuid)
            if(strMsg.indexOf("callbackmsg")>=0)//! 包含callbackmsg字样
            {
                //群消息无法有回执消息。所以注释掉
                // mainwindow.callbackmsg(_sGuid,strMsg);
                return;
            }

            String.prototype.endsWith=function(endStr){
                var d=this.length-endStr.length;
                return (d>=0&&this.lastIndexOf(endStr)==d)
            }

            var strTemMsg = strMsg.replace(/\n/g,"\\\\n").replace(/\r/g,"\\\\r");
            var obj1 = JSON.parse(strTemMsg)


            //strChatMsg = strTemMsg;
            // userJid = _sGuid

            if(obj1.type === "text"  || obj1.type === "shaking"||obj1.type === "groupgeneral" )//收到群邀请按文本消息处理2018-11-5
            {
                mainwindow.modifyConversationModel(obj1.data, obj1.send_time, _sGuid, obj1.type,obj1.groupname,obj1.uuid)
            }
            else
            {
                console.log("回执消息，会话列表插入了一个回执消息")
                if(obj1.type === "file")
                {
                    mainwindow.modifyConversationModel(obj1.data.file_name, obj1.send_time, _sGuid, obj1.type,obj1.groupname,obj1.uuid)
                }
                else
                {
                    mainwindow.modifyConversationModel(obj1.data, obj1.send_time, _sGuid, obj1.type,obj1.groupname,obj1.uuid)
                }
            }

            /*

            if(!mainwindow.getObjIsCreate(_sGuid))
            {
                //creatObj(username, userprivname, usersex, jid, usermobileno, bshow, strStaus,ImgSoure)
                //console.log(username, userprivname, usersex, jid, usermobileno, bshow, strStaus,ImgSoure)
                if(strMsg.indexOf("groupname"))
                {
                    mainwindow.creatGroupObj(obj1.groupname, "", "1", _sGuid,"", false," ","qrc:/resource/images/im/45.png","","");

                    //creatGroupObj(name,strStartTime,nike,nike,nike,true,"","qrc:/resource/images/im/45.png","","");
                    // username:群组名称（不为空）
                    // userprivname：群成员名称(空)
                    // usersex：性别（空）
                    // jid：聊天对象jid（openfire房间号）（不为空）
                    // usermobileno：用户手机号（空）
                    // bshow：是否显示（true）
                    // strStaus：字符状态(空)
                    // ImgSoure：http://192.168.0.18/img/im/groupchat.png
                    // creatObj： （空）
                    // groudmsglist：（空）
                }
                else
                {
                    mainwindow.creatGroupObj("未知群", "", "1", _sGuid,"", false,"","qrc:/resource/images/im/45.png","","");
                }
                // mainwindow._appendGroudMsg(_sGuid, strChatMsg);
                console.log("匿名用户 strChatMsg", strMsg,_sGuid,obj1.uuid)
                //chatGetUserInfo.getUserInfo(mainwindow.jsessionid, strURL, 1);
            }
            else
            {
                console.log("非匿名用户 strChatMsg", strMsg,_sGuid,obj1.uuid)
                mainwindow._appendGroudMsg(_sGuid, strTemMsg);
                //  chatGetUserInfo.getUserInfo(mainwindow.jsessionid, strURL, 1);
            }
            */

            //mainwindow._appendGroudMsg(_sGuid, strTemMsg);  //高波 ，群聊增加到会话列表，感觉重复了


            if(mainwindow.getChatObjVisible(_sGuid))
            {
                console.log("聊天窗口已显示，直接窗口内输入消息");
            }
            else
            {

                if(taryMsgdataMap.isEmpty())
                {
                    taryMsgdataMap.put("'" + _sGuid + "'", 1);
                }
                else
                {
                    if(taryMsgdataMap.containsKey("'" + _sGuid + "'"))
                    {
                        var data = taryMsgdataMap.get("'" + _sGuid + "'" );

                        taryMsgdataMap.remove("'" + _sGuid + "'")

                        var data1 = Number(data) + 1;

                        taryMsgdataMap.put("'" + _sGuid + "'" ,  data1.toString() )
                    }
                    else
                    {
                        taryMsgdataMap.put("'" + _sGuid + "'", 1)
                    }

                }
                mainwindow.modifyUserInfo(_sGuid, taryMsgdataMap.get("'" + _sGuid + "'"))
                console.log("图标开始闪烁");
                _msgtimer.running = true;

                if(strChatMsg.indexOf("groupname"))
                {
                    console.log("是群消息，群的名字:",obj1.groupname);
                    chattooltip.appendData(_sGuid, obj1.groupname, 3, taryMsgdataMap.get("'" + _sGuid + "'"));
                    if(chattooltip.visible == true)
                    {

                        console.log("刷新已经打开的chattooltip")
                        chattooltip.hide()
                        chattooltip.show()

                    }
                }
                else
                {
                    console.log("是群消息，群的名字是空，显示未知群",obj1.groupname);
                    chattooltip.appendData(_sGuid, "未知群", 3, taryMsgdataMap.get("'" + _sGuid + "'"));
                    if(chattooltip.visible == true)
                    {
                        chattooltip.hide()
                        chattooltip.show()
                    }
                }
                if(fileio.readIniFile("IM","newmsgMode") == "true")
                {
                    chattooltip.height = 35 + chattooltip.getModelCount()*50
                    chattooltip.x = screenwidth - 80 - 220;//screenwidth - 80 - 220
                    chattooltip.y = screenheight - chattooltip.height
                    if(chattooltip.visible == false)//gaobo
                    {
                        chattooltip.hide()
                        chattooltip.show()
                    }
                    return
                }

            }

        }


        //---------------------------------------------------------------------------------------------
        //收到单聊消息

        function getchatMsg(strMsg, chatuserjid)
        {

            var strURL ="";

            //![qgz] 消息回执
            console.log("收到个人消息,内容: jid:",strMsg,chatuserjid)
            if(strMsg.indexOf("callbackmsg")>=0)//! 包含callbackmsg字样
            {
                mainwindow.callbackmsg(chatuserjid,strMsg);
                return;
            }


            //strURL = strip + "/user/findUserByuid?uid=" + chatuserjid
            //console.log("收到个人消息:", strMsg, strURL)
            
            String.prototype.endsWith=function(endStr){
                var d=this.length-endStr.length;
                return (d>=0&&this.lastIndexOf(endStr)==d)
            }

            //var strTemMsg = strMsg.replace(/\n/g,"\\\\n").replace(/\r/g,"\\\\r");
            var strTemMsg=strMsg;
            var obj1 = JSON.parse(strTemMsg)



            // strChatMsg = strTemMsg;
            // userJid = chatuserjid

            if(obj1.type === "text"  || obj1.type === "shaking" )
            {
                mainwindow.modifyConversationModel(obj1.data, obj1.send_time, chatuserjid, obj1.type,"",obj1.uuid)
            }
            else
            {
                if(obj1.type === "file")
                {
                    mainwindow.modifyConversationModel(obj1.data.file_name, obj1.send_time, chatuserjid,obj1.type,"",obj1.uuid)
                }
                else
                {
                    mainwindow.modifyConversationModel(obj1.data, obj1.send_time, chatuserjid, obj1.type,"",obj1.uuid)
                }
            }

            //根据UID查询用户信息
            if(!mainwindow.getObjIsCreate(chatuserjid))
            {
                //creatObj(username, userprivname, usersex, jid, usermobileno, bshow, strStaus,ImgSoure)
                if(strMsg.indexOf("name")){
                    //mainwindow.creatObj (obj1.name, "", mainwindow.userjid, chatuserjid,"", false,"","");
                    mainwindow.appendMsg(chatuserjid, strMsg);
                }
                else
                {
                    // mainwindow.creatObj("未知用户", "", mainwindow.userjid, chatuserjid,"", false,"","");
                    mainwindow.appendMsg(chatuserjid, strMsg);
                }

                console.log("主窗口下没找到该聊天窗口，插入会话列表数据", strTemMsg,chatuserjid,obj1.uuid)
                // chatGetUserInfo.getUserInfo(mainwindow.jsessionid, strURL, 1);
            }
            else
            {

                console.log("会话列表已找到该用户，插入会话列表数据:", strTemMsg,chatuserjid,obj1.uuid)


                //mainwindow.creatObj(obj1.name, "", "0", chatuserjid,"", false,"","");

                mainwindow.appendMsg(chatuserjid, strTemMsg);

                //  chatGetUserInfo.getUserInfo(mainwindow.jsessionid, strURL, 1);
            }

            // console.log("b ·");
            
            if(mainwindow.getChatObjVisible(chatuserjid))
            {
                console.log("单聊消息：聊天窗口已显示，不进入消息闪烁提醒");
                // console.log("b 1·");
            }
            else
            {

                if(taryMsgdataMap.isEmpty())
                {
                    console.log("消息提示窗队列为空，直接添加消息条目·");
                    taryMsgdataMap.put("'" + chatuserjid.toString()+ "'", 1);
                }
                else
                {
                    // console.log("b 3·");
                    if(taryMsgdataMap.containsKey("'" + chatuserjid.toString() + "'"))
                    {
                        //  console.log("b 4·");
                        var data = taryMsgdataMap.get("'" + chatuserjid.toString() + "'" );
                        
                        taryMsgdataMap.remove("'" + chatuserjid.toString() + "'")
                        
                        var data1 = Number(data) + 1;
                        //  console.log("b 4·",data1);
                        taryMsgdataMap.put("'" + chatuserjid.toString() + "'" ,  data1.toString())
                        console.log("消息闪烁队列中已有该用户（uid）消息条目，用户jid:",chatuserjid);
                    }
                    else
                    {
                        //console.log("b 4·");

                        console.log("消息闪烁队列中没有该用户（uid）消息条目，用户jid:",chatuserjid);
                        taryMsgdataMap.put("'" + chatuserjid.toString() + "'", 1)
                    }
                }

                console.log("单聊消息：消息开始闪烁");

                //console.log("b 5·");
                //console.log("mmm",chatuserjid, userJid, taryMsgdataMap.get("'" + chatuserjid + "'"))
                //console.log("b 6·",chatuserjid,taryMsgdataMap.get("'" + chatuserjid + "'"));
                //mainwindow.modifyUserInfo(chatuserjid, taryMsgdataMap.get("'" + chatuserjid + "'"))


                _msgtimer.running = true;
                if(strMsg.indexOf("name")){
                    chattooltip.appendData(chatuserjid.toString(), obj1.name, 0, taryMsgdataMap.get("'" + chatuserjid + "'"));

                    if(chattooltip.visible == true)
                    {
                        chattooltip.hide()
                        chattooltip.show()
                    }
                }
                else
                {
                    chattooltip.appendData(chatuserjid.toString(), "未知用户", 0, taryMsgdataMap.get("'" + chatuserjid + "'"));

                    if(chattooltip.visible == true)
                    {
                        chattooltip.hide()
                        chattooltip.show()
                    }

                }
                if(fileio.readIniFile("IM","newmsgMode") == "true")
                {
                    chattooltip.height = 35 + chattooltip.getModelCount()*50
                    chattooltip.x = screenwidth - 80 - 220;//screenwidth - 80 - 220
                    chattooltip.y = screenheight - chattooltip.height

                    if(chattooltip.visible == false)  //gaobo
                    {
                        chattooltip.hide()
                        chattooltip.show()
                    }
                    return
                }


            }
        }
        
        //收到查询的用户信息
        function callBack(userjson, flags) {
            
            if(flags == 3)
                return;

            if(flags == 1)
            {
                console.log("查询个人信息接口返回数据:", userjson)
                var obj1 = eval('(' + userjson + ')');
                
                // console.log("obj1.userName", obj1.object.userName,"obj1.userPrivName", obj1.object.userPrivName, "obj1.sex", obj1.object.sex,obj1.object.mobilNo)
                
                
                var  chatjid            =obj1.object.uid;
                var  username       =obj1.object.userName;
                var  userPrivName =obj1.object.userPrivName;
                var  sex                =obj1.object.sex;
                var  iCount            =taryMsgdataMap.get("'" + obj1.object.uid + "'");
                var  mobleNo        = obj1.object.mobilNo;
                var  strStaus        = obj1.object.myStatus;
                var  avatar           = obj1.object.avatar;
                // var  isFriends        = obj1.object.avatar.isFriends;
                //
                //  console.log("收到查询的用户信息.chatjid", chatjid)
                //  console.log("收到查询的用户信息.userName", username)
                //  console.log("收到查询的用户信息.userPri吗vName",userPrivName)
                //  console.log("收到查询的用户信息.sex",sex)
                //  console.log("收到查询的用户信息.iCount",iCount)
                //  console.log("收到查询的用户信息.mobleNo:",mobleNo)
                //  console.log("收到查询的用户信息.strStaus:",strStaus)
                //  console.log("收到查询的用户信息.avatar:",avatar)

                //创建聊天窗口对象
                if( obj1.object.userName !== "" ||  obj1.object.userPrivName !=="")  //u1
                {
                    // mainwindow.setUserInfo(obj1.object.uid, obj1.object.userName, obj1.object.userPrivName, obj1.object.sex,dataMap.get("'" + obj1.object.uid + "'"), obj1.object.mobilNo,obj1.object.myStatus,obj1.object.avatar);
                    //  creatObj(username, userPrivName, sex, jid, mobleNo, false, strStaus,strip+"/img/user/"+avatar)

                    if(avatar ==="" ||  avatar === null || avatar ==="0" || avatar ==="1" )
                    {
                        if(sex === "1") //!男
                        {
                            console.log("性别为1，男，显示默认图" );
                            avatar ="qrc:/resource/images/main/maintop/womanhead.png"
                        }
                        else //! 女
                        {
                            console.log("性别不为1.女。显示默认头像" );
                            avatar ="qrc:/resource/images/main/maintop/manhead.png";
                        }
                    }
                    else
                    {
                        avatar =  strip+"/img/user/"+avatar;
                        console.log("加载了服务器返回头像  " ,strip+"/img/user/"+avatar);
                    }
                    mainwindow.setUserInfo(chatjid, username, userPrivName, sex, iCount, mobleNo,strStaus,avatar);
                    chattooltip.appendData(obj1.object.uid, obj1.object.userName, 0, taryMsgdataMap.get("'" + obj1.object.uid + "'"));

                    if(chattooltip.visible == true)  //gaobo
                    {
                        chattooltip.hide()
                        chattooltip.show()
                    }
                    // console.log("mainwindow.getChatObjVisible(userJid)",dataMap.get("'" + obj1.object.uid + "'"))
                    // console.log("mainwindow.getChatObjVisible(userPrivName)",dataMap.get("'" + obj1.object.userName + "'"))
                    // console.log("mainwindow.getChatObjVisible(userPrivName)",dataMap.get("'" + obj1.object.userPrivName + "'"))
                }
                else
                {
                    console.log("性别sex字段为空，部门等字段为空" );
                }
            }
            else
            {
                //console.log("接口返回  flags != 1")
            }

        }
        

        function logOut(strParm, bFlag)  //重新登录前的回调函数
        {

            // logoutWebServer.logoutServer(strip + "/logOut?name=liuyu&userAgent=pc", mainwindow.jsessionid, 0);

            //webrun_logout._slot_request(strip+ "/logOut?name=liuyu&userAgent=pc",mainwindow.jessonid);
            //loginWebServer.quitThread();

            //bFlag为1时切换用户，为2时是退出登录
            console.log("后台退出接口返回", strParm, bFlag)
            var obj1 = eval('(' + strParm + ')');
            if(bFlag == 0 && obj1.flag)  //正常退出
            {
                fileio.exequitsharememory(strusername)
                console.log("正常退出 main.logOut(),删除共享内存账号", strusername)
                mainwindow.app_quit()
            }
            else if(bFlag == 1 && obj1.flag) //切换用户，不自动登录
            {
                fileio.exequitsharememory(strusername)
                loginServer.startExe("./ispirit_xoa","")
                mainwindow.app_quit()

            }
            else if(bFlag == 2 && obj1.flag)  //重新登录，是否自动登录根据设置
            {
                fileio.exequitsharememory(strusername)
                loginServer.startExe("./ispirit_xoa","")
                mainwindow.app_quit()
            }
            else if(bFlag == 3) //掉线重登，不需要输入密码
            {

                console.log("掉线重登，不需要输入密码", bFlag)
                fileio.writeIniFile("login", "reboot", "1");
                fileio.writeIniFile("login", "username1", strusername);
                //fileio.writeIniFile("login", "passwd1", strpasswd);
                fileio.writeIniFile("login", "xoabang1", strpasswd)

                fileio.writeIniFile("login", "companyoid1", companyoid);

                fileio.exequitsharememory(strusername)

                loginServer.startExe("./ispirit_xoa","")
                mainwindow.app_quit()
            }
        }


        Component.onCompleted: {
            getuserinfos()
            singleChat.getSingleMsg.connect(getchatMsg)
            talkRoomIntface._sig_appendGroudMsg.connect( getgroupMsg)

            chatGetUserInfo.sigReplyMessage.connect(callBack)
            logoutWebServer.sigReplyMessage.connect(logOut)
            loginWebServer.sigReplyMessage.connect(loginCallback)

        }
    }

    function main_quit()  //退出程序
    {

        /*
        if(mainwindow.jsessionid !== "")
        {
            console.log("退出程序，退出时 jsessionid的值:",mainwindow.jsessionid);
            webrun_logout._slot_request(strip+ "/logOut?name=liuyu&userAgent=pc",mainwindow.jessonid);

            // logoutWebServer.logoutServer(strip + "/logOut?name=liuyu&userAgent=pc", mainwindow.jsessionid, 0);
            loginWebServer.quitThread();
            loginServer.logoutServer();
            fileio.exequitsharememory(strusername);
            //Qt.exit(0);
        }
        else
        {
            console.log("退出程序，直接退出");
            //Qt.exit(0);
        }*/


        mainwindow.main_quit();
    }
    
    function ispirit()
    {
        mainwindow.ispirit();
    }
    
    function switchUser()
    {
        mainwindow.switchUser();
    }
    
    function about()
    {
        mainwindow.about();
    }
    
    function relogin()
    {
        mainwindow.relogin();
    }
    function creatSetObj()
    {
        mainwindow.creatSetObj()
    }


    //隐藏到任务托盘
    function trayIconTriggered()
    {
        // console.log("chattooltip.getModelCount() >= 5",chattooltip.getModelCount());
        if(chattooltip.getModelCount() >= 30)
        {
            console.log("图标闪烁条目大于了30，现在数目为:",chattooltip.getModelCount());

        }
        else if(chattooltip.getModelCount() > 0)
        {
            window.flags = Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.WindowSystemMenuHint |Qt.Tool

            if(chattooltip.visible&&window.visibility == Window.Minimized)
            {
                window.visible=false
                window.raise()
                window.visibility =Window.Windowed

            }
            if(chattooltip.visible&&window.visible == false)
            {
                window.visible=false
                window.raise()
                window.visible =true
            }
            if(chattooltip.visible&&mainwindow.isWindowedge == true)
            {
                window.visibility = Window.Windowed;
                isWindowsHide =false
                window.y = 10
                window.height=_mainwindowh;
            }

            chattooltip.height = 35 + chattooltip.getModelCount()*50
            chattooltip.x = screenwidth - 80 - 220
            chattooltip.y = screenheight - chattooltip.height
            chattooltip.show();
        }
        else
        {
            window.flags = Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.WindowSystemMenuHint |Qt.Tool

            if(window.visibility == Window.Windowed
                    || window.visibility == Window.Maximized
                    || window.visibility ==Window.FullScreen)
                //|| isWindowsHide == false)
            {
                if(mainwindow.isWindowedge)
                {

                    console.log("窗口是在桌面边缘隐藏着")
                    //isWindowedge = true;
                    window.visibility = Window.Windowed;
                    isWindowsHide =false
                    window.y = 10
                    window.height=_mainwindowh;

                }
                else
                {
                    if(window.visibility == Window.Minimized)
                    {

                        console.log("最小化时点击了任务栏小图标")
                        window.flags = Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.WindowSystemMenuHint |Qt.Tool

                        window.visibility =Window.Windowed
                        window.visible=false
                        window.raise()


                    }
                    else
                    {
                        console.log("非最小化时点击了任务栏小图标")
                        window.visibility =Window.Windowed
                        window.flags = Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.WindowSystemMenuHint |Qt.Tool


                        //window.visible=false
                        //window.raise()

                    }
                }


            }
            /* else if(window.visibility ==Window.Minimized)
                {

                    console.log("最小时点击了图标")
                    window.visible=true
                  // window.raise()
                    window.visibility =Window.Windowed

                }*/

            else
            {
                console.log("进入非默认系统操作操作")
                /* window.visible=true
                    window.raise()*/
                window.flags = Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint | Qt.WindowSystemMenuHint |Qt.Tool

                window.visibility =Window.Windowed
                // window.visible=false
                //window.raise()
            }

            // chattooltip.deleteAllItem();
        }

    }

    function setwindowTitle(title)
    {
        window.title=title;
    }
    function getClientversionsuessed(clientversion,clientdownurl)  //版本号  地址
    {
        //console.log("clientversion",clientversion)
        //console.log("clientversion2222222",Number(clientversion.substring(0,4)))

        if(Number(clientversion.substring(0,4)) >Number( fileio.readIniFile("def", "autologinMode").substring(0,4)))
        {

            //Numnber 数字转换成字符串
            //  getclientversion.openIpdatapress(clientversion,clientdownurl);

            var versionMsgcomponent = Qt.createComponent("login/VersionMessagebox.qml");
            //  console.log(fileio.readIniFile("def", "autologinMode"))
            if (versionMsgcomponent.status === Component.Ready)
            {
                if(versionmesageObj === null)
                {
                    console.log("进入了弹窗界面2")

                    console.log("进入了弹窗界面3")
                    versionmesageObj = versionMsgcomponent.createObject(window.parent, { "visible": true
                                                                            , "messageText":"升级到"+clientversion
                                                                            , "version": clientversion
                                                                            ,"versionDownurl":clientdownurl});
                }
                if(versionmesageObj === null)
                {
                }
                else
                {
                    versionmesageObj.sigSure.connect(usertoClientversion)
                    versionmesageObj.sigCancel.connect(userNotoClientversion)
                }

            }
            else
            {
                //     console.log(component.error)

            }

        }
        else if(Number(clientversion.substring(0,4)) ===Number( fileio.readIniFile("def", "autologinMode").substring(0,4))
                &&Number(clientversion.substring(5,7)) >Number( fileio.readIniFile("def", "autologinMode").substring(5,7)))
        {
            //console.log(clientversion)
            var versionMsgcomponent = Qt.createComponent("login/VersionMessagebox.qml");
            //  console.log(fileio.readIniFile("def", "autologinMode"))
            if (versionMsgcomponent.status === Component.Ready)
            {
                if(versionmesageObj === null)
                {
                    // console.log("进入了弹窗界面2")

                    //  console.log("进入了弹窗界面3")
                    versionmesageObj = versionMsgcomponent.createObject(window.parent, { "visible": true
                                                                            , "messageText":"升级到"+clientversion
                                                                            , "version": clientversion
                                                                            ,"versionDownurl":clientdownurl});
                }
                if(versionmesageObj === null)
                {
                }
                else
                {

                    versionmesageObj.sigSure.connect(usertoClientversion)
                    versionmesageObj.sigCancel.connect(userNotoClientversion)
                }

            }
            else
            {
                // console.log(component.error)

            }

        }
        else if(Number(clientversion.substring(0,4)) ===Number( fileio.readIniFile("def", "autologinMode").substring(0,4))
                &&Number(clientversion.substring(5,7))===Number( fileio.readIniFile("def", "autologinMode").substring(5,7))
                &&Number(clientversion.substring(8,10))>Number( fileio.readIniFile("def", "autologinMode").substring(8,10)))
        {
            // console.log(clientversion)
            var versionMsgcomponent = Qt.createComponent("login/VersionMessagebox.qml");
            //  console.log(fileio.readIniFile("def", "autologinMode"))
            if (versionMsgcomponent.status === Component.Ready)
            {
                if(versionmesageObj === null)
                {
                    // console.log("进入了弹窗界面2")

                    // console.log("进入了弹窗界面3")
                    versionmesageObj = versionMsgcomponent.createObject(window.parent, { "visible": true
                                                                            , "messageText":"升级到"+clientversion
                                                                            , "version": clientversion
                                                                            ,"versionDownurl":clientdownurl});
                }
                if(versionmesageObj === null)
                {
                }
                else
                {

                    versionmesageObj.sigSure.connect(usertoClientversion)
                    versionmesageObj.sigCancel.connect(userNotoClientversion)
                }

            }
            else
            {
                // console.log(component.error)

            }

        }
        else if(Number(clientversion.substring(0,4)) ===Number( fileio.readIniFile("def", "autologinMode").substring(0,4))
                &&Number(clientversion.substring(5,7))===Number( fileio.readIniFile("def", "autologinMode").substring(5,7))
                &&Number(clientversion.substring(8,10))===Number( fileio.readIniFile("def", "autologinMode").substring(8,10))
                &&Number(clientversion.substring(11,12))>Number( fileio.readIniFile("def", "autologinMode").substring(11,12)))
        {
            // console.log(clientversion)
            var versionMsgcomponent = Qt.createComponent("login/VersionMessagebox.qml");
            //console.log(fileio.readIniFile("def", "autologinMode"))
            if (versionMsgcomponent.status === Component.Ready)
            {
                if(versionmesageObj === null)
                {
                    //  console.log("进入了弹窗界面2")

                    //   console.log("进入了弹窗界面3")
                    versionmesageObj = versionMsgcomponent.createObject(window.parent, { "visible": true
                                                                            , "messageText":"升级到"+clientversion
                                                                            , "version": clientversion
                                                                            ,"versionDownurl":clientdownurl});
                }
                if(versionmesageObj === null)
                {

                }
                else
                {

                    versionmesageObj.sigSure.connect(usertoClientversion)
                    versionmesageObj.sigCancel.connect(userNotoClientversion)
                }

            }
            else
            {
                //   console.log(component.error)

            }

        }
        else
        {

            //login.loginSuccess(userpasswd.text)
            userNotoClientversion();
        }
    }

    function usertoClientversion(clientdownurl,clientversion)
    {
        console.log("用户确认了升级---------------");

        versionmesageObj.sigSure.disconnect(usertoClientversion)
        getclientversion.openIpdatapress(strip+clientversion,clientdownurl);

        versionmesageObj.deleteitem();
        versionmesageObj.close();
        versionmesageObj=NULL;
        //versionmesageObj.vi
        //  quit();
        //Qt.quit();

    }
    function userNotoClientversion(clientdownurl,clientversion)
    {
        // versionmesageObj.sigSure.disconnect(usertoClientversion)
        //getclientversion.openIpdatapress(clientdownurl,clientversion);
        console.log("用户取消了升级---------------");


        var oaoutnet = fileio.readIniFile("login", "useroutnetlogin")
        if(oaoutnet === "0") //内网登录
        {
            strip = fileio.readIniFile("login", "oainnet")
            if(strip === "http://"|| strip === "")
            {
                creatMessageObj("请输入网址!", "creatSetObj");

                // creatSetObj();
                return;
            }
        }
        else if(oaoutnet === "1")//外网登录
        {
            strip = fileio.readIniFile("login", "oaoutnet")
            if(strip === "http://"|| strip === "")
            {
                creatMessageObj("请输入网址!", "creatSetObj");

                //    creatSetObj();
                return;
            }
        }
        else if(oaoutnet === "2")//测试地址
        {
            strip = fileio.readIniFile("login", "oatestnet")
            if(strip === "http://"|| strip === "")
            {
                creatMessageObj("请输入网址!", "creatSetObj");

                // creatSetObj();
                return;
            }
        }
        if(rememberpasswd.checkedState)
        {
            //fileio.writeIniFile("login", "passwd", userpasswd.text)
            fileio.writeIniFile("login", "xoabang", fileio.textEncode(userpasswd.text,"X"))

        }
        else
        {
            fileio.writeIniFile("login", "passwd", "")
        }

        fileio.writeIniFile("login", "username", username.text)

        fileio.writeIniFile("login", "autologin", autologin.checkedState)
        fileio.writeIniFile("login", "remembPasswd", rememberpasswd.checkedState)

        /* loginingicon.visible = true
         rememberpasswd.visible = false
         autologin.visible = false*/
        //versionmesageObj.sigSure.disconnect(userNotoClientversion)
        //    console.log("clientdownurl==",clientdownurl,"clientversion===",clientversion)
        //   Qt.quit()

        // login.loginSuccess(userpasswd.text)

    }

    Component.onCompleted:
    {
        getclientversion.sigGetVersionSuccess.connect(getClientversionsuessed)

        var windowX=0
        var windowY=0
        windowX = fileio.readIniFile("login", "windowX")
        windowY = fileio.readIniFile("login", "windowY")
        if(windowX>0)
        {
            console.log("找到窗口位置X配置")
            if(windowX>Screen.desktopAvailableWidth)
                window.x=Screen.desktopAvailableWidth - 350
            else
                window.x=windowX
        }
        else
        {
            window.x=Screen.desktopAvailableWidth - 350
        }

        if(windowY>0)
        {
            console.log("找到窗口位置Y配置")
            if(windowY>Screen.desktopAvailableHeight)
                window.y=50
            else
                window.y=windowY
        }

        // console.log("",isWindowsHide)
        // console.log("window.y",window.y)
    }

}

