﻿import QtQuick 2.0
import QtQuick.Window 2.2
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import FileIo 1.0
import "../common"

Window {
    id: aboutwindow
    width: 380
    height: 286
    x: (Screen.desktopAvailableWidth - 380)/2
    y: (Screen.desktopAvailableHeight - 286)/2

    flags: Qt.Window | Qt.FramelessWindowHint
    property bool bPressed: true

    signal deleteitem()

    FileIo {
        id: fileio
    }
    MouseArea { //为窗口添加鼠标事件
        id:mouse
        anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true
            //console.log("mouse.x"+mouse.x +" mouse.y"+mouse.y )
        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                //var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)

                //如果mainwindow继承自QWidget,用setPos
                //aboutwindow.setX(aboutwindow.x+delta.x)
                //aboutwindow.setY(aboutwindow.y+delta.y)

                //console.log("mouse.x"+mouse.x +" mouse.y"+mouse.y )
                if((aboutwindow.x + mouse.x - clickPos.x)<Screen.desktopAvailableWidth)
                   aboutwindow.x = aboutwindow.x + (mouse.x - clickPos.x)
                if((aboutwindow.y + mouse.y - clickPos.y)<Screen.desktopAvailableHeight)
                   aboutwindow.y = aboutwindow.y + (mouse.y - clickPos.y)
            }
        }
    }

    Rectangle{

        id: bkgrect
        anchors.fill: parent
        border.width: 1
        border.color: "#278ADD"
        color: "#169ADA"

        Rectangle{
            id: titlebkg
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.right: parent.right
            height: 28
            color: "#169ADA"

            Image {
                id: icon
                anchors.top: parent.top
                anchors.topMargin: 3
                anchors.left: parent.left
                anchors.leftMargin: 6
                source: "qrc:/resource/window_logo.png"
            }


            Text {
                id: title
                anchors.top: parent.top
                anchors.topMargin: 0
                anchors.left: icon.right
                anchors.leftMargin: 3
                font.family: "微软雅黑"
                font.pixelSize: 12
                height: 28
                color: "#FFFFFF"
                verticalAlignment: Qt.AlignVCenter
                text: qsTr("关于OA办公精灵")
            }

            ControlButton {
                id:min
                anchors.top: parent.top
                anchors.right: close.left
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/main/maintop/min.png"
                hoverImage: "qrc:/resource/images/main/maintop/minHover.png"
                onClicked: {
                    aboutwindow.visibility = Window.Minimized
                }
            }

            ControlButton {
                id:close
                anchors.top: parent.top
                anchors.right: parent.right
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/main/maintop/close.png"
                hoverImage: "qrc:/resource/images/main/maintop/closeHover.png"
                onClicked: {
                    deleteitem()
                }
            }
        }

        Image {
            id: bkg
            anchors.top: parent.top
            anchors.topMargin: 28
            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right: parent.right
            anchors.rightMargin: 1
            source: "qrc:/resource/images/main/mainbottom/about.png"
        }

        Rectangle{
            id: infobake
            anchors.top: bkg.bottom
            anchors.topMargin: 0
            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right: parent.right
            anchors.rightMargin: 1
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 40
            color: "#FAFAFA"

            Text {
                id: versioninfo
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.leftMargin: 16
                height: 20

                font.family: "微软雅黑"
                font.pixelSize: 11
                color: "#000000"
                horizontalAlignment: Qt.AlignLeft
                verticalAlignment: Qt.AlignVCenter
                text: qsTr("OA办公精灵版本号: "+fileio.readIniFile("def", "autologinMode"))
                anchors.topMargin: 13
            }

 
         Text {
             id: companyinfo
             anchors.top: versioninfo.bottom
             anchors.topMargin: 10
             anchors.left: parent.left
             anchors.leftMargin: 15
             height: 15
             font.family: "微软雅黑"
             font.pixelSize: 11
             color: "#000000"
             horizontalAlignment: Qt.AlignLeft
             verticalAlignment: Qt.AlignVCenter
             text: qsTr("OA办公精灵研发组 版权所有")
         }
  
  
         Text {
             id: copyright
             anchors.top: companyinfo.bottom
             anchors.topMargin: 10
             anchors.left: parent.left
             anchors.leftMargin: 15
             height: 15
             font.family: "微软雅黑";
             font.pixelSize: 11
             color: "#000000"
             horizontalAlignment: Qt.AlignLeft
             verticalAlignment: Qt.AlignVCenter
             text: qsTr("Copyright©2015-2021 XOA All Rights Reserved")
         }
  
  
         Text {
             id: url
             anchors.top: copyright.bottom
             anchors.topMargin: 10
             anchors.left: parent.left
             anchors.leftMargin: 15
             height: 15
             font.family: "微软雅黑"
             font.pixelSize: 6
             color: "red"
             horizontalAlignment: Qt.AlignLeft
             verticalAlignment: Qt.AlignVCenter
             //text: "<a href='http://8OA.cn/'><h1>http://8OA.cn</h1></a>"
             onLinkActivated: {
                 Qt.openUrlExternally(link)
             }
         }

        }

        Button {
            id: closebtn
            width: 70
            height: 25
            anchors.right: parent.right
            anchors.rightMargin: (380 - 70)/2
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 8
            style:ButtonStyle {
                background: Rectangle {
                    border.color: control.hovered ? "#0075c4" : "#ccc"
                    border.width: 1
                    radius: 3
                }

                label: Text{
                    text:qsTr("关闭")
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color:  control.hovered ?"#0075c4" :"#333333"
                    font.bold: false
                    horizontalAlignment: Qt.AlignHCenter
                    verticalAlignment: Qt.AlignVCenter
                }
            }

            onClicked: {
                deleteitem()
            }
        }
    }
}

