﻿import QtQuick 2.12
import QtQuick.Controls 2.2
import QtGraphicalEffects 1.0


Rectangle{
    id: hoveredbkg
    width: conversationRect.width
    height: 52
    property string strJid:      ""
    property string strType:     ""
    property string strPrivName: ""
    property string strSex:      ""
    property string strMobileNo: ""
    property string strIconImage:"qrc:/resource/images/im/chatman.png"
    property string strUserName: ""
    property string strUserTime: ""
    property string strUserText: ""
    property int    messageCount: 0
    property string strUserStatus: ""
    property string groudmsglist: ""
    property string strlistid: ""
    property string msgtype: ""
    property string groudimg: ""
    property int menupositionX: 0
    property int menupositionY: 0
    property int topnum: 0
    property var mackTop:[]
    property bool mackTopreb:false
    color: "#FFFFFF"
    //color: ListView.isCurrentItem ? "#EFF7FE" : "#FAFCFD"
    signal sigClicked(string index);
    //右键菜单删除会话列表
    signal sigRightMenu(string index);

    //右键菜单置顶
    signal sigMaktopMenu(string index, bool top);

    // Rectangle{
    //     radius:20
    //     width: 40
    //     height: 40
    //     anchors.top: parent.top
    //     anchors.topMargin: 7
    //     anchors.left: parent.left
    //     anchors.leftMargin: 12
    Image {
        id: icon
        width: 40
        height: 40
        source: strIconImage
        smooth: true

        sourceSize: Qt.size(parent.width, parent.height)
        anchors.top: parent.top
        anchors.topMargin: 7
        anchors.left: parent.left
        anchors.leftMargin: 12
        visible: true
    }
/*
    Rectangle{
        id:mask
        anchors.fill: icon
        radius: width/2.
        color:"lightsteelblue"
    }

    OpacityMask {
        anchors.fill: icon
        source: icon
        maskSource: mask
    }
*/
    Text {
        id: username
        anchors.top:parent.top
        anchors.topMargin: 7
        anchors.left:icon.right
        anchors.leftMargin: 6
       // anchors.right: parent.right
       // anchors.rightMargin: 6
        height: 20
        verticalAlignment: Qt.AlignVCenter
        horizontalAlignment: Qt.AlignLeft
        width: 180
        font.pixelSize: 14
        font.family: "微软雅黑"
        color: "#333333"
        elide: Text.ElideRight
        text:{
            if(strUserName.indexOf("邀请")>-1 && strUserName.indexOf("加入群聊")>-1 )
            {
                return strUserName.substring(2,strUserName.length-4)
            }
            else
            {
                return strUserName;
            }
        }

    }

    Text {
        id: usercontext
        anchors.top:username.bottom
        anchors.topMargin: 2
        anchors.left:icon.right
        anchors.leftMargin: 6
        anchors.right: parent.right
        anchors.rightMargin: 55
        elide: Text.ElideRight
        height: 20

        verticalAlignment: Qt.AlignVCenter
        horizontalAlignment: Qt.AlignLeft

        font.pixelSize: 12
        font.family: "微软雅黑"
        color: "#999999"
        //textFormat: TextEdit.RichText

        text:
        {
            if(strUserType == "text")
            {

//                if(strUserText.indexOf("邀请")>-1 && strUserText.indexOf("加入群聊")>-1 )
//                {
//                   return strUserText.substring(2,strUserText.length-4)
//                }
//                else
//                {
//                    //console.log("ConversationItem 写入文字:",strUserText)

                    return strUserText.replace(/\n/g," ").replace(/\\n/g," "); //replace("\\n"," ").
//                }

            }

            else if(strUserType === "file")
            {
                console.log("会话列表，类型为文件，消息体：",strUserType,strUserText)
                return "["+strUserText+"]"
               // return "[文件]"
            }
            else if(strUserType === "img")
            {
                return "[图片]"
            }
            else if(strUserType === "voice")
            {
                return "[语音]"
            }
            else if(strUserType === "shaking")
            {
                return "[抖屏]"
            }
            else if(strUserType === "groupgeneral")
            {
                //return "[群邀请]"
                return strUserText.replace(/\n/g," ").replace(/\\n/g," "); //replace("\\n"," ").
            }
            else
            {
                if(strJid.indexOf("@gsrooms.gsubo")<=0)
                    return "未知"
                else
                    return strUserText;

            }
        }
    }

    Text {
        id: receivetime
        anchors.top: parent.top
        anchors.topMargin:10
        anchors.right: parent.right
        anchors.rightMargin: 5
        height: 15
        verticalAlignment: Qt.AlignVCenter
        horizontalAlignment: Qt.AlignRight

        font.pixelSize: 12
        font.family: "微软雅黑"
        color: "#999999"
        text: strUserTime


    }

    Rectangle{
        id: msgcountbkg
        anchors.top: receivetime.bottom
        anchors.topMargin:5
        anchors.right: parent.right
        anchors.rightMargin: 5
        width: 22
        height: 14
        color: "#F9493A"
        radius: 7

        Text {
            id: receiveCount
            anchors.fill: parent
            verticalAlignment: Qt.AlignVCenter
            horizontalAlignment: Qt.AlignHCenter

            font.pixelSize: 8
            font.family: "微软雅黑"
            color: "white"
            text: {
                if(messageCount > 99)
                {
                    return "99+";
                }
                else
                {
                    if(messageCount == 0)
                    {
                        msgcountbkg.visible = false;
                    }
                    else
                    {
                        msgcountbkg.visible = true;
                    }

                    return messageCount;
                }
            }

        }
    }

    MouseArea{
        id: parentmouse
        anchors.fill: parent
        hoverEnabled: true
        cursorShape: Qt.PointingHandCursor
        acceptedButtons: Qt.LeftButton | Qt.RightButton

        onExited: {
            hoveredbkg.color = "#FAFCFD"
        }

        onEntered: {
            hoveredbkg.color = "#ABD9FE"
        }

        onClicked: {
            if (mouse.button == Qt.LeftButton)
            {
                sigClicked(index)
               // console.log("左键点击")
            }
            else if(mouse.button == Qt.RightButton)
            {
               // console.log("右键点击")//执行删除操作
                convermenu.open()
                menupositionX = parentmouse.mouseX
                menupositionY = parentmouse.mouseY
            }
        }
        Menu {
            id: convermenu
            width: 60
            x:menupositionX
            y:menupositionY
            focus: true

           /* MenuItem {
                text: "隐藏"
                onTriggered: {
                    console.log("会话列表右键点击隐藏菜单");
                    sigRightMenu(index)
                }

                //onTriggered: document.reset()
            }*/
            MenuItem {
                text: "打开"
                onTriggered: {
                    console.log("会话列表右键点击打开菜单");
                    sigClicked(index);
                    // sigRightMenu(index)
                }
                //onTriggered:openDialog.open()
            }
            MenuItem {
               text: "删除"
               onTriggered: {
                   console.log("789");
                   sigRightMenu(index)
            }
               //onTriggered: saveDialog.open()
           }

            /*
            MenuItem {
                id:texID
                text:
                {
                    var reb = false;

                    for(var len = 0; len<mackTop.length;len++)
                    {

                        console.log("len",conversationModel.get(lenC).strUserJid,mackTop[lenC],texID.text);

                        for(var lenC = 0; lenC<conversationModel.length;lenC++)
                        {
                            console.log("lenC",conversationModel.get(lenC).strUserJid,mackTop[lenC],texID.text);

                            if(mackTop[lenC] == conversationModel.get(lenC).strUserJid)
                            {
                                console.log("取消置顶",conversationModel.get(lenC).strUserJid,mackTop[lenC],texID.text);
                                mackTopreb = true;
                            }
                        }
                    }

                //   mackTopreb = false;
                //   texID.text = "置顶"
                //   console.log("置顶",conversationModel.get(lenC).strUserJid,mackTop[lenC],texID.text);
                //
                //
                //   if(mackTopreb)
                //   {
                //
                //   }
                //   else
                //   {
                //   }


                }

                onTriggered: {

                    mackTop.push(conversationModel.get(index).strUserJid)
                    console.log("onTriggered 置顶",conversationModel.get(index).strUserJid,mackTopreb);
                    console.log("onTriggered 置顶",mackTop[mackTop.length-1],mackTop.length,mackTopreb);
                    sigMaktopMenu(index,mackTopreb);
                }

            }
             */
        }
    }


    Rectangle{
        anchors.bottom: parent.bottom
        width: parent.width
        height: 1
        color: "#E7E7E7"
    }
}


