﻿import QtQuick 2.0
import QtQuick.Window 2.2
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import "../common"
import FileIo 1.0

Window {
    id: imwindow
    width: 302
    height: 340//402
    flags: Qt.Window | Qt.FramelessWindowHint
    x: (Screen.desktopAvailableWidth - 300)/2
    y: (Screen.desktopAvailableHeight - 340)/2
    opacity: 1.0
    visible: true
    property string heartBeatCount: "0"
    property string loseHeartBeatCount: "0"
    property string reconnectionNum: "0"
    property alias loginStatusText: loginStatusContent.text
    property alias loginTimeText: loginTimeContent.text
    property alias userId:idcontent.text
    property alias lastTimeText: lastTimeContent.text
    property alias openfireIp: openfireIpContent.text
    property alias userName:namesh.text
    property alias usererrorparameter:error_parameterContent.text
    property bool bPressed: true
    signal deleteitem();
    FileIo {
        id: fileio
    }
    MouseArea { //为窗口添加鼠标事件
        id:mouse
        anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true
        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)

               // console.log("233221213")
                //如果mainwindow继承自QWidget,用setPos
                imwindow.setX(imwindow.x+delta.x)
                imwindow.setY(imwindow.y+delta.y)
            }
        }
    }
    Rectangle{
        id: bkgRec
        anchors.fill: parent
        color: "#cccccc"
        border.width: 1
        border.color: "#278ADD"

        Image {
            id: bkgimg
            anchors.top: parent.top
            anchors.topMargin: 1
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 2
            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right: parent.right
            anchors.rightMargin: 1
            anchors.fill: parent
            source :
                if(loginStatusContent.text == "即时通讯服务连接成功")
                {
                    return "qrc:/resource/images/main/mainbottom/IMLoginSuccess.png"
                }
                else if(loginStatusContent.text == "即时通讯服务连接失败")
                {
                    return "qrc:/resource/images/main/mainbottom/IMLoginFail.png"
                }
                else
                {
                    return "qrc:/resource/images/main/mainbottom/IMLoginFail.png"
                }
        }

        Image {
            id: titleIcon
            anchors.top: parent.top
            anchors.topMargin: 7
            anchors.left:parent.left
            anchors.leftMargin: 6
            source: "qrc:/resource/images/main/common/imstatus.png"
        }

        Text {
            id: titletext
            anchors.top: parent.top
            anchors.topMargin: 5
            anchors.left:titleIcon.right
            anchors.leftMargin: 3
            font.pixelSize: 12
            font.bold: false
            font.family: "微软雅黑"
            color: "#FFFFFF"
            text: qsTr("即时通讯状态  版本号 "+fileio.readIniFile("def", "autologinMode"))
        }

        ControlButton {
            id: min
            anchors.top: parent.top
            anchors.right: close.left
            width: 28
            height: 28
            //normalImage: "qrc:/resource/images/main/maintop/min.png"
            //hoverImage: "qrc:/resource/images/main/maintop/minHover.png"

            onClicked: {
                imwindow.visibility = Window.Minimized
            }
        }

        ControlButton {
            id: close
            anchors.top: parent.top
            anchors.right: parent.right
            width: 28
            height: 28
            normalImage: "qrc:/resource/images/main/maintop/close.png"
            hoverImage: "qrc:/resource/images/main/maintop/closeHover.png"
            onClicked:{
                imwindow.visible=false;
            }
        }

        Text {
            id: loginStatusContent
            anchors.top: bkgimg.top
            anchors.topMargin: 120
            anchors.left: bkgimg.left
            anchors.leftMargin: 70
            font.pixelSize: 18
            font.family: "微软雅黑"
            color: "#FFFFFF"
            text: qsTr("登录状态")
        }

        Text {
            id: id
            anchors.top: bkgimg.top
            anchors.topMargin: 175
            anchors.left: parent.left
            anchors.leftMargin: 22
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#777777"
            text: qsTr("用户ID: ")
        }

        Text {
            id: idcontent
            anchors.top: bkgimg.top
            anchors.topMargin: 175
            anchors.left: id.right
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#db8600"

        }

        Text {
            id: idname
            anchors.top: bkgimg.top
            anchors.topMargin: 175
            anchors.left: idcontent.right
           anchors.leftMargin: 30
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#777777"
            text: qsTr("用户名: ")
        }
        Text {
            id:namesh
            anchors.top: bkgimg.top
            anchors.topMargin: 175
            anchors.left: idname.right
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#db8600"
        }

        Text {
            id: loginTime
            anchors.top: id.bottom
            anchors.topMargin: 6
            anchors.left: parent.left
            anchors.leftMargin: 22
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#777777"
            text: qsTr("首次登录时间: ")
        }

        Text {
            id: loginTimeContent
            anchors.top: idcontent.bottom
            anchors.topMargin: 6
            anchors.left: loginTime.right
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#db8600"
        }

        Text {
            id: lastTime
            anchors.top: loginTime.bottom
            anchors.topMargin: 6
            anchors.left: parent.left
            anchors.leftMargin: 22
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#777777"
            text: qsTr("最后登录时间: ")
        }

        Text {
            id: lastTimeContent
            anchors.top: loginTimeContent.bottom
            anchors.topMargin: 6
            anchors.left: lastTime.right
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#db8600"
        }
        Text {
            id: openfireIp
            anchors.top: lastTime.bottom
            anchors.topMargin: 6
            anchors.left: parent.left
            anchors.leftMargin: 22
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#777777"
            text: qsTr("IM服务器地址: ")
        }

        Text {
            id: openfireIpContent
            anchors.top: lastTimeContent.bottom
            anchors.topMargin: 6
            anchors.left: openfireIp.right
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#db8600"
        }
        Text {
            id: error_parameter;
            anchors.top: openfireIp.bottom
            anchors.topMargin: 6
            anchors.left: parent.left
            anchors.leftMargin: 22
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#777777"
            text: qsTr("重连次数: ")
        }

        Text {
            id: error_parameterContent
            anchors.top: openfireIp.bottom
            anchors.topMargin: 8
            anchors.left: error_parameter.right
            font.pixelSize: 14
            font.family: "微软雅黑"
            color: "#db8600"
            text:reconnectionNum
        }
        Text {
            id: heartbeat
            anchors.top: error_parameter.bottom
            anchors.topMargin: 8
            anchors.left: parent.left
            anchors.leftMargin: 60
            font.pixelSize: 12
            font.family: "微软雅黑"
            color: "#000000"
            text: qsTr("共发送 ")
        }

        Text {
            id: name
            anchors.top: error_parameter.bottom
            anchors.topMargin: 8
            anchors.left: heartbeat.right
            anchors.leftMargin: 0
            font.pixelSize: 12
            font.family: "微软雅黑"
            color: "#4ca0db"
            text: heartBeatCount==""?0:heartBeatCount
        }

        Text {
            id: name2
            anchors.top: error_parameter.bottom
            anchors.topMargin: 8
            anchors.left: name.right
            anchors.leftMargin: 0
            font.pixelSize: 12
            font.family: "微软雅黑"
            color: "#000000"
            text: " 个心跳包，丢失 "
        }

        Text {
            id: name3
            anchors.top: error_parameter.bottom
            anchors.topMargin: 8
            anchors.left: name2.right
            anchors.leftMargin: 0
            font.pixelSize: 12
            font.family: "微软雅黑"
            color: "#e46c6c"
            text: loseHeartBeatCount==""?0:loseHeartBeatCount
        }

        Text {
            id: name4
            anchors.top: error_parameter.bottom
            anchors.topMargin: 8
            anchors.left: name3.right
            anchors.leftMargin: 0
            font.pixelSize: 12
            font.family: "微软雅黑"
            color: "#000000"
            text: " 个"
        }

    }
    
    function setHeartBeat(iHeartBeatCount, iLoseCount)
    {
        heartBeatCount = iHeartBeatCount
        loseHeartBeatCount = iLoseCount
    }

    function addReconnectionNum()
    {
        //heartBeatCount = iHeartBeatCount
        // loseHeartBeatCount = iLoseCount
        console.log("进入重新连接计数")
        reconnectionNum = String(Number(reconnectionNum)+1);
    }

    function setLoginSatus(status)
    {
        console.log("即时通讯服务连接状态:", status)
        loginStatusText=status

    }

   function setLoginTime(time, id)
    {

        if(loginTimeText=="")
           loginTimeText = time

        lastTimeText = time

        userId = id + ""

    }

    Component.onCompleted: {
        loginServer.sigGetLoginTime.connect(setLoginTime)
        loginServer.sigGetHeartBeatCount.connect(setHeartBeat);
        loginServer.sigGetConReason.connect(setLoginSatus);
        loginServer.sigAddReconnectionNum.connect(addReconnectionNum);
    }
}
