﻿import QtQuick 2.7
import QtQuick.Layouts 1.1
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import FileIo 1.0
import WebRunPlatform 1.0
import QtGraphicalEffects 1.0
import WebIEPlatform 1.0
import "../js/query.js" as Query
import "../common"

Rectangle {
    id:maintopoperat
    color: "#278ADD"
    
    property string jid: ""
    property string strip: ""
    property string strport: ""
    property string oaoutnet: ""
    property alias userName: username.text
    property alias headimg: headimg.source
    property alias signatureText: signature.textContent
    property alias signatureIcon: signature.sigIcon
    property var webPageObj: []
    property var signatureObj: null
    property string titleName: ""
    
    signal maxclicked()
    signal minclicked()
    signal skinclicked()
    signal closeclicked()
    
    function getuserinfo()
    {
        oaoutnet = fileio.readIniFile("login", "useroutnetlogin")
        if(oaoutnet === "0") //内网登录
        {
            strip = fileio.readIniFile("login", "oainnet")
        }
        else if(oaoutnet === "1")//外网登录
        {
            strip = fileio.readIniFile("login", "oaoutnet")
        }
        else if(oaoutnet === "2")//测试地址
        {
            strip = fileio.readIniFile("login", "oatestnet")
        }
        
    }
    
    function setInfo(emailcount, noticcount, taskcount) {
          email.textcontent = emailcount
          seralarms.textcontent = noticcount
          //taskcenter.textcontent = taskcount
    }

    function maintoptranstor() {
        titlename.text = qsTr("办公精灵");
        //username.text = qsTr("系统管理员");
        textinline.text = qsTr("在线");
        textbusy.text = qsTr("忙碌");
        textleave.text = qsTr("离开");
        emailwebview.titletext = qsTr("电子邮件");
        noticewebview.titletext = qsTr("事务提醒");
        taskewebview.titletext = qsTr("任务中心");
    }
    
    FileIo {
        id:fileio
    }
    
    WebRunPlatform{
        id:webRun
    }
    WebIEPlatform
    {
        id:iewebrun
    }

    Image {
        id: icon
        anchors.top: parent.top
        anchors.topMargin: 5
        anchors.left: parent.left
        anchors.leftMargin: 12
        width: 22
        height: 22
        source: "qrc:/resource/window_logo.png"
    }
    
    Text {
        id: titlename
        anchors.top: parent.top
        anchors.topMargin: 7
        anchors.left: icon.right
        anchors.leftMargin: 4
        width: 50
        font.pixelSize: 12
        font.family: "微软雅黑"
        renderType: Text.NativeRendering
        smooth: true
        color:  "#ffffff"
        font.bold: false
        text: titleName
    }
    
    /*
    ControlButton {
        id:skin
        anchors.top: parent.top
        anchors.right: min.left
        width: 25
        height: 20
        normalImage: "qrc:/resource/images/main/maintop/theme.png"
        hoverImage: "qrc:/resource/images/main/maintop/theme_hover.png"
        onClicked: {
            maintopoperating.skinclicked()
        }
    }
    */
    
    ControlButton {
        id:min
        anchors.top: parent.top
        anchors.right: close.left
        width: 28
        height: 28
        normalImage: "qrc:/resource/images/main/maintop/min.png"
        hoverImage: "qrc:/resource/images/main/maintop/minHover.png"
        onClicked: {
            maintopoperating.minclicked()
        }
    }
    
    ControlButton {
        id:max
        anchors.top: parent.top
        anchors.right: close.left
        width: 28
        height: 28
        normalImage: "qrc:/resource/images/main/maintop/max.png"
        hoverImage: "qrc:/resource/images/main/maintop/maxHover.png"
        visible: false
        onClicked: {
            maintopoperating.maxclicked()
        }
    }
    
    ControlButton {
        id:close
        anchors.top: parent.top
        anchors.right: parent.right
        width: 28
        height: 28
        normalImage: "qrc:/resource/images/main/maintop/close.png"
        hoverImage: "qrc:/resource/images/main/maintop/closeHover.png"
        onClicked: {
            maintopoperating.closeclicked()
        }
    }
    
    Rectangle {
        id:headinfor
        width: 68
        height: 68
        radius: 68/2
        anchors.top: titlename.bottom
        anchors.topMargin: 14
        anchors.left: parent.left
        anchors.leftMargin: 10
        color: "#169ADA"
        BorderImage {
            id: headimg
            anchors.fill: parent
            visible: true
      }
        /*
        Rectangle{
                 id:mask
                 anchors.fill: headimg
                 radius: width/2.
             }
        //}

        OpacityMask {
            anchors.fill: headimg
            source: headimg
            maskSource: mask
        }
*/
        MouseArea {
            anchors.fill: parent
            hoverEnabled: true
            cursorShape: Qt.PointingHandCursor
            onPressed: {
                getuserinfo()

                // var firstWindow = windowComponent.createObject(window.parent
                //                                                ,{"webWidth":window.webWidth
                //                                                    , "webHeight": window.webHeight
                //                                                    , "strTitle": qsTr("用户信息")});
                // firstWindow.webView.url = strip + "/controlpanel/index?lang=zh_CN";

                //用户信息
                console.log("用户信息miantop:"+ strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN")

                webRun._vNewWindows(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN&JSESSIONID1=" + jsessionid,"用户信息",false)

               //Qt.openUrlExternally(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                console.log("用户信息miantop:"+ strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN")

            }
        }

    }
    
    Text {
        id: username
        width: 80
        height: 15
        anchors.left: headinfor.right
        anchors.leftMargin: 16
        anchors.top:parent.top
        anchors.topMargin: 37
        font.pixelSize: 14
        font.family: "微软雅黑"
        smooth: true
        color: "#ffffff"
        font.bold: true
    }
    
    Button{
        id: signature
        anchors.top: username.bottom
        anchors.topMargin: 8
        anchors.left: headinfor.right
        anchors.leftMargin: 14
        anchors.right: parent.right
        anchors.rightMargin: 27
        height: 20
        property string textContent: qsTr("编辑个性签名")
        property string sigIcon: ""
        style:ButtonStyle{
            background:  Image{
                id:background
                states:[
                    State{
                        name:"hovered"
                        when:signature.hovered
                        PropertyChanges {
                            target: background; source:"qrc:/resource/images/main/maintop/input.png"
                        }
                    },
                    
                    State{
                        name:"!hovered"
                        when:!signature.hovered
                        PropertyChanges {
                            target: background; source:""
                        }
                    }
                ]
                
                Image {
                    id: sigicon
                    anchors.top: parent.top
                    anchors.topMargin: 2
                    anchors.left: parent.left
                    anchors.leftMargin: 2
                    anchors.bottom: parent.bottom
                    width: 16
                    height: 16
                    source: if(signature.sigIcon == "")
                            {
                                return "qrc:/resource/images/main/common/1.png";
                            }
                            else
                            {
                                return "qrc:/resource/images/main/common/"  + signature.sigIcon
                            }
                    
                }
                
                Text{
                    id:text_label
                    text:signature.textContent
                    anchors.left: background.left
                    anchors.leftMargin: 20
                    anchors.right: background.right
                    anchors.rightMargin: 0
                    height: signature.height
                    font.pixelSize: 11
                    font.family: "微软雅黑"
                    font.weight: Font.Normal
                    renderType: Text.NativeRendering
                    smooth: true
                    color:  "#ffffff"
                    font.bold: false
                    horizontalAlignment: Qt.AlignLeft
                    verticalAlignment: Qt.AlignVCenter
                }
            }
        }
        onClicked: {
            creatSignatureObj();
        }
    }
    
    Timer {
            id: timeremailseralarmsmaintop
            //interval: 160000;//2018-11-19 修改定时器原来的3分钟修改为5分钟
            interval: 300000;//修改为5分钟
            repeat: true //是否重复定时,默认为false
            running: false //是否开启定时，默认是false
            triggeredOnStart: false // 是否开启定时就触发onTriggered
            onTriggered: {
               /* getuserinfo()
                //setInfo()
                console.log("界面头部位",strip, userId, window.companyoid);*/
                timeremailseralarms.start();
                timeremailseralarmsmaintop.stop();
                Query.query(strip, userId, jsessionid,parsedata)

            }
        }
        IconButton {
            id: email
            width: 42
            height: 22
            iconWidth: 22
            iconHeight: 22
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 18
            anchors.left: headinfor.right
            anchors.leftMargin: 12
            leftMargin: 2
            textcontent: "0"
            toolTipText: "电子邮件"
            iconImage: "qrc:/resource/images/main/maintop/mail.png"
            hoverImage: "qrc:/resource/images/main/maintop/hovered.png"
            onClicked: {
                getuserinfo()
                //setInfo()
                //Query.query(strip, userId, window.companyoid,parsedata)
                //if(email.textcontent>0)email.textcontent=email.textcontent-1;
                email.update()

                // var firstWindow = windowComponent.createObject(window.parent
                //                                                    , {"webWidth":window.webWidth
                //                                                    , "webHeight": window.webHeight
                //                                                    , "strTitle": qsTr("电子邮件")
                //                                                    , "pageFlags": "email"});
                //      firstWindow.webView.url = strip + "/email/index?lang=zh_CN";

                //电子邮件
                console.log("电子邮件:"+strip + "/email/index?lang=zh_CN");
                var  paramurl = strip + "/email/index?lang=zh_CN";
               // Qt.openUrlExternally(paramurl+"&JSESSIONID1=" + jsessionid)
                //iewebrun._vNewWindows_IE((paramurl+"&JSESSIONID1=" + jsessionid).toString(),"电子邮件");
                iewebrun._vNewWindows_XOAbrowser((paramurl+"&JSESSIONID1=" + jsessionid).toString(),"电子邮件",true);
               // iewebrun._vNewWindows((paramurl+"&JSESSIONID1=" + jsessionid).toString(),"电子邮件",true,strip);
             Query.query(strip, userId, jsessionid,parsedata)
                //webRun._vNewWindows(strip + "/email/index?lang=zh_CN","电子邮件",true,strip)
             console.log("这是未看的邮件。。",textcontent)
            }
        }

        IconButton {
            id: seralarms
            width: 42
            height: 22
            iconWidth: 22
            iconHeight: 22
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 18
            anchors.left: email.right
            anchors.leftMargin: 4
            leftMargin: 2
            textcontent: "0"
            toolTipText: "事务提醒"
            iconImage: "qrc:/resource/images/main/maintop/notice.png"
            hoverImage: "qrc:/resource/images/main/maintop/hovered.png"
            onClicked: {
                 getuserinfo()  //判断用户使用哪个网址登陆

                //2018-11-19修改点击事务提醒，事务提醒数目为0，取消事务提醒闪烁。
                /* seralarms.update()
                 console.log("事务提醒: ",  strip + "/sms/index?lang=zh_CN")  //strip

               // iewebrun._vNewWindows((paramurl+"&JSESSIONID1=" + jsessionid).toString(),"事务提醒",true,strip);
                Query.query(strip, userId, jsessionid,parsedata)
              //webRun._vNewWindows( strip + "/sms/index?lang=zh_CN","事务提醒",true,strip)
                console.log("这是未看的事务。。",textcontent,jsessionid)*///原来代码。
                //新代码将数目清零逻辑放到该处
                var  paramurl = strip + "/sms/index?lang=zh_CN";
                //Qt.openUrlExternally(paramurl+"&JSESSIONID1=" + jsessionid)
                console.log("点击了事务提醒",strip + "/sms/index?lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                //iewebrun._vNewWindows_IE(strip + "/sms/index?lang=zh_CN"+"&JSESSIONID1=" + jsessionid,"事务提醒");
                iewebrun._vNewWindows_XOAbrowser(strip + "/sms/index?lang=zh_CN"+"&JSESSIONID1=" + jsessionid,"事务提醒",true);

                cleartopseralarms();
                console.log("MainTop:当事务提醒为零时，清除图标闪烁事务提醒条目1",chattooltip.getModelCount())
                taryMsgdataMap.remove("'" + "/sms/index?" + "'")
                //taryMsgdataMap.clear();
                //chattooltip.removeAtIndexasname("'" + "/sms/index?"  + "'");
                chattooltip.removeAtIndexasname("/sms/index?");
                //chattooltip.removeAtIndex(); //gaobo
                console.log("MainTop:当事务提醒为零时，清除图标闪烁事务提醒条目2",chattooltip.getModelCount(),taryMsgdataMap.length)
                    //if(chattooltip.getModelCount()== 0)
                    if(chattooltip.getModelCount() == 0)
                    {
                        console.log("MainTop:当所有提醒为零时，清除图标闪烁事务提醒条目3")
                        _msgtimer.running = false;
                        chattooltip.visible = false;
                        chattooltip.hide();
                        taryMsgdataMap.clear();
                        trayIconUpdate.updateTrayIcon(":/resource/logo.ico")
                        return
                    }                    

                //setInfo()
               // Query.query(strip, userId, window.companyoid,parsedata)
                //if(seralarms.textcontent>0)seralarms.textcontent=seralarms.textcontent-1;

                //  var firstWindow = windowComponent.createObject(window.parent
                //                                                     , {"webWidth":window.webWidth
                //                                                     , "webHeight": window.webHeight
                //                                                     , "strTitle": qsTr("事务提醒")
                //                                                     , "pageFlags": "seralarms"});
                //  firstWindow.webView.url = strip + "/sms/index?lang=zh_CN";

                //事务提醒
            }
        }

        /*IconButton {
            id: taskcenter
            width: 45
            height: 20
            iconWidth: 25
            iconHeight: 20
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 18
            anchors.left: seralarms.right
            anchors.leftMargin: 2
            textcontent: "0"
            visible: flase
            iconImage: "qrc:/resource/images/main/maintop/task_center.png"
            hoverImage: "qrc:/resource/images/main/maintop/task_center_hover.png"
            onClicked: {
                getuserinfo()

                creatWebObj(qsTr("待办中心"), strip + "/workflow/work/workList?lang=zh_CN", "task")
            }
        }*/
    IconButton {
        id: spirit
        width: 24
        height: 24
        iconWidth: 22
        iconHeight: 22
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 18
        anchors.right: parent.right
        anchors.rightMargin: 5
        leftMargin: 1
        toolTipText: "精灵导航"
        iconImage: "qrc:/resource/window_logo.png"
        hoverImage: "qrc:/resource/window_logo.png"
        onClicked: {
            getuserinfo()
            
            //var  paramurl = strip + "/main?lang=zh_CN";
            var   paramtitle  = "精灵导航";
            console.log("精灵导航spirit: ",  strip + "/main?lang=zh_CN"+"?&JSESSIONID1=" + jsessionid)
            var  paramurl = strip + "/main?lang=zh_CN"+"&JSESSIONID1=" + jsessionid;
            //webRun._vNewWindows(paramurl.toString(),paramtitle.toString(),true,strip);
            // Qt.openUrlExternally(paramurl+"&JSESSIONID1="+ jsessionid)
            //  iewebrun._vNewWindows(paramurl.toString(),paramtitle.toString(),true,strip);
            //iewebrun._vNewWindows_IE(paramurl+"&JSESSIONID1="+ jsessionid,"精灵导航");   //这是最新的

            iewebrun._vNewWindows_XOAbrowser(paramurl,"精灵导航",true);   //XOA 浏览器
        }
    }
    
    
    //创建web窗口对象
    function creatWebObj(text, url, pageId) {
        var component = Qt.createComponent("../common/CustomWebView.qml");

        console.log("mainUrl___2____",mainUrl)
        var obj;
        if (component.status === Component.Ready)
        {
            
            for(var i = 0; i < webPageObj.length; ++i)
            {
                if(webPageObj[i].pageid  == pageId)
                {
                    return;
                }
            }
            
            obj = component.createObject(window.parent, {"nabkgImageme": "qrc:/resource/images/main/common/skin.png"
                                             , "titletext": text
                                             , "visible": true
                                             , "pageid": pageId
                                             , "weburl": url});
            
        }
        
        if(obj === null)
        {
            
        }
        else
        {
            obj.sendWebUrl.connect(mainwindow.getWebChildUrl)
            obj.deleteitem.connect(maintopoperating.deleteUserInfoObj)
            webPageObj.push(obj)
        }
    }
    
    function deleteUserInfoObj(pageid)
    {
        
        for(var i = 0; i < webPageObj.length; ++i)
        {
            if(webPageObj[i].pageid == pageid)
            {
                if(webPageObj[i] == null)
                {
                    return;
                }
                
                webPageObj[i].deleteitem.disconnect(maintopoperating.deleteUserInfoObj)
                webPageObj[i].sendWebUrl.disconnect(mainwindow.getWebChildUrl)
                webPageObj[i].destroy()
                console.log("destroy4DSW", pageid)
            }
        }
    }
    
    function deleteAllObj()
    {
        for(var i = 0; i < webPageObj.length; ++i)
        {
            if(webPageObj[i] == null)
            {
                return;
            }
            
            webPageObj[i].deleteitem.disconnect(maintopoperating.deleteUserInfoObj)
            webPageObj[i].destroy()
        }
        
        if(signatureObj == null)
        {
            return;
        }
        signatureObj.deleteitem.disconnect(maintopoperating.deletesignatureObj)
        signatureObj.destroy()
        signatureObj = null
    }
    
    function deletesignatureObj(textEdit, bFlag)
    {
        if(bFlag)
        {
            var strSign = textEdit.split("/");
            signature.textContent = strSign[0]
            mainwindow.strSignatureIcon = strSign[1]
            signature.sigIcon = strSign[1]
        }
        signatureObj.deleteitem.disconnect(maintopoperating.deletesignatureObj)
        signatureObj.destroy()
        signatureObj = null
    }
    function cleartopseralarms()
    {
        seralarms.textcontent = "0"
        email.textcontent = "0"
        timeremailseralarms.stop();
        timeremailseralarmsmaintop.start();
        msgtimerNum = 0
    }
    function creatSignatureObj() {
        var component = Qt.createComponent("PersonalizedSignature.qml");
        
        if (component.status === Component.Ready)
        {
            if(signatureObj === null)
            {
                signatureObj = component.createObject(window.parent, { "visible": true
                                                          , "strip": window.strip
                                                          , "strJessionId": mainwindow.jsessionid
                                                          , "signatureText": signature.textContent
                                                          , "signatureIcon" : mainwindow.strSignatureIcon
                                                      });
            }
        }
        if(signatureObj === null)
        {
            
        }
        else
        {
            
            signatureObj.deleteitem.connect(maintopoperating.deletesignatureObj)
        }
    }
    
    Component.onCompleted: {
        
        
    }
}
