﻿import QtQuick 2.0
import QtQuick.Window 2.2

Window {
    id:menupage
    property alias pagex: menupage.x
    property alias pagey: menupage.y

    width: 150
    height: 120
    color: "#E9E9E9"
    flags: Qt.Window | Qt.FramelessWindowHint
    signal deleteitem()

    ListModel {
        id: contactModel
        ListElement {
            content: qsTr("打开主面板")
        }

        ListElement {
            content: qsTr("关于OA办公精灵")
        }

        ListElement {
            content: qsTr("切换用户")
        }


        ListElement {
            content: qsTr("退出")
        }
    }


    Component {
        id: contactDelegate

        Rectangle{
            id: hoveredbkg
            width: 150
            height:30

            color: ListView.isCurrentItem ? "lightsteelblue" : "#D5D095"

            Text {
                id: username
                anchors.top:parent.top
                anchors.topMargin: 4
                anchors.left:parent.left
                anchors.leftMargin: 6
                anchors.right: parent.right
                anchors.rightMargin: 6
                height: 30

                verticalAlignment: Qt.AlignVCenter
                horizontalAlignment: Qt.AlignHCenter

                font.pixelSize: 12
                color: "black"

                text: content
            }

            MouseArea{
                anchors.fill: parent
                hoverEnabled: true

                onClicked: {
                    hoveredbkg.ListView.view.currentIndex = index
                }
            }
        }
    }

    ListView {
        id: contactlistview
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.leftMargin: 1
        anchors.right: parent.right
        anchors.rightMargin: 1
        anchors.bottom: parent.bottom
        focus: true
        spacing:1
        //clip: true
        model: contactModel
        delegate: contactDelegate
        currentIndex: 0
    }

}
