﻿import QtQuick 2.7
import QtQuick.Window 2.2
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import "../common"

Window {
    id: signaturewindow
    width: 320
    height: 367
    flags: Qt.Window | Qt.FramelessWindowHint
    x: (Screen.desktopAvailableWidth - 320)/2
    y: (Screen.desktopAvailableHeight - 367)/2
    opacity: 1.0
    visible: true
    title: "编辑个性签名"
    property string strip: "";
    property string strJessionId: "";
    property string signatureText: "";
    property string signatureIcon: "";
    signal deleteitem(string strText, bool bFlag);
    property bool bPressed: true

    
    MouseArea { //为窗口添加鼠标事件
        id:mouse
        anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0";
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true
        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                //如果mainwindow继承自QWidget,用setPos
                signaturewindow.setX(signaturewindow.x+delta.x)
                signaturewindow.setY(signaturewindow.y+delta.y)
            }
        }
    }

    Rectangle {
        id: bkgimg
        anchors.fill: parent
        color: "#168ADA"
        border.width: 1
        border.color: "#cccccc"
        Rectangle{
            id: titlebkg
            width: parent.width
            height: 28
            color: "#168ADA"

            Image {
                id: titleImage
                anchors.top: parent.top
                anchors.topMargin: 5
                anchors.left: parent.left
                anchors.leftMargin: 6
                height: 18
                width: 18
                source: "qrc:/resource/images/main/maintop/titleIcon.png"
            }
            Text {
                id: titletext
                anchors.top: parent.top
                anchors.topMargin: 5
                anchors.left:titleImage.right
                anchors.leftMargin: 3
                font.pixelSize: 12
                font.bold: false
                font.family: "微软雅黑"
                color: "#FFFFFF"
                text: qsTr("修改个性签名")
            }

            ControlButton {
                id: mix
                anchors.top: parent.top
                anchors.right: close.left
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/main/maintop/min.png";
                hoverImage: "qrc:/resource/images/main/maintop/minHover.png";

                onClicked: {
                    signaturewindow.visibility = Window.Minimized
                }
            }

            ControlButton {
                id: close
                anchors.top: parent.top
                anchors.right: parent.right
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/main/maintop/close.png"
                hoverImage: "qrc:/resource/images/main/maintop/closeHover.png"
                onClicked:{
                    signaturewindow.deleteitem("", false);
                }
            }
        }

        Rectangle {
            id: bkg
            anchors.top: titlebkg.bottom
            anchors.topMargin: 0
            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right: parent.right
            anchors.rightMargin: 1
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 1
            color: "#ffffff"
            Rectangle{
                id: editbkg
                anchors.top: parent.top
                anchors.topMargin: 0
                anchors.left: parent.left
                anchors.leftMargin: 0
                height: 40
                width: 318
                color: "#EBF6FF"
                Image {
                    id: editImage
                    anchors.top: parent.top
                    anchors.topMargin: 12
                    anchors.left: parent.left
                    anchors.leftMargin: 7
                    height: 18
                    width: 18
                    source:
                        if(signatureIcon === "")
                        {
                            return "qrc:/resource/images/main/maintop/DefaultIcon.png"
                        }
                        else
                        {
                            return "qrc:/resource/images/main/maintop/" + signatureIcon;
                        }
                }
                TextField{
                    id: editContent
                    anchors.top: editbkg.top
                    anchors.topMargin: 0
                    anchors.left: editImage.right
                    anchors.leftMargin: 0
                    anchors.right: quitImage.left
                    anchors.rightMargin: 0
                    anchors.bottom: parent.bottom
                    anchors.bottomMargin: 0
                    verticalAlignment: Qt.AlignVCenter
                    font.family: "微软雅黑"
                    font.pixelSize: 14
                    placeholderText:qsTr("说说你的办公状态吧")
                    text: signatureText

                    style: TextFieldStyle {
                        placeholderTextColor: "#a4d3f5"
                        textColor: "#555555"
                        background: Item {

                        }
                    }
                }
                Image {
                    id: quitImage
                    anchors.top: parent.top
                    anchors.topMargin: 11
                    anchors.right: parent.right
                    anchors.rightMargin: 5
                    height: 18
                    width: 18
                    source: "qrc:/resource/images/main/maintop/clearIcon.png"
                    MouseArea{
                        anchors.fill: parent
                        hoverEnabled: true
                        onClicked: {
                            editContent.text = ""
                            editImage.source = "qrc:/resource/images/main/maintop/DefaultIcon.png"
                        }

                        onEntered: {
                            quitImage.source = "qrc:/resource/images/main/maintop/clearIcon_hover.png"
                        }

                        onExited: {
                            quitImage.source = "qrc:/resource/images/main/maintop/clearIcon.png"
                        }
                    }
                }
            }
            ListModel{
                id: selectModel
                ListElement {
                    iconImage: "qrc:/resource/images/main/maintop/1.png"
                    textContent: "认真办公中"
                }
                ListElement {
                    iconImage: "qrc:/resource/images/main/maintop/2.png"
                    textContent: "休息充电中"
                }
                ListElement {
                    iconImage: "qrc:/resource/images/main/maintop/3.png"
                    textContent: "出差办事中"
                }
                ListElement {
                    iconImage: "qrc:/resource/images/main/maintop/4.png"
                    textContent: "学习提高中"
                }
                ListElement {
                    iconImage: "qrc:/resource/images/main/maintop/5.png"
                    textContent: "生病难受中"
                }
                ListElement {
                    iconImage: "qrc:/resource/images/main/maintop/6.png"
                    textContent: "总结报告中"
                }
                ListElement {
                    iconImage: "qrc:/resource/images/main/maintop/7.png"
                    textContent: "开会中"
                }
            }
            ListView{
                id: selectView
                anchors.top: editbkg.bottom
                anchors.topMargin: 10
                anchors.left: parent.left
                anchors.leftMargin: 0
                anchors.right: parent.right
                anchors.rightMargin: 0
                height: 224
                spacing:0
                clip: true
                model: selectModel
                delegate: selectDelegate
                //currentIndex: 0

            }
            Component {
                id: selectDelegate

                Rectangle{
                    id: hoveredbkg
                    width: 318
                    height:32
                    Image {
                        id: icon
                        width: 24
                        height: 24
                        anchors.top: parent.top
                        anchors.topMargin: 4
                        anchors.left: parent.left
                        anchors.leftMargin: 20
                        source: iconImage
                    }
                    Text {
                        id: textName
                        anchors.top:parent.top
                        anchors.topMargin: 2
                        anchors.left: icon.right
                        anchors.leftMargin: 10
                        height: 28

                        verticalAlignment: Qt.AlignVCenter
                        horizontalAlignment: Qt.AlignLeft

                        font.pixelSize: 14
                        color: "#555555"
                        font.family: "微软雅黑"

                        text: textContent
                    }

                    MouseArea{
                        anchors.fill: parent
                        hoverEnabled: true

                        onExited: {
                            hoveredbkg.color = "#ffffff"
                        }

                        onEntered: {
                            hoveredbkg.color = "#EBF6FF"
                        }

                        onClicked: {
                            editContent.text = selectModel.get(index).textContent
                            editImage.source = selectModel.get(index).iconImage

                            var strPath = selectModel.get(index).iconImage

                            var strImageName = strPath.split("/")

                            signatureIcon = strImageName[strImageName.length - 1]
                        }
                    }
                }
            }
        }

        Rectangle{
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 50
            height: 1
            color: "#eee"
        }

        Button {
            id: loginsavebtn
            width: 64
            height: 28
            anchors.right: parent.right
            anchors.rightMargin: 15
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 11
            style:ButtonStyle {
                background: Rectangle {
                    border.color: control.hovered ? "#0075c4" : "#ccc"
                    border.width: 1
                    radius: 3
                    color: control.hovered ? "#278ADD" : "#EEEEEE"
                }

                label: Text{
                    text:qsTr("保存")
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: control.hovered ?"#FFFFFF" :"#333333"
                    font.bold: false
                    horizontalAlignment: Qt.AlignHCenter
                    verticalAlignment: Qt.AlignVCenter
                }
            }

            onClicked: {
                chatGetUserInfo.sendSignatureToServer(strip + "/user/editUserSign?sign=" + editContent.text +"/"+ signatureIcon, strJessionId, 3);
                deleteitem(editContent.text + "/"+ signatureIcon, true);
            }
        }
    }
}

