import QtQuick 2.2
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import FileIo 1.0

Item {

    property string language: ""

    function advancedView_transfer()
    {
        console.log("test-----test")
        //languagetext.text = qsTr("语言选择")
//        chinaese.text = qsTr("中文")
//        english.text = qsTr("English")
//        loginsavebtn.savetext = qsTr("保存")
//        logincancelbtn.canceltext = qsTr("关闭")
    }

    FileIo {
        id:fileio
    }

    Text {
        id: languagetext
        anchors.top: parent.top
        anchors.topMargin: 20
        anchors.left: parent.left
        anchors.leftMargin: 20

        font.pixelSize: 14
        //font.family: "微软雅黑"
        font.bold: true
        verticalAlignment: Qt.AlignVCenter
        text: qsTr("语言选择")
    }

    ExclusiveGroup {
        id: exclusive
    }

    RadioButton {
        id: chinaese
        width: 100
        height: 20
        anchors.top: languagetext.bottom
        anchors.topMargin: 15
        anchors.left: parent.left
        anchors.leftMargin: 20
        exclusiveGroup: exclusive
        text:qsTr("中文")
        onClicked: {

            fileio.writeIniFile("advanced", "language" , "zh")
            translator.load("zh")
        }
    }

    RadioButton {
        id: english
        width: 100
        height: 20
        anchors.top: languagetext.bottom
        anchors.topMargin: 15
        anchors.left: chinaese.right
        anchors.leftMargin: 10
        exclusiveGroup: exclusive
        text: qsTr("English")
        onClicked: {

            fileio.writeIniFile("advanced", "language" , "en")
            translator.load("zh")
        }
    }

    Button {
        id: loginsavebtn
        property string savetext: qsTr("保存")
        width: 70
        height: 30
        anchors.right: logincancelbtn.left
        anchors.rightMargin: 15
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 30
        style:ButtonStyle {
            background: Rectangle {
                border.color: "#ACACAC"
                border.width: 1
                color: control.hovered ? "#008AE7" : "#EEEEEE"
            }

            label: Text{
                text:loginsavebtn.savetext
                font.pixelSize: 12
                //font.family: "微软雅黑"
                color:  "#010101"
                font.bold: false
                horizontalAlignment: Qt.AlignHCenter
                verticalAlignment: Qt.AlignVCenter
            }
        }
        onClicked: {
            if(chinaese.checked)
            {
                fileio.writeIniFile("advanced", "language", "zh")
            }
            else
            {
                fileio.writeIniFile("advanced", "language", "en")
            }
        }
    }

    Button {
        id: logincancelbtn
        property string canceltext: qsTr("关闭")
        width: 70
        height: 30
        anchors.right: parent.right
        anchors.rightMargin: 20
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 30
        style:ButtonStyle {
            background: Rectangle {
                border.color: "#ACACAC"
                border.width: 1
                color: control.hovered ? "#008AE7" : "#EEEEEE"
            }

            label: Text{
                text: logincancelbtn.canceltext
                font.pixelSize: 12
                //font.family: "微软雅黑"
                color:  "#010101"
                font.bold: false
                horizontalAlignment: Qt.AlignHCenter
                verticalAlignment: Qt.AlignVCenter
            }
        }
        onClicked: {

        }
    }

    Component.onCompleted:
    {
        translator.languageChanged.connect(advancedView_transfer)

        language = fileio.readIniFile("advanced", "language")

        if(language === "zh")
        {
            translator.load("zh")
            chinaese.checked = true
        }
        else
        {
            translator.load("zh")
            english.checked = true
        }

    }
}
