﻿import QtQuick 2.2
import QtQuick.Window 2.2
import QtQuick.Controls 1.2
import QtQuick.Controls.Styles 1.4

import FileIo 1.0
import "../common"

Window {
    id: network
    width:550
    height: 380
    visible: true
    x: (Screen.desktopAvailableWidth - 550)/2
    y: (Screen.desktopAvailableHeight - 380)/2
    
    flags: Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint
    modality: Qt.ApplicationModal
    signal deleteitem()
    property bool bPressed: true
    
    
    function setValue(){
        innetinput.text = fileio.readIniFile("login", "oainnet")
        outnetinput.text = fileio.readIniFile("login", "oaoutnet")
        testnetinput.text = fileio.readIniFile("login", "oatestnet")
        
        var usernet = fileio.readIniFile("login", "useroutnetlogin");
        if(usernet === "0")
        {
            innetcheckbox.checked = true;
        }
        else if(usernet === "1")
        {
            outnetcheckbox.checked = true;
        }
        else if(usernet === "2")
        {
            testnetcheckbox.checked = true;
        }
    }
    
    MouseArea { //为窗口添加鼠标事件
        id:mouse
        anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true
        }
        
        onReleased: {
            bPressed = false;
        }
        
        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                //如果mainwindow继承自QWidget,用setPos
                network.setX(network.x+delta.x)
                network.setY(network.y+delta.y)
            }
        }
    }
 
    Rectangle{
        anchors.fill: parent
        border.color: "#ccc"
        border.width: 1
        
        Rectangle{
            id: titlebkg
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.right: parent.right
            height:28
            color: "#149ADA"
            
            Image {
                id: icon
                width: 18
                height: 18
                anchors.top: parent.top
                anchors.topMargin: 5
                anchors.left: parent.left
                anchors.leftMargin: 6
                source: "qrc:/resource/images/login/set1.png"
            }
            
            Text
            {
                anchors.top: parent.top
                anchors.bottom: parent.bottom
                anchors.left: icon.right
                anchors.leftMargin: 3
                
                font.pixelSize: 12
                color: "white"
                font.family: "微软雅黑"
                verticalAlignment: Qt.AlignVCenter
                text: qsTr("网络和登录")
            }
            
            ControlButton {
                id:min
                anchors.top: parent.top
                anchors.topMargin: 0
                anchors.right: close.left
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/main/maintop/min.png"
                hoverImage: "qrc:/resource/images/main/maintop/minHover.png"
                onClicked: {
                    network.visibility = Window.Minimized
                }
            }
            
            ControlButton{
                id:close
                anchors.top: parent.top
                anchors.topMargin: 0
                anchors.right: parent.right
                anchors.rightMargin: 0
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/main/maintop/close.png"
                hoverImage: "qrc:/resource/images/main/maintop/closeHover.png"
                onClicked:{
 
                    deleteitem();
                }
            }
        }
        
        ExclusiveGroup {
            id: exclusive
        }
        
        Item {
            id: innetitem
            height:60
            anchors.top: titlebkg.bottom
            anchors.topMargin: 50
            anchors.left: parent.left
            anchors.right: parent.right
            
            CheckBox {
                id: innetcheckbox
                width: 23
                height: 23
                anchors.left: parent.left
                anchors.leftMargin: 60
                anchors.top: parent.top
                anchors.topMargin: 14.5
                exclusiveGroup: exclusive
                style: CheckBoxStyle {
                    indicator: Item {
                        implicitWidth: 16
                        implicitHeight: 16
                        Image {
                            id: autonormal
                            anchors.fill: parent
                            source: "qrc:/resource/images/login/checkbox.png"
                        }
                        
                        Image {
                            id: autochecked
                            anchors.fill: parent
                            visible: control.checked
                            source: "qrc:/resource/images/login/checkbox_hover.png"
                        }
                    }
                }
                
             //  onClicked: {
             //      fileio.writeIniFile("login", "useroutnetlogin", 0)innetcheckbox
             //  }
            }
            
            Rectangle {
                width: 380
                height: 60
                anchors.left: innetcheckbox.right
                anchors.leftMargin: 20
                anchors.top:parent.top
                radius: 3
                
                border.color: "#dbdbdb"
                border.width: 1
                
                Rectangle{
                    id: innetnamebkg
                    width: 120
                    height: 29
                    color: "#edf3f7"
                    anchors.top: parent.top
                    anchors.topMargin: 1
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    Text {
                        id: innetname
                        anchors.centerIn: parent
                        font.pixelSize: 14
                        color: "#333333"
                        font.family: "微软雅黑"
                        
                        text:qsTr(" 网络1:")
                    }
                }
                
                Text {
                    anchors.top: parent.top
                    anchors.bottom: line.top
                    anchors.left: innetnamebkg.right
                    anchors.leftMargin: 20
                    anchors.right: parent.right
                    
                    font.pixelSize: 14
                    color: "#666666"
                    font.family: "微软雅黑"
                    horizontalAlignment: Qt.AlignLeft
                    verticalAlignment: Qt.AlignVCenter
                    text: qsTr("内网地址")
                }
                
                Rectangle{
                    id:line
                    height: 1
                    anchors.top: innetnamebkg.bottom
                    anchors.left: parent.left
                    anchors.right: parent.right
                    color: "#dbdbdb"
                }
                
                Rectangle{
                    id: innetipbkg
                    width: 120
                    height: 28
                    anchors.top: line.bottom
                    anchors.topMargin: 0
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    color: "#edf3f7"
                    
                    Text {
                        id: innetip
                        anchors.centerIn: parent
                        font.pixelSize: 14
                        color: "#333333"
                        font.family: "微软雅黑"
                        text: qsTr("IP地址:")
                    }
                }
                
                
                TextField {
                    id: innetinput
                    anchors.left: innetipbkg.right
                    anchors.leftMargin: 15
                    anchors.right: parent.right
                    anchors.rightMargin: 5
                    anchors.top: line.bottom
                    anchors.bottom: parent.bottom
                    anchors.bottomMargin: 1
                    font.pixelSize: 14
                    font.family: "微软雅黑"
                    style: TextFieldStyle {
                        
                        textColor: "#666666"
                        background: Rectangle {
                            border.color: "#333"
                            border.width: 0
                        }
                    }
                    
                    onEditingFinished: {
                        innetinput.text = fileio.removeSubstr(innetinput.text);
                        var strinaddress = innetinput.text.split(":");
                        if(strinaddress[0] === "http"||strinaddress[0] === "https")
                        {
                            fileio.writeIniFile("login", "oainnet", innetinput.text)
                        }
                        else
                        {
                            fileio.writeIniFile("login", "oainnet", "http://" + innetinput.text)
                        }
                    }
                }
            }
        }
        
        Item {
            id: outnetitem
            height: 60
            anchors.top: innetitem.bottom
            anchors.topMargin: 30
            anchors.left: parent.left
            anchors.right: parent.right
            
            CheckBox {
                id: outnetcheckbox
                width: 23
                height: 23
                anchors.left: parent.left
                anchors.leftMargin: 60
                anchors.top: parent.top
                anchors.topMargin: 14.5
                exclusiveGroup: exclusive
                style: CheckBoxStyle {
                    indicator: Item {
                        implicitWidth: 16
                        implicitHeight: 16
                        Image {
                            id: autonormal1
                            anchors.fill: parent
                            source: "qrc:/resource/images/login/checkbox.png"
                        }
                        
                        Image {
                            id: autochecked1
                            anchors.fill: parent
                            visible: control.checked
                            source: "qrc:/resource/images/login/checkbox_hover.png"
                        }
                    }
                }
                onClicked: {
                 //   fileio.writeIniFile("login", "useroutnetlogin", 1) outnetcheckbox fileio.writeIniFile("login", "useroutnetlogin", 0)innetcheckbox
                }
            }
            
            Rectangle {
                width: 380
                height: 60
                anchors.left: outnetcheckbox.right
                anchors.leftMargin: 20
                anchors.top:parent.top
                radius: 3
                
                border.color: "#dbdbdb"
                border.width: 1
                
                Rectangle{
                    id: outnetnamebkg
                    width: 120
                    height: 29
                    color: "#edf3f7"
                    anchors.top: parent.top
                    anchors.topMargin: 1
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    Text {
                        id: outnetname
                        anchors.centerIn: parent
                        font.pixelSize: 14
                        color: "#333333"
                        font.family: "微软雅黑"
                        text:qsTr(" 网络2:")
                    }
                }
                
                Text {
                    anchors.top: parent.top
                    anchors.bottom: line1.top
                    anchors.left: outnetnamebkg.right
                    anchors.leftMargin: 20
                    anchors.right: parent.right
                    
                    font.pixelSize: 14
                    font.family: "微软雅黑"
                    color: "#666666"
                    horizontalAlignment: Qt.AlignLeft
                    verticalAlignment: Qt.AlignVCenter
                    text: qsTr("外网地址")
                }
                
                Rectangle{
                    id:line1
                    height: 1
                    anchors.top: outnetnamebkg.bottom
                    anchors.left: parent.left
                    anchors.right: parent.right
                    color: "#dbdbdb"
                }
                
                Rectangle{
                    id: outnetipbkg
                    width: 120
                    height: 28
                    anchors.top: line1.bottom
                    anchors.topMargin: 0
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    color: "#edf3f7"
                    
                    Text {
                        id: outnetip
                        anchors.centerIn: parent
                        font.pixelSize: 14
                        font.family: "微软雅黑"
                        color: "#333333"
                        text: qsTr("IP地址:")
                    }
                }
                
                
                TextField {
                    id: outnetinput
                    anchors.left: outnetipbkg.right
                    anchors.leftMargin: 15
                    anchors.right: parent.right
                    anchors.rightMargin: 5
                    anchors.top: line1.bottom
                    anchors.bottom: parent.bottom
                    anchors.bottomMargin: 1
                    font.pixelSize: 14
                    font.family: "微软雅黑"
                    text: ""
                    style: TextFieldStyle {
                        
                        textColor: "#666666"
                        background: Rectangle {
                            border.color: "#333"
                            border.width: 0
                        }
                    }
                    onEditingFinished: {
                        outnetinput.text = fileio.removeSubstr(outnetinput.text);
                        
                        var stroutaddress = outnetinput.text.split(":")
                        if(stroutaddress[0] === "http"||stroutaddress[0] === "https")
                        {
                            fileio.writeIniFile("login", "oaoutnet", outnetinput.text)
                        }
                        else
                        {
                            fileio.writeIniFile("login", "oaoutnet", "http://" + outnetinput.text)
                        }
                    }
                }
            }
        }
        
        Item {
            id: testnetitem
            height: 60
            anchors.top: outnetitem.bottom
            anchors.topMargin: 30
            anchors.left: parent.left
            anchors.right: parent.right

            CheckBox {
                id: testnetcheckbox
                width: 23
                height: 23
                anchors.left: parent.left
                anchors.leftMargin: 60
                anchors.top: parent.top
                anchors.topMargin: 15
                exclusiveGroup: exclusive
                style: CheckBoxStyle {
                    indicator: Item {
                        implicitWidth: 16
                        implicitHeight: 16
                        Image {
                            id: autonormal2
                            anchors.fill: parent
                            source: "qrc:/resource/images/login/checkbox.png"
                        }

                        Image {
                            id: autochecked2
                            anchors.fill: parent
                            visible: control.checked
                            source: "qrc:/resource/images/login/checkbox_hover.png"
                        }
                    }
                }

                onClicked: {
                 //   fileio.writeIniFile("login", "useroutnetlogin", 2) 
                }
            }

            Rectangle {
                width: 380
                height: 60
                anchors.left: testnetcheckbox.right
                anchors.leftMargin: 20
                anchors.top:parent.top
                radius: 3

                border.color: "#dbdbdb"
                border.width: 1

                Rectangle{
                    id: testnetnamebkg
                    width: 120
                    height: 29
                    color: "#edf3f7"
                    anchors.top: parent.top
                    anchors.topMargin: 1
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    Text {
                        id: testnetname
                        anchors.centerIn: parent
                        font.pixelSize: 14
                        color: "#333333"
                        font.family: "微软雅黑"

                        text:qsTr(" 网络3:")
                    }
                }

                Text {
                    anchors.top: parent.top
                    anchors.bottom: line2.top
                    anchors.left: testnetnamebkg.right
                    anchors.leftMargin: 20
                    anchors.right: parent.right

                    font.pixelSize: 14
                    font.family: "微软雅黑"
                    color: "#666666"
                    horizontalAlignment: Qt.AlignLeft
                    verticalAlignment: Qt.AlignVCenter
                    text: qsTr("OA办公精灵网址")
                }

                Rectangle{
                    id:line2
                    height: 1
                    anchors.top: testnetnamebkg.bottom
                    anchors.left: parent.left
                    anchors.right: parent.right
                    color: "#dbdbdb"
                }

                Rectangle{
                    id: testnetipbkg
                    width: 120
                    height:28
                    anchors.top: line2.bottom
                    anchors.topMargin: 0
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    color: "#edf3f7"

                    Text {
                        id: testnetip
                        anchors.centerIn: parent
                        font.pixelSize: 14
                        font.family: "微软雅黑"
                        color: "#333333"
                        text: qsTr("IP地址:")
                    }
                }

                TextField {
                    id: testnetinput
                    anchors.left: testnetipbkg.right
                    anchors.leftMargin: 15
                    anchors.right: parent.right
                    anchors.rightMargin: 6
                    anchors.top: line2.bottom
                    anchors.bottom: parent.bottom
                    anchors.bottomMargin: 1
                    font.pixelSize: 14
                    font.family: "微软雅黑"
                    style: TextFieldStyle {

                        textColor: "#666666"
                        background: Rectangle {
                            border.color: "#333"
                            border.width: 0
                        }
                    }
                    onEditingFinished: {
                        testnetinput.text = fileio.removeSubstr(testnetinput.text);
                        var strtestaddress = testnetinput.text.split(":");
                        if(strtestaddress[0] === "http"||strtestaddress[0] === "https")
                        {
                            fileio.writeIniFile("login", "oatestnet", testnetinput.text)
                        }
                        else
                        {
                            fileio.writeIniFile("login", "oatestnet", "http://" + testnetinput.text)
                        }
                    }
                }
            }
        }
        
        Button {
            id: btnSave
            x: 375
            width: 64
            height: 28
            anchors.top: btnCancle.top
            anchors.topMargin:  1
            anchors.right: btnCancle.left
            anchors.rightMargin: 9
            
            style:ButtonStyle {
                background: Rectangle {
                    border.color: control.hovered ? "#0075c4" : "#ccc"
                    border.width: 1
                    radius: 3
                    color: control.hovered ? "#278ADD" : "#EEEEEE"
                }
                
                label: Text{
                    text:qsTr("保存")
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: control.hovered ?"#FFFFFF" :"#333333"
                    font.bold: false
                    horizontalAlignment: Qt.AlignHCenter
                    verticalAlignment: Qt.AlignVCenter
                }
            }
            
            onClicked: {
                
                //   fileio.writeIniFile("login", "useroutnetlogin", 2)  testnetcheckbox
                //   fileio.writeIniFile("login", "useroutnetlogin", 1) outnetcheckbox 
                //  fileio.writeIniFile("login", "useroutnetlogin", 0)innetcheckbox
                
                
                if(innetcheckbox.checked)
                {
                    fileio.writeIniFile("login", "useroutnetlogin", 0)
                }  
                else if(outnetcheckbox.checked)
                {
                    fileio.writeIniFile("login", "useroutnetlogin", 1)
                }  
                else    if(testnetcheckbox.checked)
                {
                    fileio.writeIniFile("login", "useroutnetlogin", 2)
                }
                
                
                
                innetinput.text = fileio.removeSubstr(innetinput.text);
                var strinaddress = innetinput.text.split(":");
                
                if(strinaddress[0] === "http"||strinaddress[0] === "https")
                {
                    fileio.writeIniFile("login", "oainnet", innetinput.text)
                }
                else
                {
                    fileio.writeIniFile("login", "oainnet", "http://" + innetinput.text)
                }
                
                
                
                outnetinput.text = fileio.removeSubstr(outnetinput.text);
                var stroutaddress1 = outnetinput.text.split(":")
                
                if(stroutaddress1[0] === "http"||stroutaddress1[0] === "https")
                {
                    fileio.writeIniFile("login", "oaoutnet", outnetinput.text)
                }
                else
                {
                    fileio.writeIniFile("login", "oaoutnet", "http://" + outnetinput.text)
                }
                
                
                testnetinput.text = fileio.removeSubstr(testnetinput.text);
                var strtestaddress2 = testnetinput.text.split(":");
                
                if(strtestaddress2[0] === "http"||strtestaddress2[0] === "https")
                {
                    fileio.writeIniFile("login", "oatestnet", testnetinput.text)
                }
                else
                {
                    fileio.writeIniFile("login", "oatestnet", "http://" + testnetinput.text)
                }

                //settingwindow.close();
                if(innetcheckbox.checked)
                {
                    fileio.writeIniFile("login", "dnsip", fileio.readIniFile("login","oainnet"))//innetinput.text
                    //fileIo.setstrDns(fileio.readIniFile("login","oainnet"));

                }
                else if(outnetcheckbox.checked)
                {
                    fileio.writeIniFile("login", "dnsip",  fileio.readIniFile("login","oaoutnet"))//outnetinput.text
                    // fileIo.setstrDns(fileio.readIniFile("login","oaoutnet"));
                }
                else
                {
                    fileio.writeIniFile("login", "dnsip", fileio.readIniFile("login","oatestnet"))//testnetinput.text
                   // fileIo.setstrDns(fileio.readIniFile("login","oatestnet"));
                }
                deleteitem();
            }
        }
        
        Button {
            id: btnCancle
            x: 448
            width: 64
            height: 28
            anchors.top: testnetitem.top
            anchors.topMargin:  81
            anchors.right: testnetitem.left
            anchors.rightMargin: -512
            style:ButtonStyle {
                background: Rectangle {
                    border.color: control.hovered ? "#0075c4" : "#ccc"
                    border.width: 1
                    radius: 3
                    color: control.hovered ? "#278ADD" : "#EEEEEE"
                }
                
                label: Text{
                    text:qsTr("取消")
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: control.hovered ?"#FFFFFF" :"#333333"
                    font.bold: false
                    horizontalAlignment: Qt.AlignHCenter
                    verticalAlignment: Qt.AlignVCenter
                }
            }
            onClicked: {
                deleteitem();
            }
        }
    }
    
    Component.onCompleted:
    {
        setValue()
    }
}
