﻿import QtQuick 2.8
import QtQuick.Layouts 1.3
import QtWebEngine 1.5
import QtWebChannel 1.0
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import QtQuick.Window 2.2
import QtQuick.Dialogs 1.1

Rectangle {

    id: _SignalWebEngineID
    objectName: "_SignalWebEngine"
    property string _webWidth       : ""//!高度
    property string _webHeigth      : ""//!宽度
    property string _webTitle         :  "你好"//!标题字样
    property string _webTitlecolor  : ""//!标题样式
    property string _webTitleico     : ""//!ioc地址
    property string _webUrl            : "www.baidu.com"//初始url
    property string _webMode        : ""//!webmode
    property string _cachePath      : ""//!缓存路径
    property string _cacheMaxSize: "" //!最大缓存大小 0为自动分配
    property bool   _fullScreen       : 0 //!全屏显示
    property string  _zoomFactor    :1.0//!缩放比例
    property bool   _javasCanOpenWindows : true //!支持java打开对话框
    // property  list<WebEngineScript>:""

    //![1]
    signal _sig_urlChanged(var url); //!url更改事件
    signal _sig_loadFinished(var load);//!load成功事件
    signal _sig_loadProgress(var vle);//!load进程
    signal _sig_loadStarted();    //!load开始
    signal _sig_renderProcessTerminated(var exitcode); //!未知情况终止
    //signal _sig_downloadRequested(var vle);//!下载请求事件

    signal _sig_close();           //! 关闭界面事件
    signal _sig_hide();            //!隐藏事件
    signal _sig_setEnabled(var flag); //!设置控件可用

    signal _sig_fullScreenCancelled()
    signal _sig_goBack()//!返回事件
    signal _sig_goBackOrForward(var offset)//!返回源码事件
    signal _sig_goForward()//!查看源码事件
    signal _sig_reload()//!刷新事件
    signal _sig_stop()//!停止事件

    signal  _sig_setActiveFocusOnPress(var arg)
    signal  _sig_triggerWebAction(var action)

    //![!1]


    WebChannel {
        id: _SignalWebEngineChannel
    }

    WebEngineProfile
    {
        id:_SignalWebEngineProfile
        //cachePath : "D:\bak\ispirit_xoa\Cache"
        //!  httpAcceptLanguage :  ""
        httpCacheMaximumSize :  0   //!automatically
        httpCacheType : WebEngineProfile.DiskHttpCache
        //httpUserAgent : true
        //offTheRecord : bool //!脱机
        //! persistentCookiesPolicy : enumeration //!会话Cookies
        //! persistentStoragePath : "" //!持续存储路径
        spellCheckEnabled : true//!拼写检测
        //  spellCheckLanguages : list<string>
        // storageName : ""  配置存储位置
        //   userScripts : list<WebEngineScript>//!脚本对象列表
    }


    WebEngineView {
        id: _SignalWebEngine
        webChannel: _SignalWebEngineChannel
        profile:_SignalWebEngineProfile
        // setting:_SignalWebEngineSettings
        anchors.fill: parent
        width: parent.width
        height: parent.width
        visible: true
        smooth: true
        url:"www.baidu.com"


        /*
        //  ErrorDomain : enumeration 介绍各种高级错误类型：
        //  Feature : enumeration  能要求用户授予或拒绝访问的平台功能访问类别  0:位置硬件或服务。 1:音频捕获设备，如麦克风。 2:视频设备，如相机。3:音频和视频捕获设备。
        //  FindFlags : enumeration 介绍可用于findText（）函数的选项。 选项可以从以下列表中进行或运算
        //  JavaScriptConsoleMessageLevel : enumeration  //指示JavaScript控制台消息的严重性：
        //  LoadStatus : enumeration  //反映页面的加载状态：
        //  NewViewDestination : enumeration  //介绍如何打开新视图          NewViewInWindow: 一个单独的窗口中。  .NewViewInTab: 在同一个窗口的标签中。     .NewViewInDialog: 在没有标签栏，工具栏或URL栏的窗口中。        NewViewInBackgroundTab:在同一窗口的选项卡中，不隐藏当前可见的Web引擎视图。
        //  PrintedPageOrientation : enumeration //打印的页面方向：枚举
        //  PrintedPageSizeId : enumeration  //打印页面尺寸标识
        //  RenderProcessTerminationStatus : enumeration //渲染进程终止状态
        //  WebAction : enumeration      //介绍可以在网页上执行的操作类型：
                           WebEngineView.NoWebAction没有行动被触发。
                           WebEngineView.Back浏览导航链接的历史记录。
                           WebEngineView.Forward在导航链接的历史记录中前进。
                           WebEngineView.Stop停止加载当前页面。
                           WebEngineView.Reload重新加载当前页面。
                           WebEngineView.ReloadAndBypassCache重新加载当前页面，但不要使用任何本地缓存。
                           WebEngineView.Cut将当前选中的内容剪切到剪贴板中。
                           WebEngineView.Copy将当前选中的内容复制到剪贴板。
                           WebEngineView.Paste从剪贴板粘贴内容。
                           WebEngineView.Undo撤消上一次编辑操作。
                           WebEngineView.Redo重做上一次编辑操作。
                           WebEngineView.SelectAll选择所有内容。
                           WebEngineView.PasteAndMatchStyle以当前样式粘贴剪贴板中的内容。
                           WebEngineView.OpenLinkInThisWindow打开当前窗口中的当前链接。 （在Qt 5.6中添加）
                           WebEngineView.OpenLinkInNewWindow在新窗口中打开当前链接。 （在Qt 5.6中添加）
                           WebEngineView.OpenLinkInNewTab在新选项卡中打开当前链接。 （在Qt 5.6中添加）
                           WebEngineView.CopyLinkToClipboard将当前链接复制到剪贴板。 （在Qt 5.6中添加）
                           WebEngineView.CopyImageToClipboard将点击的图像复制到剪贴板。 （在Qt 5.6中添加）
                           WebEngineView.CopyImageUrlToClipboard将点击的图像的URL复制到剪贴板。 （在Qt 5.6中添加）
                           WebEngineView.CopyMediaUrlToClipboard将悬停的音频或视频的网址复制到剪贴板。 （在Qt 5.6中添加）
                           WebEngineView.ToggleMediaControls切换显示和隐藏悬停的音频或视频元素的控件。 （在Qt 5.6中添加）
                           WebEngineView.ToggleMediaLoop切换播放的音频或视频是否应循环完成。 （在Qt 5.6中添加）
                           WebEngineView.ToggleMediaPlayPause切换悬停的音频或视频元素的播放/暂停状态。 （在Qt 5.6中添加）
                           WebEngineView.ToggleMediaMute静音或取消静音悬停的音频或视频元素。 （在Qt 5.6中添加）
                           WebEngineView.DownloadLinkToDisk将当前链接下载到磁盘。要执行下载操作，请连接到QWebEngineProfile :: downloadRequested信号。 （在Qt 5.6中添加）
                           WebEngineView.DownloadImageToDisk将突出显示的图像下载到磁盘。 （在Qt 5.6中添加）
                           WebEngineView.DownloadMediaToDisk将悬停的音频或视频下载到磁盘。 （在Qt 5.6中添加）
                           WebEngineView.InspectElement触发任何附加的Web Inspector检查高亮元素。 （在Qt 5.6中添加）
                           WebEngineView.ExitFullScreen退出全屏模式。 （在Qt 5.6中添加）
                           WebEngineView.SavePage将当前网页保存到磁盘。 （在Qt 5.7中添加）
                           WebEngineView.ViewSource在新标签中显示当前页面的来源。 （在Qt 5.8中添加）
        //  activeFocusOnPress : bool //指定视图在按下时是否应获得活动焦点。默认值是true。
        //  audioMuted : bool               // 当前页面音频是否静音的状态。
        //  backgroundColor : bool      //更改WebEngineView背景的颜色
        //  canGoBack : bool             //如果以前的会话历史记录条目返回true，否则返回false。
        //  canGoForward : bool         //如果存在后续会话历史记录条目，则返回true，否则返回false。
        //  contentsSize : size           //页面内容的大小。
        //  icon : url                          //用于访问当前显示的网站图标（也称为图标或快捷图标）的内部URL
        //  isFullScreen : bool            //如果Web视图处于全屏模式，则返回true，否则返回false。
        //  loadProgress : int              // 已加载的页面中的数据量，以从0到100的整数百分比表示
        //  loading : bool                    //如果HTML页面正在加载，则返回true;否则返回false
        //  navigationHistory : WebEngineHistory  //当前视图的导航历史记录。
        //  profile : WebEngineProfile                  // 用于视图的当前配置文件。
       //   recentlyAudible : bool                          //返回当前页面的可听状态（音频最近播放或不播放）。
        //  scrollPosition : point                          //滚动页面内容的位置
        //  settings : WebEngineSettings            //这个视图使用的设置。
        //  title : string                                        //当前显示的HTML页面的标题。这是一个反映<title>标签内容的只读值。
        //  url : url                                              //当前显示的HTML页面的位置。这个可写属性提供了将页面加载到Web视图的主界面。
        //  userScripts : list<WebEngineScript>   //附加到视图的脚本对象的列表。
        //  webChannel : QQmlWebChannel    //此视图使用的Web通道实例。此通道自动使用Chromium IPC上的内部QtWebEngine传输机制，并将其呈现为qt.webChannelTransport的页面的javascript上下文中公开
        //  webChannelWorld : int               //该视图使用的Web通道实例安装在的JavaScript世界中。
        //  zoomFactor : real                      //视图的缩放因子。有效值在0.25到5.0的范围内。默认因子是1.0。

*/

        //![4] signal
        // activeFocusOnPressChanged(bool activeFocusOnPress)
        onActiveFocusOnPressChanged: //主动焦点按下更改
        {
            console.log(" onActiveFocusOnPressChanged: " +activeFocusOnPress);
        }

        // audioMutedChanged(bool muted)
        onAudioMutedChanged: // 音频静音改变
        {
            console.log(" onAudioMutedChanged: " +muted);
        }

        // authenticationDialogRequested(AuthenticationDialogRequest request)
        onAuthenticationDialogRequested:// 认证对话请求
        {
            console.log(" onAuthenticationDialogRequested: " +request.url);
        }

        // backgroundColorChanged()
        onBackgroundColorChanged: //背景颜色改变
        {
        }

        // certificateError(WebEngineCertificateError error)
        onCertificateError://证书错误
        {
            console.log(" onCertificateError: " +error.url);
        }

        // colorDialogRequested(ColorDialogRequest request)
        onColorDialogRequested://颜色对话框请求
        {
            console.log(" colorDialogRequested: " +request.url);
        }

        // contextMenuRequested(ContextMenuRequest request)
        onContextMenuRequested://上下文菜单请求
        {
            console.log(" onContextMenuRequested: " +request.url);
        }

        // featurePermissionRequested(url securityOrigin, Feature feature)
        onFeaturePermissionRequested: //功能权限请求
        {
            console.log(" onFeaturePermissionRequested: " +securityOrigin.toString());
            console.log(" onFeaturePermissionRequested: " +feature.toString());
        }

        // fileDialogRequested(FileDialogRequest request)
        onFileDialogRequested://文件对话框请求
        {
            console.log(" fileDialogRequested: " +feature.url);
            //! 处理文件对话框

        }

        // formValidationMessageRequested(FormValidationMessageRequest request)
        onFormValidationMessageRequested://形式验证消息请求
        {
            console.log(" formValidationMessageRequested: " +feature.url);
        }

        // fullScreenRequested(WebEngineFullScreenRequest request)
        onFullScreenRequested: //全屏请求
        {
            console.log(" fullScreenRequested: " +feature.url);
        }

        // javaScriptConsoleMessage(JavaScriptConsoleMessageLevel level, string message, int lineNumber, string sourceID)
        onJavaScriptConsoleMessage://javaScript控制台消息
        {
            console.log(" javaScriptConsoleMessage: " +level);
            console.log(" javaScriptConsoleMessage: " +message);
            console.log(" javaScriptConsoleMessage: " +lineNumber);
            console.log(" javaScriptConsoleMessage: " +sourceID);
        }

        // javaScriptDialogRequested(JavaScriptDialogRequest request)
        onJavaScriptDialogRequested://javaScript对话框请求
        {
            console.log(" javaScriptDialogRequested: " +request.url);
        }

        // linkHovered(url hoveredUrl)
        onLinkHovered: //链接悬停
        {
            console.log(" linkHovered: " +hoveredUrl);
        }

        // loadingChanged(WebEngineLoadRequest loadRequest)
        onLoadingChanged://加载更改
        {
            console.log(" loadingChanged: " +loadRequest.url);
        }

        // navigationRequested(WebEngineNavigationRequest request)
        onNavigationRequested://导航请求
        {
            console.log(" navigationRequested: " +request.url);
        }

        // newViewRequested(WebEngineNewViewRequest request)
        onNewViewRequested://请求的新视图
        {
            console.log(" newViewRequested: " +request.url);
            if(_webMode == "1")
            {
                request.openIn(_SignalWebEngine)
            }
            else
            {
                //! new Object
            }
        }

        // pdfPrintingFinished(string filePath, bool success)
        onPdfPrintingFinished: //pdf打印完成
        {
            console.log(" pdfPrintingFinished: " +filePath);
            console.log(" pdfPrintingFinished: " +success);
        }

        // recentlyAudibleChanged(bool recentlyAudible)
        onRecentlyAudibleChanged://最近音频变化
        {
            console.log(" recentlyAudibleChanged: " +rrecentlyAudible);
        }

        // renderProcessTerminated(RenderProcessTerminationStatus terminationStatus, int exitCode)
        onRenderProcessTerminated: //渲染进程终止
        {
            console.log(" renderProcessTerminated: " +terminationStatus.toString());
            console.log(" renderProcessTerminated: " +exitCode);
        }

        // wasRecentlyAudibleChanged(bool wasRecentlyAudible)
        //   onWasRecentlyAudibleChanged: //最近听起来变了
        //   {}

        // windowCloseRequested()
        onWindowCloseRequested: //窗口关闭请求
        {
            console.log(" onWindowCloseRequested: ");
        }

    }

    /*
    Component  //组件
    {
        id: _sID
        url:"pageLoader"

        //   progress : real //加载组件的进度从0.0（没有加载）到1.0（已完成）。
        //   status : enumeration  //此属性拥有组件加载的状态 1.Null - 没有数据可用于组件. 2.Ready - 组件已被加载，并可用于创建实例 3..Loading - 组件正在加载. 4.Error - 加载组件时发生错误。 调用errorString（）
        //   url : url  //组件的URL。 这是用来构造组件的URL。
    }
*/
    Loader {    //加载组件
        id: pageLoader
        /*
        // active : bool  当前处于活动状态，则该属性为true,如果为false,控件不能被加载
        // asynchronous : bool //该属性保持组件是否将被异步实例化。
        // item : object       //该属性包含当前加载的顶级对象。
        // progress : real     //这个属性持有从网络中加载QML数据的进度，从0.0（没有加载）到1.0（已完成）
        // source : url          //该属性保存要实例化的QML组件的URL。卸载当前加载的对象，请将此属性设置为空字符串，或者将sourceComponent设置为undefined。 将源代码设置为新的URL也会导致由前一个URL创建的项目被卸载
        // sourceComponent : Component //源组件：组件 该属性包含要实例化的组件。
        // status : enumeration  //Loader.Null - 加载器处于非活动状态，或者没有设置QML源            Loader.Ready - 已加载QML源代码          Loader.Loading - 当前正在加载QML源代码          Loader.Error - 加载QML源时发生错误*/
    }

    Connections //信号链接
    {
        id: _sIDtions
        /*
        //  enabled : bool  //该属性保持项目是否接受更改事件
        //  ignoreUnknownSignals : bool //忽略未知的信号
        //  target : Object   //触发者ID*/
    }

    //![2]

    function _slot_initwensetting()
    {
        _SignalWebEngine.settings.javascriptEnabled =true;

        /*   WebEngineSettings
      {
          //    accelerated2dCanvasEnabled : bool //OpenGL帧缓存
          //    allowGeolocationOnInsecureOrigins : bool  //HTTPS已经能够请求
          //    allowRunningInsecureContent : bool  //URL运行JavaScript、CSS、插件或Web套接字
          //    autoLoadIconsForPage : bool  //自动下载网页图标。
          //    autoLoadImages : bool  //自动加载网页上的图片。
          //    defaultTextEncoding : string  //设置默认编码。
          //    errorPageEnabled : bool  //启用显示铬的内置错误页面。
          //    focusOnNavigationEnabled : bool //每当导航操作发生（加载、停止、重新加载、重新加载和旁路缓存、向前、向后、设置内容等）时，都会将焦点放在视图上。
          //    fullscreenSupportEnabled : bool //全屏
          //    hyperlinkAuditingEnabled : bool //启用对超链接ping属性的支持。
          //    javascriptCanAccessClipboard : bool 允许JavaScript程序从剪贴板读取或写入
          //    javascriptCanOpenWindows : //允许JavaScript程序在没有用户交互的情况下打开弹出窗口
          //    javascriptEnabled : boolbool //支持JavaScript程序的运行。
          //   linksIncludedInFocusChain : bool //包含键盘焦点链中的超链接。
          //   localContentCanAccessFileUrls : bool /允许本地加载的文档访问其他本地URL。
          //   localContentCanAccessRemoteUrls : bool//允许本地加载的文档访问远程URL。
          //   localStorageEnabled : bool //支持HTML 5本地存储功能。
          //   pluginsEnabled : bool //支持胡椒插件，如Flash播放器。
          //   printElementBackgrounds : bool//在打印网页时打开CSS背景的打印。
          //   screenCaptureEnabled : bool//在打印网页时打开CSS背景的打印。
          //   spatialNavigationEnabled : bool//告诉Web引擎在这个应用程序中是否支持屏幕捕获。
          //   touchIconsEnabled : bool //使触摸图标的支持和预触摸图标。
          //   webGLEnabled : bool  //使WebGL支持HTML 5。
      }
     */


    }

    // void fullScreenCancelled()
    function _slot_fullScreenCancelled()
    {
        _SignalWebEngine.fullScreenCancelled();
    }

    // void goBack()
    function _slot_goBack()
    {
        _SignalWebEngine.goBack();
        _sig_goBack();
    }

    // void reload()
    function _slot_reload()
    {
        _SignalWebEngine.reload();
        _sig_reload();
    }

    // void reloadAndBypassCache() //!重新加载
    function _slot_reloadAndBypassCache()
    {
        _SignalWebEngine.reloadAndBypassCache();
        _sig_reloadAndBypassCache();
    }

    // void goBackOrForward(int offset) //后退
    function _slot_goBackOrForward(offset)
    {
        _SignalWebEngine.goBackOrForward(offset)
        _sig_goBackOrForward(offset)
    }
    
    // void goForward()//前进
    function _slot_goForward()
    {
        _SignalWebEngine.goForward();
        _sig_goForward();
    }

    // void stop() //停止
    function _slot_stop()
    {
        _SignalWebEngine.stop();
        _sig_stop();
    }

    // void triggerWebAction(WebAction action)
    //如果arg为true，则将活动焦点设置为单击的Web引擎视图。 通过将其设置为false，可以使用Web引擎视图来创建不应该焦点的UI元素
    function _slot_triggerWebAction( action)  //不用
    {

    }

    // void setActiveFocusOnPress(bool arg)  //触发网络操作。和triggerWebAction配合使用
    function _slot_setActiveFocusOnPress( arg)// 设置活动焦点按下 不用
    {

    }
    //![!2]


    //![3]
    // void findText(string subString, FindFlags options, variant resultCallback)
    function _slot_findText( subString,  options,  resultCallback) //搜索字符串//不用
    {

    }

    // void findText(string subString, FindFlags options)
    function _slot_findTextV0( subString,  options)//搜索字符串//不用
    {

    }

    // void findText(string subString)
    function _slot_findTextV1(subString)//搜索字符串//不用
    {

    }

    // void grantFeaturePermission(url securityOrigin, Feature feature, bool granted)
    //根据授权，为securityOrigin标识的要使用功能的网站设置或取消设置权限。
    function _slot_grantFeaturePermission( securityOrigin,  feature,  granted) //不用
    {

    }

    // void loadHtml(string html, url baseUrl)
    function _slot_loadHtml( html,  baseUrl)//不用
    {

    }

    // void printToPdf(variant resultCallback, PrintedPageSizeId pageSizeId, PrintedPageOrientation orientation)
    function _slot_printToPdf( resultCallback,  pageSizeId,  orientation)//不用
    {

    }

    // void printToPdf(const string filePath, PrintedPageSizeId pageSizeId, PrintedPageOrientation orientation)
    function _slot_printToPdfV( filePath, pageSizeId,orientation)//不用
    {

    }

    // void replaceMisspelledWord(const QString &replacement)
    function _slot_replaceMisspelledWord(replacement)//替换 //不用
    {

    }

    // void runJavaScript(string script, variant callback)
    function _slot_runJavaScript( script, callback) //脚本运行回调设置 //!测试可以使用
    {

    }


    //![!3]


}

